unit PROS_ITEM_AddItem;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, MyGrids, SortGrid, ClipBrd, Trpcb, MFunStr,
  RpcConf1, ProgBar, Fmcmpnts, Diaccess, Fmcntrls, Menus, SRGrad;

type
  TfrmAddItem = class(TForm)
    edtItem: TEdit;
    grdItemSelect: TSortGrid;
    btnSearch: TBitBtn;
    btnAddToVista: TBitBtn;
    grdSelectedItems: TSortGrid;
    edtVendorNumber: TEdit;
    btnClearSearch: TBitBtn;
    lblSelectFrom: TLabel;
    lblToBeAdded: TLabel;
    grdAllContracts: TSortGrid;
    brkrRPC: TRPCBroker;
    grdContracts: TSortGrid;
    lblAvailableContracts: TLabel;
    edtSelItemNumber: TEdit;
    lstToSend: TListBox;
    btnClearToBeAdded: TBitBtn;
    lblItem: TLabel;
    lblVendor: TLabel;
    btnClose: TBitBtn;
    pnlProgressBar: TPanel;
    cbxSelVendor: TFMComboBoxLookUp;
    dbsGetsSelVendor: TFMGets;
    dbsListerSelVendor: TFMLister;
    mnuAddItem: TMainMenu;
    mnuItemFile: TMenuItem;
    mnuItemExit: TMenuItem;
    mnuItemHelp: TMenuItem;
    mnuItemAbout: TMenuItem;
    btnRemoveItem: TBitBtn;
    pnlMessageBox: TPanel;
    lblMessageBox: TLabel;
    lblNoVendorSelected: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnAddToVistaClick(Sender: TObject);
    procedure grdItemSelectDblClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure grdItemSelectRowSelected(Sender: TObject);
    procedure btnClearSearchClick(Sender: TObject);
    procedure btnClearToBeAddedClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbxSelVendorExit(Sender: TObject);
    procedure GridDeleteRow(RowNumber: Integer; Grid: TSortGrid);
    procedure FormActivate(Sender: TObject);
    procedure mnuItemExitClick(Sender: TObject);
    procedure mnuItemAboutClick(Sender: TObject);
    procedure btnRemoveItemClick(Sender: TObject);
    procedure grdItemSelectDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure grdContractsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure grdSelectedItemsDrawCell(Sender: TObject; ACol,
      ARow: Integer; Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAddItem: TfrmAddItem;
  UserID, strServer, strPort: string;
  ani: TAnimationThread;
  r: TRect;


implementation

uses PROS_ITEM_About;

{$R *.DFM}

procedure TfrmAddItem.GridDeleteRow(RowNumber: Integer; Grid: TSortGrid);
var
  i: Integer;
begin
Grid.Cells[0,RowNumber] := ''; //Clears Item # so item can be added later
if (Grid.RowCount = 2) then ( Grid.RowCount := 1) else
  begin
  Grid.Row := RowNumber;
  if (Grid.Row = Grid.RowCount - 1) then
    { On the last row}
    Grid.RowCount := Grid.RowCount - 1
  else
  begin
    { Not the last row}
    for i := RowNumber to Grid.RowCount - 1 do
      Grid.Rows[i] := Grid.Rows[i + 1];
    Grid.RowCount := Grid.RowCount - 1
  end;
 end;
 if RowNumber >1 then Grid.Row := RowNumber-1; //Position selected row
end;


procedure TfrmAddItem.FormCreate(Sender: TObject);
begin

with grdItemSelect do
 begin
  Cells[0,0] := 'Item #';
  Cells[1,0] := 'HCPC';
  Cells[2,0] := 'Description';
  Cells[3,0] := 'Station';
  Cells[4,0] := 'U of M Code';
  Cells[5,0] := 'U of M Desc';
  Cells[6,0] := 'Restricted';
 end;

 with grdContracts do
 begin
  Cells[0,0] := 'Item #';
  Cells[1,0] := 'Unit $';
  Cells[2,0] := 'Unit';
  Cells[3,0] := 'Contract #';
  Cells[4,0] := 'Type';
 end;

with grdSelectedItems do
 begin
  Cells[0,0] := 'Item #';
  Cells[1,0] := 'HCPC';
  Cells[2,0] := 'Description';
  Cells[3,0] := 'Station';
  Cells[4,0] := 'U of M Code';
  Cells[5,0] := 'U of M Desc';
  Cells[6,0] := 'Restricted';
 end;

end;

procedure TfrmAddItem.btnAddToVistaClick(Sender: TObject);
var
  Mult1: TMult;
  i,j,k : integer;
begin
  if grdSelectedItems.Cells[0,1] <> '' then
  begin
    if MessageDlg('Do you want to send the items'+#10+
                  'in the ''TO BE ADDED'' grid to VistA?',
        mtConfirmation, [mbYes, mbNo], 0) = mrYes then

      begin
      lstToSend.Items.Clear;
        begin  //Filling the List Box
         for i:= 1 to grdSelectedItems.RowCount -1  do
          begin //Needed to loop through both grids in sequence
           begin //Fetch Items from the Selected Item grid
            lstToSend.Items.Add('1^'+
            grdSelectedItems.Cells[0,i]+'^'+
            grdSelectedItems.Cells[1,i]+'^'+
            grdSelectedItems.Cells[2,i]+'^'+
            grdSelectedItems.Cells[3,i]+'^'+
            grdSelectedItems.Cells[4,i]+'^'+
            grdSelectedItems.Cells[5,i]+'^'+
            grdSelectedItems.Cells[6,i]+'^'+
            UserID);
           end; //End Fetching Items

           begin  //Fetch the Contracts from the Contract grid using Item #
            for k := 1 to grdAllContracts.RowCount -1 do
             begin
              if grdAllContracts.Cells[0,k] = grdSelectedItems.Cells[0,i] then
               begin
               lstToSend.Items.Add('2^'+
               grdAllContracts.Cells[0,k]+'^'+
               grdAllContracts.Cells[1,k]+'^'+
               grdAllContracts.Cells[2,k]+'^'+
               grdAllContracts.Cells[3,k]+'^'+
               grdAllContracts.Cells[4,k]+'^'+
               edtVendorNumber.Text+'^'+ UserID);
               end;
          end;
       end; //End Fetching Contracts
     end; //Getting data from both grids
  end; //Filling the List Box
//********************


// Send to VistA
    Mult1 := TMult.Create(frmAddItem);
    Mult1.Assign (lstToSend.Items);

    brkrRPC.RemoteProcedure := 'RMPR CFLS ITEM/CONTRACT UPDATE';
    brkrRPC.Param[1].Mult := Mult1;
    brkrRPC.Param[1].PType := list;
    brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

//*****
  TRY
    brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;
//*****
 btnClearToBeAdded.Click;  //Clears the To Be Added grid after send
  end;
//********************
 end //Confirmation
//********************
 else
  ShowMessage(' Please Select at least One Item to Send');
end;


procedure TfrmAddItem.grdItemSelectDblClick(Sender: TObject);
var
  i,j,k,l : integer;
begin
  l := 0;

with grdSelectedItems do begin
 for k := 1 to RowCount do begin
  if Cells[0,k] = grdItemSelect.Cells[0,grdItemSelect.row] then
   begin
   ShowMessage('Sorry, you have already added that Item');
   l := 1;
   end;
 end;

 begin
  if l = 0 then
  begin

 i := RowCount;
   begin
    if Cells[0,1] = '' then
       RowCount := i
    else
    begin
      inc(i);
      RowCount := i;
    end;
  end;
  j := i -1;
   grdSelectedItems.Cells[0,j] := grdItemSelect.Cells[0,grdItemSelect.row];
   grdSelectedItems.Cells[1,j] := grdItemSelect.Cells[1,grdItemSelect.row];
   grdSelectedItems.Cells[2,j] := grdItemSelect.Cells[2,grdItemSelect.row];
   grdSelectedItems.Cells[3,j] := grdItemSelect.Cells[3,grdItemSelect.row];
   grdSelectedItems.Cells[4,j] := grdItemSelect.Cells[4,grdItemSelect.row];
   grdSelectedItems.Cells[5,j] := grdItemSelect.Cells[5,grdItemSelect.row];
   grdSelectedItems.Cells[6,j] := grdItemSelect.Cells[6,grdItemSelect.row];
   grdSelectedItems.Cells[7,j] := grdItemSelect.Cells[7,grdItemSelect.row];
   end;
  end;
 end;
end;

procedure TfrmAddItem.btnSearchClick(Sender: TObject);
var
 i,j,k,l : integer;

begin
 if edtItem.Text = '' then
 ShowMessage('Please enter an ITEM to search for.') else
 begin
//   grdItemSelect.Clear;

  if cbxSelVendor.Text = '' then
   begin
    grdContracts.Visible := False;
    lblAvailableContracts.Visible := False;
   end
   else
   begin
    grdContracts.Visible := True;
    lblAvailableContracts.Visible := True
   end;

//***************
   for k :=1 to grdItemSelect.RowCount do   //If selected will clear the grid
    grdItemSelect.Rows[k].Text := '';
//***************

   grdItemSelect.Cells[0,1] :='';
   grdItemSelect.RowCount := 2;
//   grdItemSelect.Row := 1;


//***************
   for k :=1 to grdContracts.RowCount do   //Clear the grid
    grdContracts.Rows[k].Text := '';
//***************

    brkrRPC.RemoteProcedure := 'RMPR ITEM Q';
    brkrRPC.Param[1].Value := edtItem.text;
    brkrRPC.Param[1].Ptype := literal;
    brkrRPC.Param[2].Value := edtVendorNumber.text;
    brkrRPC.Param[2].Ptype := literal;
    brkrRPC.RPCTimeLimit := 600; //Set recv timeout


 TRY
  begin
  pnlProgressBar.Visible := true;
  r := pnlProgressBar.clientrect;
  InflateRect( r, - pnlProgressBar.bevelwidth, - pnlProgressBar.bevelwidth );

  //Start progress bar in thread
  ani := TanimationThread.Create( pnlProgressBar, r, pnlProgressBar.color, clWhite, 25 );

  Application.ProcessMessages;
      brkrRPC.Call;//Sleep( 1000 );  {replace with query.Open or such}

  //Stop progress bar
  pnlProgressBar.Visible := False;
  ani.Terminate;
  end;
 Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;
//******


 l := 0; //Grid rows based on items, not the full broker results
 for i:= 0 to frmAddItem.brkrRPC.Results.Count -1 do
  begin //Getting data from the Broker Call

   if Piece(frmAddItem.brkrRPC.Results[i],'^',1) = '1' then //check for null/0/1/2/3
         begin
          grdItemSelect.Cells[0,l+1] := Piece(frmAddItem.brkrRPC.Results[i],'^',2); //Delayed
          grdItemSelect.Cells[1,l+1] := Piece(frmAddItem.brkrRPC.Results[i],'^',3);//Status
          grdItemSelect.Cells[2,l+1] := Piece(frmAddItem.brkrRPC.Results[i],'^',4); //Type
          grdItemSelect.Cells[3,l+1] := Piece(frmAddItem.brkrRPC.Results[i],'^',5);//Station
          grdItemSelect.Cells[4,l+1] := Piece(frmAddItem.brkrRPC.Results[i],'^',6); //Create Date
          grdItemSelect.Cells[5,l+1] := Piece(frmAddItem.brkrRPC.Results[i],'^',7); //1st Action Date
          grdItemSelect.Cells[6,l+1] := Piece(frmAddItem.brkrRPC.Results[i],'^',8); //1st Action Date
          inc(l);
         end;
     end;
 grdItemSelect.RowCount := brkrRPC.Results.Count +1;

 j := 0;
 for i:= 0 to frmAddItem.brkrRPC.Results.Count -1 do
  begin //Getting data from the Broker Call

   if Piece(frmAddItem.brkrRPC.Results[i],'^',1) = '2' then // 1/2
         begin //2 so results have contract
         inc(j);
          grdAllContracts.Cells[0,j] := Piece(frmAddItem.brkrRPC.Results[i],'^',2); //Delayed
          grdAllContracts.Cells[1,j] := Piece(frmAddItem.brkrRPC.Results[i],'^',3);//Status
          grdAllContracts.Cells[2,j] := Piece(frmAddItem.brkrRPC.Results[i],'^',4); //Type
          grdAllContracts.Cells[3,j] := Piece(frmAddItem.brkrRPC.Results[i],'^',5);//Station
          grdAllContracts.Cells[4,j] := Piece(frmAddItem.brkrRPC.Results[i],'^',6); //Create Date
          grdAllContracts.Cells[5,j] := Piece(frmAddItem.brkrRPC.Results[i],'^',7); //1st Action Date
          grdAllContracts.Cells[6,j] := Piece(frmAddItem.brkrRPC.Results[i],'^',8); //0-5
         end;
//       grdAllContracts.RowCount := j + 1;
   end;
//  end; //Vendor warning
// end; //Vendor check
 end; //Item warning
 grdItemSelect.RowSelected [1]:= True;//Select first row and get contracts
end;

procedure TfrmAddItem.grdItemSelectRowSelected(Sender: TObject);
var i,j,k : integer;
//s : string;
begin
 begin
  for k :=1 to 5 do   //If selected will clear the grid
   grdContracts.Rows[k].Text := '';
   grdContracts.Row := 1;
   grdContracts.Cells[0,1] :='';
   grdContracts.RowCount := 5;
 end;

 edtSelItemNumber.Text := grdItemSelect.Cells[0,grdItemSelect.Row];
 j :=1;
  for i := 1 to grdAllContracts.RowCount -1 do
    begin
    if grdAllContracts.Cells[0,i] = edtSelItemNumber.text then
      begin

          grdContracts.Cells[0,j] := grdAllContracts.Cells[0,i];//grdAllContracts.Row];
          grdContracts.Cells[1,j] := grdAllContracts.Cells[1,i];//grdAllContracts.Row];
          grdContracts.Cells[2,j] := grdAllContracts.Cells[4,i];//grdAllContracts.Row];
          grdContracts.Cells[3,j] := grdAllContracts.Cells[3,i];//grdAllContracts.Row];
          grdContracts.Cells[4,j] := grdAllContracts.Cells[2,i];//grdAllContracts.Row];
          inc(j);
      end;
     end;

end;


procedure TfrmAddItem.btnClearSearchClick(Sender: TObject);
var
 i : integer;
begin
 begin
  for i :=1 to 11 do   //If selected will clear the grid
   grdItemSelect.Rows[i].Text := '';
   grdItemSelect.Row := 1;
   grdItemSelect.Cells[0,1] :='';
   grdItemSelect.RowCount := 11;
 end;
 begin
  for i :=1 to 5 do   //If selected will clear the grid
   grdContracts.Rows[i].Text := '';
   grdContracts.Row := 1;
   grdContracts.Cells[0,1] :='';
   grdContracts.RowCount := 5;
 end;
 edtItem.Clear;
 edtVendorNumber.Clear;
 cbxSelVendor.Clear;
end;

procedure TfrmAddItem.btnClearToBeAddedClick(Sender: TObject);
var
i : integer;
begin
  for i :=1 to grdSelectedItems.RowCount  do   //If selected will clear the grid
   grdSelectedItems.Rows[i].Text := '';
   grdSelectedItems.Row := 1;
   grdSelectedItems.Cells[0,1] :='';
   grdSelectedItems.RowCount := 2;
end;

procedure TfrmAddItem.btnCloseClick(Sender: TObject);
begin
Close;
end;

procedure TfrmAddItem.FormClose(Sender: TObject; var Action: TCloseAction);
begin
brkrRPC.Connected := False;
end;

procedure TfrmAddItem.cbxSelVendorExit(Sender: TObject);
begin
edtVendorNumber.Text := '';
edtVendorNumber.Text := Piece(cbxSelVendor.Text,'  ',3);
end;

procedure TfrmAddItem.FormActivate(Sender: TObject);
begin
 if ( brkrRPC.Connected = False) and (GetServerInfo(strServer, strPort)<> mrCancel) then
   begin //getsvrinfo
     brkrRPC.Server := strServer;          //use specified server name/addr
     brkrRPC.ListenerPort := StrToInt(strPort);//use specified port
     brkrRPC.RPCTimeLimit := 600; //Set recv timeout
     brkrRPC.Connected := True;
   end;
   if brkrRPC.Connected = false then frmAddItem.Close else
    begin
     brkrRPC.CreateContext('RMPR COREFLS GUI');
     brkrRPC.RemoteProcedure := 'XWB GET VARIABLE VALUE';
     brkrRPC.Param[0].Value := 'DUZ';
     brkrRPC.Param[0].PType := reference ;

TRY
     brkrRPC.Call;
 Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  frmAddItem.Close;     
  END;
    UserID := brkrRPC.Results[0];  //DUZ of User
 end;

 end;

procedure TfrmAddItem.mnuItemExitClick(Sender: TObject);
begin
Close;
end;

procedure TfrmAddItem.mnuItemAboutClick(Sender: TObject);
begin
dlgAbout.ShowModal;
end;

procedure TfrmAddItem.btnRemoveItemClick(Sender: TObject);
begin
if grdSelectedItems.RowCount > 2 then
GridDeleteRow(grdSelectedItems.Row,grdSelectedItems)
else
frmAddItem.btnClearToBeAdded.Click;
end;

procedure TfrmAddItem.grdItemSelectDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin

 with grdItemSelect do
   begin
   // Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $FFF8BE    //light blue
       else
        Canvas.Brush.Color := $FFFFFF;   //white
    // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
      else
      begin

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;

//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);
  end;    
 end;
end;

procedure TfrmAddItem.grdContractsDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin

 with grdContracts do
   begin
   // Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $D5FFE2    //light green
       else
        Canvas.Brush.Color := $FFFFFF;   //white
    // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
      else
      begin

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;

//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);
  end;    
 end;
end;

procedure TfrmAddItem.grdSelectedItemsDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
with grdSelectedItems do
//   begin
//   if RowCount > 2 then
    begin
   // Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $CFFFFF    //light yellow
       else
        Canvas.Brush.Color := $FFFFFF;   //white
    // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
      else
      begin

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;

//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);
//   end;
  end;
 end;
end;

end.
