{*****************************************************
  PFSS Detail Display - GUI    ver 1.3.96    Jan, 2005
  Office of Information Field Office
  Department of Veterans Affairs
  Hines,Illinois

  Developers: Helen Corkwell, Ken Nelson
  Description: GUI to view and print Prosthetics Billing Information
  Requires: RMPR*3.0*96, RMPR*3.0*149

*******************************************************}

unit Pros_Billing_Menu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ShellAPI, SRGrad, Rpcconf1, ExtCtrls, Trpcb, ProgBar,
  SharedRPCBroker, OleServer, RPCSharedBrokerSessionMgr1_TLB;

type
  TfrmMenu = class(TForm)
    btnVistaSignOn: TBitBtn;
    btnDetailDisplay: TBitBtn;
    btnPurchasing: TBitBtn;
    btnView2319: TBitBtn;
    btnEZ3: TBitBtn;
    btnClose: TBitBtn;
    imgGradiantTop: TSRGradient;
    imgGradiantBottom: TSRGradient;
    lblProsthetics: TLabel;
    imgVALogo: TImage;
    btnInventory: TBitBtn;
    btnDelayedOrderReport: TBitBtn;
    btnHelp: TBitBtn;
    brkrRPC: TRPCBroker;
    btnAbout: TBitBtn;
    btnPFFS: TBitBtn;
    procedure btnDetailDisplayClick(Sender: TObject);
    procedure btnVistaSignOnClick(Sender: TObject);
    procedure btnPurchasingClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnDelayedOrderReportClick(Sender: TObject);
    procedure SignOnVista;
    procedure btnAboutClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnHelpClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnPFFSClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;



var
  frmMenu: TfrmMenu;
  gDebug: Boolean; // CodeCR PROST431

implementation

uses
  PROS_Billing_Menu_About
// Patch RMPR*3*174
// CodeCR PROS434  Replacing original unit with the one updated for IDC-10
//  , PROS_PFFSDetailDisplay_Main // original unit (Prior to Patch 174)
  , PROS_ViewBilling              // unit upadated for ICD-10
  ;

{$R *.DFM}

procedure TfrmMenu.SignOnVista;  //Sign onto the Vista System
var
strServer, strPort: string;
begin
  brkrRPC.Connected := false;  //Forces disconnection
  frmMenu.Caption := '   You are not logged on . . .';
  brkrRPC.Server := '';    //Clears specified server name/addr
  brkrRPC.ListenerPort := 0 ;
//  frmConsult.btnClear.Click;  //Clears DOR grid
//  frmMain.btnClear.Click;     //Clears Detail Display grid

  if ( brkrRPC.Connected = False) and (GetServerInfo(strServer, strPort)<> mrCancel) then
   begin //getsvrinfo
     brkrRPC.Server := strServer;          //use specified server name/addr
     brkrRPC.ListenerPort := StrToInt(strPort);  //use specified port
     brkrRPC.Connected := true;
     frmMenu.Caption := '   You are logged onto '+brkrRPC.Server;
{$IFDEF BILLING}
     if brkrRPC.Connected then
       brkrRPC.CreateContext('RMPR PFFS GUI');
{$ELSE}
{$ENDIF}

   end;
end;   


procedure TfrmMenu.btnVistaSignOnClick(Sender: TObject);
begin
if  brkrRPC.Connected = true then      //Checks if user really wants to
  begin                                  //log off then log on again
  if MessageDlg('You are about to log off of VISTA - Continue?',
     mtConfirmation, [mbYes, mbNo], 0) = mrYes then SignOnVista;
  end
 else SignOnVista;
end;



procedure TfrmMenu.btnDetailDisplayClick(Sender: TObject);
begin

if brkrRPC.Connected = false then
  //begin
   MessageDlg('Please Sign-On to VISTA first.', mtInformation,
   [mbOk], 0)
  else
//   frmMain.ShowModal;
end;

procedure TfrmMenu.btnPurchasingClick(Sender: TObject);
begin
 brkrRPC.Connected := true;
 ShellExecute(frmMenu.Handle, nil,'PROS_POC.EXE',
  nil, nil, SW_SHOWNORMAL);
end;

procedure TfrmMenu.btnCloseClick(Sender: TObject);
begin
Close;
end;

procedure TfrmMenu.btnDelayedOrderReportClick(Sender: TObject);
begin

if brkrRPC.Connected = false then
   MessageDlg('Please Sign-On to VISTA first.', mtInformation,
   [mbOk], 0)
  else
//   frmConsult.ShowModal;


end;

procedure TfrmMenu.btnAboutClick(Sender: TObject);
begin
dlgAbout.ShowModal;
end;

procedure TfrmMenu.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 if MessageDlg('Are you sure you want to EXIT the View Prosthetics Billing Application?', mtConfirmation,
    [mbOk, mbCancel], 0) = mrCancel then
     CanClose := False;

end;

procedure TfrmMenu.btnHelpClick(Sender: TObject);
begin
Application.HelpFile := 'PROS_ViewBillingMenu.HLP'; //Needed here
Application.HelpCommand (Help_Index,0);
end;

procedure TfrmMenu.FormActivate(Sender: TObject);
begin
Application.HelpFile := 'PROS_ViewBillingMenu.HLP'; //Needed here
end;

procedure TfrmMenu.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (Key = VK_F1) then
   begin
    Application.HelpFile := 'PROS_ViewBillingMenu.HLP'; //Needed here
    btnHelp.Click;
   end;
end;

procedure TfrmMenu.btnPFFSClick(Sender: TObject);
begin
{$IFNDEF TEST434} // CodeCR 434 Testing
if brkrRPC.Connected = false then
   MessageDlg('Please Sign-On to VISTA first.', mtInformation,
   [mbOk], 0)
  else
{$ENDIF}  // CodeCR 434 Testing
   frmViewBilling.ShowModal;
end;

procedure TfrmMenu.FormClose(Sender: TObject; var Action: TCloseAction);
begin
brkrRPC.Connected := False;
end;

// CodeCR PROST 431 ---- begin
procedure TfrmMenu.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  for i := 1 to ParamCount do
    begin
      if copy(ParamStr(i),1,6)='/DEBUG' then
        begin
          gDebug := True;
          break;
        end;
    end;
end;
// CodeCR PROST 431 ---- end

end.
