{ **************************************************
Remote Procedure Call Broker      ver. 1.1P14   04/05/00
   OpenVista Development Team
   San Francisco IRM Field Office, Dept. of Veterans Affairs

Contains functions that emulate MUMPS functions.
************************************************** }
unit MFunStr;

interface

uses SysUtils, Dialogs;

{procedure and function prototypes}
function Piece(x: string; del: string; piece: integer) : string;
function Translate(passedString, identifier, associator: string): string;

const
  U: string = '^';

implementation

function Translate(passedString, identifier, associator: string): string;
{TRANSLATE(string,identifier,associator)
Performs a character-for-character replacement within a string.}
var
   index, position: integer;
   newString: string;
   substring: string;

begin
     newString := '';                     {initialize NewString}
     for index := 1 to length(passedString) do begin
         substring := copy(passedString,index,1);
         position := pos(substring,identifier);
         if position > 0 then
           newString := newString + copy(associator,position,1)
         else
           newString := newString + copy(passedString,index,1)
     end;
     result := newString;
end;


function Piece(x: string; del: string; piece: integer) : string;
{PIECE(string,delimiter,piece number)
Returns a field within a string using the specified delimiter.}
var
  delIndex,pieceNumber,startScanIndex,firstCharIndex: integer;
begin
  {initialize variables}
  firstCharIndex := 1;
  startScanIndex := 1;
  pieceNumber := 0;
  {delIndex :=1;}
  repeat
    delIndex := Pos(del,Copy(x+del,startScanIndex,length(x)));
    if delIndex > 0 then begin
      inc(pieceNumber);
      firstCharIndex := startScanIndex;
      startScanIndex := startScanIndex + delIndex + Length(del) - 1;
    end;
  until (pieceNumber = piece) or (delIndex = 0);
  if delIndex > 0 then
    {found the piece that was looking for}
    Result := Copy(x, firstCharIndex, delIndex-1)
  else if (pieceNumber > 0) or (piece > 1) then
    {if there are fewer than requested piece - 1 instances of delimiter
    in string, return null string.}
    Result := ''
  else Result := x;
  {if the substring specified in delimiter does not exist in the string
  and if requested piece is 1, return entire string.}
end;
end.
