library GMV_PatientSelector;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  ShareMem,
  SysUtils,
  Classes,
  Forms,
  Dialogs,
  TRPCB,
  CCOWRPCBroker,
  RpcConf1,
  VERGENCECONTEXTORLib_TLB,
  uGMV_FileEngine in '..\patient_selector\uGMV_FileEngine.pas',
  uGMV_FileEntry in '..\patient_selector\uGMV_FileEntry.pas',
  uGMV_Patient in '..\patient_selector\uGMV_Patient.pas',
  uGMV_ScrollListBox in '..\patient_selector\uGMV_ScrollListBox.pas',
  uWV_RPCExecutor in '..\RPC_Executor\uWV_RPCExecutor.pas',
  uWV_RPCBroker in '..\RPC_Executor\uWV_RPCBroker.pas',
  uWV_RPCEvent in '..\RPC_Executor\uWV_RPCEvent.pas',
  fGMV_PatientSelector in '..\patient_selector\fGMV_PatientSelector.pas' {frmGMV_PatientSelector},
  uWV_Utils in '..\Utils\uWV_Utils.pas',
  uWV_VersionInfo in '..\Service_VersionInfo\uWV_VersionInfo.pas',
  uWV_EventLog in '..\Presenter_Log\uWV_EventLog.pas',
  uWV_BrokerParams in '..\RPC_Executor\uWV_BrokerParams.pas';

{$R *.res}

var
  EX: TWV_RPCExecutor;

function newSelectPatientForm(anExecutor: TWV_RPCExecutor): TForm;export;stdcall;
begin
  try
    getFileEngine(anExecutor);
  except
    ShowMessage('Failed to init file engine');
  end;

  try
    Result := getPatientSelectorForm;
  except
    Result := nil;
  end;
end;

function SelectPatientDFN(aBroker: TCCOWRPCBroker):String; export;stdcall;
var
  sDFN,sName:String;
begin
  Result := '';
  InitGlobalLists;                        // init all data element lists
  EX := TWV_RPCExecutor.Create;           // create an RPC executor
  EX.VAConnection.RPCBroker := aBroker;   // set executor by Broker
  GetFileEngine(EX);                      // create File Engine
  try
    if fGMV_PatientSelector.SelectPatientDFN(sDFN,sName) then
      Result := sDFN;
  except
    Result := '';
  end;
end;

exports
   newSelectPatientForm       name 'GMV_SelectPatientForm',
   SelectPatientDFN           name 'GMV_SelectPatientDFN';

begin
end.
