unit dlgWV_RPCContext;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls
  , uWV_RPCExecutor
  ;

type
  TdlgRPCContext = class(TForm)
    Panel5: TPanel;
    Panel8: TPanel;
    Panel14: TPanel;
    SpeedButton1: TSpeedButton;
    Panel9: TPanel;
    Label2: TLabel;
    edCurrent: TEdit;
    SpeedButton3: TSpeedButton;
    Panel1: TPanel;
    Label1: TLabel;
    edContext: TEdit;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    WV: TWV_RPCExecutor;
  public
    { Public declarations }
  end;

var
  dlgRPCContext: TdlgRPCContext;

procedure updateRPCContext(aWV: TWV_RPCExecutor=nil);

implementation


{$R *.dfm}
procedure updateRPCContext;
begin
  if not Assigned(dlgRPCContext) then
    begin
      Application.CreateForm(TdlgRPCContext,dlgRPCContext);
      dlgRPCContext.WV := aWV;
    end;
  if not Assigned(dlgRPCContext) then
    Exit;

  if not Assigned(dlgRPCContext.WV) then      // check if the Model exists
    Exit;                       // exit if there is no object that can execute RPSs

  dlgRPCContext.edCurrent.Text := dlgRPCContext.WV.VAConnection.ContextName;
  dlgRPCContext.ShowModal;
end;

procedure TdlgRPCContext.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TdlgRPCContext.SpeedButton3Click(Sender: TObject);
begin
  if not Assigned(WV) then      // check if the Model exists
    Exit;                       // exit if there is no object that can execute RPSs
  try
    if not WV.VAConnection.setContext(edContext.Text) then
      begin
        edContext.SelStart := 0;
        edContext.SelLength := Length(edContext.Text);
        MessageDLG('You do not have the <'+edContext.Text + '> '+
          'options'+#13+ 'Please contact IRMS',mtError,[mbOK],0);
      end
    else
      begin
        ShowMessage('Context was updated');
        ModalResult := mrOK;
      end;
  except
    on E: Exception do
      begin
        edContext.SelStart := 0;
        edContext.SelLength := Length(edContext.Text);
        ShowMessage(E.Message);
      end;
  end;
end;

procedure TdlgRPCContext.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    ModalResult := mrCancel;
end;

end.
