unit dlgWV_RPCExec;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls
  , uWV_RPCExecutor
  ;

type
  TdlgRPCExec = class(TForm)
    Panel5: TPanel;
    Panel8: TPanel;
    Label1: TLabel;
    edRPC: TEdit;
    Panel10: TPanel;
    Panel11: TPanel;
    Label3: TLabel;
    mmParams: TMemo;
    Panel14: TPanel;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    Panel9: TPanel;
    Label2: TLabel;
    SpeedButton3: TSpeedButton;
    edContext: TEdit;
    SpeedButton4: TSpeedButton;
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
    WV: TWV_RPCExecutor;
  public
    { Public declarations }
  end;

var
  dlgRPCExec: TdlgRPCExec;

procedure ExecRPC(aWV: TWV_RPCExecutor=nil);

implementation

{$R *.dfm}
procedure ExecRPC;
begin
  if not Assigned(dlgRPCExec) then
    begin
      Application.CreateForm(TdlgRPCExec,dlgRPCExec);
      dlgRPCExec.WV := aWV;
    end;
  if not Assigned(dlgRPCExec) then
    Exit;
  dlgRPCExec.edContext.Text := dlgRPCExec.WV.VAConnection.ContextName;
  dlgRPCExec.ShowModal;
end;

procedure TdlgRPCExec.SpeedButton2Click(Sender: TObject);
var
  SL: TStringList;
begin
  if not Assigned(WV) then      // check if the Model exists
    Exit;                       // exit if there is no object that can execute RPSs
  try
    SL := TStringList.Create;   // create object to keep results of the RPC execution
    WV.RPCExecute(edRPC.Text,mmParams.Lines,SL); // exec rpc
    SL.Free;                    // discard the object after use
    ModalResult := mrOK;
  except
  end;
end;

procedure TdlgRPCExec.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TdlgRPCExec.SpeedButton3Click(Sender: TObject);
begin
  try
    if not WV.VAConnection.setContext(edContext.Text) then
      begin
        edContext.SelStart := 0;
        edContext.SelLength := Length(edContext.Text);
        MessageDLG('You do not have the <'+edContext.Text + '> '+
          'options'+#13+ 'Please contact IRMS',mtError,[mbOK],0);
      end
    else
      begin
        ShowMessage('Context was updated');
        ModalResult := mrOK;
      end;
  except
    on E: Exception do
      begin
        edContext.SelStart := 0;
        edContext.SelLength := Length(edContext.Text);
        ShowMessage(E.Message);
      end;
  end;
end;

procedure TdlgRPCExec.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    ModalResult := mrCancel;
end;

procedure TdlgRPCExec.SpeedButton4Click(Sender: TObject);
begin
  edRPC.Text := 'GMV PARAMETER';
  mmParams.Text := 'GETLST'#13#10+ 'SYS'#13#10+'GMV GUI VERSION'#13#10;
end;

end.
