unit uWV_Utils;
{
================================================================================
*
*       Package:        WV - Women Health
*       Date Created:   01-27-2009
*       Site:           Hines OIFO
*       Developers:     dddddddddomain.user@domain.ext
*
*       Description:    Utils
*                       Copy of uROR_Utils.pas
*                       by Sergey Gavrilov
*
*
================================================================================
}

interface
uses
  Classes,
  SysUtils
  , Forms
  , Controls
  ;

  function Piece(Value, Delimiter: string; StartPiece: Integer = 1; EndPiece: Integer = 0): string;
  function CmdLineSwitch(swlst: array of string): Boolean; overload;
  function CmdLineSwitch(swlst: array of string; var swval: string): Boolean; overload;
  function InString(S: String; SubStrs: array of String; CaseSensitive: Boolean = True): Boolean;

  procedure setFormParented(aForm: TForm; aParent: TWinControl);
  function FormatSSN(aSSN:String):String;
  function TitleCase(Value: string): string;

  function Err(aFMT:String;aParamList:Array of const):String;

implementation

function Piece(Value, Delimiter: string; StartPiece: Integer = 1; EndPiece: Integer = 0): string;
var
  i: Integer;
begin
  if EndPiece > 0 then {Two parameter mode}
    begin
      i := StartPiece;
      while i < EndPiece do
        begin
          Result := Result + Piece(Value, Delimiter, i) + Delimiter;
          inc(i);
        end;
      Result := Result + Piece(Value, Delimiter, EndPiece);
    end
  else if StartPiece < 1 then
    Result := ''
  else if (Pos(Delimiter, Value) < 1) and (StartPiece > 1) then
    Result := ''
  else if Pos(Delimiter, Value) < 1 then
    Result := Value
  else
    begin
      i := 1;
      while i < StartPiece do
        begin
          if Pos(Delimiter, Value) < 1 then
            Value := ''
          else
            Value := Copy(Value, Pos(Delimiter, Value) + 1, Length(Value));
          inc(i);
        end;

      if Value <> '' then
        if Pos(Delimiter, Value) > 0 then
          Value := Copy(Value, 0, Pos(Delimiter, Value) - 1);

      Result := Value;
    end;
end;

function InString(S: string; SubStrs: array of string; CaseSensitive: Boolean = True): Boolean;
var
  i: integer;
begin
  i := 0;
  Result := False;
  while (i <= High(SubStrs)) and (Result = False) do
    begin
      if CaseSensitive then
        begin
          if Pos(SubStrs[i], S) > 0 then
            Result := True
          else
            inc(i)
        end
      else
        begin
          if Pos(LowerCase(SubStrs[i]), LowerCase(S)) > 0 then
            Result := True
          else
            inc(i)
        end;
    end
end;

function CmdLineSwitch(swlst: array of string): Boolean;
var
  swval: string;
begin
  Result := CmdLineSwitch(swlst, swval);
end;

function CmdLineSwitch(swlst: array of string; var swval: string): Boolean;
var
  i: Integer;
begin
  Result := False;
  swval := '';
  for i := 1 to ParamCount do
    begin
      if InString(ParamStr(i), swlst, False) then
        begin
          swval := Piece(ParamStr(i), '=', 2);
          Result := True;
          break;
        end;
    end;
end;

procedure setFormParented(aForm: TForm; aParent: TWinControl);
begin
  if aForm.Parent <> aParent then
    begin
      aForm.BorderStyle := bsNone;
      aForm.Parent := aParent;
      aForm.Align := alClient;
      aForm.Menu := nil;
      aForm.Show;
    end;
end;

function FormatSSN(aSSN:String):String;
var
  s: String;
begin
  try
    s := aSSN;
    While pos(' ',s) = 1 do
      s := copy(s,2,length(s)-1);
    if pos('*S',s)=1 then
      Result := s
    else
      Result := Copy(aSSN,1,3)+'-'+Copy(aSSN,4,2)+'-'+Copy(aSSN,6,99);
  except
    Result := aSSN
  end;
end;

function TitleCase(Value: string): string;
{Returns a string value in Title Case format}
begin
  Result := UpperCase(Copy(Value, 1, 1));
  while Length(Value) > 1 do
    begin
      if
        ((Copy(Value, 1, 1) >= 'A') and (Copy(Value, 1, 1) <= 'Z')) or
        ((Copy(Value, 1, 1) >= 'a') and (Copy(Value, 1, 1) <= 'z')) then
        Result := Result + LowerCase(Copy(Value, 2, 1))
      else
        Result := Result + Copy(Value, 2, 1);
      Value := Copy(Value, 2, Length(Value) - 1);
    end;
end;

function Err(aFMT:String;aParamList:Array of const):String;
begin
  try
    Result := Format(aFmt,aParamList);
  except
    Result := 'Error using format '+#13#10+ aFMT+#13#10;
  end;
end;

end.








