unit fGMV_PatientSelector;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons
  , ActnList, Grids, DBGrids, Math
  , uGMV_ScrollListBox
  , uGMV_Patient
  ;

type
  TgetList = function:TStringList of object;

  TfrmGMV_PatientSelector = class(TForm)
    pcMain: TPageControl;
    tsUnit: TTabSheet;
    tsTeam: TTabSheet;
    tsClinic: TTabSheet;
    tsWard: TTabSheet;
    tsAll: TTabSheet;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    Splitter4: TSplitter;
    tmSearch: TTimer;
    pnlSelection: TPanel;
    pnlPtInfo: TPanel;
    Panel3: TPanel;
    lvUnitPatients: TListView;
    Panel16: TPanel;
    Panel11: TPanel;
    Label14: TLabel;
    Panel6: TPanel;
    Panel17: TPanel;
    cmbUnit: TComboBox;
    lbUnits: TListBox;
    Panel18: TPanel;
    Label15: TLabel;
    Panel1: TPanel;
    lvWardPatients: TListView;
    Panel19: TPanel;
    Label16: TLabel;
    Panel7: TPanel;
    Panel20: TPanel;
    cmbWard: TComboBox;
    lbWards: TListBox;
    Panel21: TPanel;
    Label17: TLabel;
    lvAllPatients: TListView;
    Panel22: TPanel;
    Label18: TLabel;
    Panel9: TPanel;
    cmbAll: TComboBox;
    Panel2: TPanel;
    lvTeampatients: TListView;
    Panel23: TPanel;
    Label19: TLabel;
    Panel8: TPanel;
    Panel24: TPanel;
    cmbTeam: TComboBox;
    lbTeams: TListBox;
    Panel25: TPanel;
    Label20: TLabel;
    Panel4: TPanel;
    lvClinicPatients: TListView;
    Panel26: TPanel;
    Label21: TLabel;
    pnlClinic: TPanel;
    Panel27: TPanel;
    cmbClinic: TComboBox;
    Panel28: TPanel;
    Label22: TLabel;
    Label23: TLabel;
    cmbPeriod: TComboBox;
    pnlClinics: TPanel;
    lbClinics0: TListBox;
    sbClinics: TScrollBar;
    tmrLoad: TTimer;
    lblLoadStatus: TLabel;
    pnlMain: TPanel;
    pnlSelector: TPanel;
    lblSelectedPatientNameID: TLabel;
    lblSelectedPatientLocationNameID: TLabel;
    tsUser: TTabSheet;
    pnlCanvas: TPanel;
    pnlCustom: TPanel;
    lvCustom: TListView;
    cmbHistory: TComboBox;
    Label1: TLabel;
    pnlControls: TPanel;
    Panel5: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    bbtnMyList: TBitBtn;
    ActionList1: TActionList;
    acCustomListAdd: TAction;
    tsHistory: TTabSheet;
    Panel10: TPanel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    lvHistory: TListView;
    pnlToolBarButtons: TPanel;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    sbPatientGroupAll: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton5: TSpeedButton;
    acSelectPatientGroup: TAction;
    procedure tmSearchTimer(Sender: TObject);
    procedure pcMainChange(Sender: TObject);
    procedure cmbUnitChange(Sender: TObject);
    procedure lbUnitsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbUnitsDblClick(Sender: TObject);
    procedure lvUnitPatientsChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure lvUnitPatientsDblClick(Sender: TObject);
    procedure lbUnitsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmbUnitKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmbUnitEnter(Sender: TObject);
    procedure cmbUnitExit(Sender: TObject);
    procedure lbUnitsEnter(Sender: TObject);
    procedure lbUnitsExit(Sender: TObject);
    procedure lvUnitPatientsEnter(Sender: TObject);
    procedure lvUnitPatientsExit(Sender: TObject);
    procedure cmbPeriodEnter(Sender: TObject);
    procedure cmbPeriodExit(Sender: TObject);
    procedure cmbPeriodChange(Sender: TObject);
    procedure cmbAllChange(Sender: TObject);
    procedure lvAllPatientsKeyPress(Sender: TObject; var Key: Char);
    procedure cmbAllKeyPress(Sender: TObject; var Key: Char);
    procedure lvUnitPatientsClick(Sender: TObject);
    procedure cmbClinicKeyPress(Sender: TObject; var Key: Char);
    procedure sbClinicsScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure sbClinicsChange(Sender: TObject);
    procedure lbClinics0KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmbClinicChange(Sender: TObject);
    procedure tmrLoadTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lvAllPatientsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure acCustomListAddExecute(Sender: TObject);
    procedure acSelectPatientGroupExecute(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
    fSelectedPatient: TPatient;

    fFocusedPatientID,
    fFocusedPatientName: String;

    fLocationCaption, // Name of Location record in the list
    fLocationName,
    fLocationID:String;

    fTarget: String;
    fSource: TComboBox;
    fListBox: TListBox;
    fLV: TListView;
    fGetList: TgetList;

    fFound: Integer;
    fIgnore:Boolean;
    iLoadLimit: Integer; //500;

    bLastClinicFound: Boolean;
    sLastClinicFound: String;

    fOnPatientChange: TNotifyEvent;
    fOnMyListChange: TNotifyEvent;

    procedure DefaultOnPatientChange(Sender: TObject);

    function getUnitList:TStringList;
    function getWardList:TStringList;
    function getTeamList:TStringList;
    function getClinicList:TStringList;
    function getAllPatientList:TStringList;

    procedure setTarget(aValue:String);
    function UpdateListView(aSource:TStrings;lvItems:TListItems;
      iCaption,iSSN:Integer; iSubItems: array of Integer;aMode:Integer):Integer;
    procedure ReportFoundItems(aCount:Integer;aMessage:String);

    procedure SetFocusedPatient;
    procedure SetFocusedLocation;
    procedure SetCurrentList;

    function getSelectCount:Integer;

    function UploadClinics(aTarget,aDirection:String;anOption:Word): Integer;
    procedure FindClinics(aTarget:String);
    function LookupClinicInTheList(aTarget:String):Integer;

    procedure UpdateScrollBar;

    function PerformByParent(Msg: Cardinal; WParam, LParam: Longint): Longint;
    procedure setSelectedPatient(aPatient: TPatient);
    procedure addHistoryRecord(aPatient: TPatient);
  public
    lbClinics: TNoVScrollListBox; // zzzzzzandria 2008-04-17
    { Public declarations }

    iMSecondsToStart:Integer; //
    sSecondsToStart:String;   //
    sMyListStatus,
    sStatus:String;

    property SelectedPatient: TPatient read fSelectedPatient write setSelectedPatient;

    property Target:String read fTarget write setTarget;
    property PatientGroup: TListBox read fListBox;
    property PatientList: TListView read fLV;
    property OnPatientChange: TNotifyEvent read fOnPatientChange write fOnPatientChange;
    property OnMyListChange: TNotifyEvent read fOnMyListChange write fOnMyListChange;

    procedure SetUp;

    procedure setInfo;
    procedure clearInfo;
    procedure SilentSearch;
    procedure Search;

    procedure ClearListView(aLV: TListView);

    procedure HideTabs;
    procedure RefreshTab(aTab: Integer);
  end;

var
  frmGMV_PatientSelector: TfrmGMV_PatientSelector;

function newPatientSelectorForm:  TfrmGMV_PatientSelector;
function getPatientSelectorForm:  TfrmGMV_PatientSelector;
function getSelectedPatientList: TStringList;

procedure setPatientSelector(aFrm: TfrmGMV_patientSelector;
  aParent: TWinControl;
  OnPatientChange:TNotifyEvent;
  OnMyListChange:TNotifyEvent;
  startTab:Integer=0);

function SelectPatientDFN(var aDFN: String; var aName:String): Boolean;

const
  ssSelected = 'Selected';
  ssInProgress = 'Selection In Progress';

  CM_PTSEARCHING = WM_APP + 406; //AAN 07/18/02
  CM_PTLISTNOTFOUND = WM_APP + 407; //AAN 07/18/02
  CM_PTSEARCHDONE = WM_APP + 408; //AAN 07/18/02
  CM_PTSEARCHKBMODE = WM_APP + 409; //AAN 07/18/02
  CM_PTSEARCHDELAY = WM_APP + 412; //AAN 06/11/02
  CM_PTSEARCHSTART = WM_APP + 413; //AAN 06/11/02
  CM_PTLISTCHANGED = WM_APP + 414; //AAN 06/11/02
  CM_SELECTPTLIST = WM_APP + 415; //AAN 06/11/02

implementation

uses
  uWV_Utils
  , uGMV_FileEntry
  , uGMV_FileEngine
  ;

{$R *.dfm}

const
  clTabIn  = clWindow;
  clTabOut = clInfoBk;

function getFileEntriesByStringList(aSL: TStringList): TStringList;
var
  i: Integer;
  fe: TGMV_FileEntry;
begin
  Result := nil;
  if Assigned(aSL) then
    begin
      Result := TStringList.Create;
      for i := 1 to aSL.Count - 1 do
      begin
        fe := TGMV_FileEntry.CreateFromRPC(aSL[i]);
        Result.AddObject(fe.Caption, fe);
      end;
      FreeAndNil(aSL);
    end;
end;

function newPatientSelectorForm:  TfrmGMV_PatientSelector;
begin
  try
    InitGlobalLists;
  except
    ShowMessage('Failed to init global lists...');
  end;

  Application.CreateForm(TfrmGMV_patientSelector, Result);
  try
    Result.SetUp;
    Result.HideTabs;
    Result.Align := alNone;
    Result.pnlControls.Visible := True;
//    Result.pnlPtInfo.Visible := True;
//    Result.pnlSelection.Visible := True;
    Result.bbtnMyList.Visible := False;
    Result.pcMain.ActivePageIndex := 0;
    try
      Result.pcMainChange(nil);
    except
    end;
  except
    ShowMessage('Failed to setup patient selector...');
  end;
end;

function getPatientSelectorForm:  TfrmGMV_PatientSelector;
begin
  try
    InitGlobalLists;
  except
    ShowMessage('Failed to init global lists...');
  end;

  if not Assigned(frmGMV_PatientSelector) then
    begin
      Application.CreateForm(TfrmGMV_patientSelector, frmGMV_PatientSelector);
      Result := frmGMV_PatientSelector;
      try
        frmGMV_PatientSelector.SetUp;
      except
        ShowMessage('Failed to setup patient selector...');
      end;
    end;
  Result := frmGMV_PatientSelector;
end;

function SelectPatientDFN(var aDFN: String; var aName:String): Boolean;
var
  F: TfrmGMV_PatientSelector;
begin
  Result := False;
  F := newPatientSelectorForm;
  if F = nil then
    exit
  else if F.ShowModal = mrOK then
    begin
      F.tmSearch.Enabled := False;
      if Assigned(f.SelectedPatient) then
        begin
          aName := F.SelectedPatient.Name;
          aDFN := F.SelectedPatient.DFN;
          Result := True;
        end;
      F.Free;
    end;
end;

function getSelectedPatientList: TStringList;
begin
  Result := nil;
end;

procedure setPatientSelector(aFrm: TfrmGMV_patientSelector;
  aParent: TWinControl;
  OnPatientChange:TNotifyEvent;
  OnMyListChange:TNotifyEvent;
  startTab:Integer=0);
begin
  if not Assigned(aFrm) then
    exit;
  aFrm.HideTabs;
  aFrm.OnPatientChange := OnPatientChange;
  aFrm.OnMyListChange := OnMyListChange;
  aFrm.Show;
  setFormParented(aFrm,aParent);
  aFrm.pcMain.ActivePageIndex := startTab;
  aFrm.pcMainChange(nil);
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure TfrmGMV_PatientSelector.FormCreate(Sender: TObject);
begin
  fIgnore := False;
  fFound := 0;
  pcMain.ActivePageIndex := 0;
  fGetList := getUnitList;
  fSource := cmbUnit;
  fLV := lvUnitPatients;
  fListBox := lbUnits;

//  lblPatientName.Caption := '';

  cmbUnit.Color := clTabIn;
  cmbWard.Color := clTabIn;
  cmbTeam.Color := clTabIn;
  cmbClinic.Color := clTabIn;
  cmbAll.Color := clTabIn;

  lbClinics := TNoVScrollListBox.Create(pnlClinics);
//  lbClinics.Sorted := True;
  lbClinics.Align := alClient;
  lbClinics.Parent := pnlClinics;
  lbClinics.Color := clWindow;
  lbClinics.OnClick := lbUnitsClick;
  lbClinics.OnDblClick := lbUnitsDblClick;
  lbClinics.OnEnter := lbUnitsEnter;
  lbClinics.OnExit := lbUnitsExit;
  lbClinics.OnKeyDown := lbClinics0KeyDown;//lbClinics.OnKeyDown:=lbUnitsKeyDown;

  bLastClinicFound := False;
  sLastClinicFound := '';
end;

procedure TfrmGMV_PatientSelector.FormDestroy(Sender: TObject);
begin
  if Assigned(fSelectedPatient) then
    FreeAndNil(fSelectedPatient);
end;

function TfrmGMV_PatientSelector.PerformByParent(Msg: Cardinal; WParam, LParam: Longint): Longint;
var
  f: TCustomForm;
begin
  Result := 0;
EXIT;
  f := GetParentForm(Self);
  if Assigned(f) then
    begin
      if f.Visible then // zzzzzzandria 2007-07-16
        Result := f.Perform(msg, WParam, LParam)
      else
        Result := -2;
    end
  else
    Result := -1;
end;

procedure TfrmGMV_PatientSelector.Setup;
var
  sl: TStringList;
  sErr: String;

  procedure setLoadLimit;
  var
    sLoadLimit: String;
  begin
    if cmdLineSwitch(['ll','LL','LOADLIMIT','LoadLimit'],sLoadLimit) then
      iLoadLimit := StrToIntDef(sLoadLimit,iLoadLimit);
  end;

  procedure setLB(aLB: TListBox;aSL: TStringList);
  begin
    try
      aLB.Items.Clear;
      aLB.Items.Assign(aSL);
    except
    end;
  end;

begin
  sErr := '';

  if not Assigned(fEng) then
    sErr := 'File engin is missing...'#13#10#13#10;
  try
    if GMVNursingUnits.Entries.Count < 1 then GMVNursingUnits.LoadEntries('211.4');
    SetLB(lbUnits, GMVNursingUnits.Entries);
  except
    sErr := 'Failed to load Nutsing Units'#13#10;
  end;

  try
    if GMVWardLocations.Entries.Count < 1 then   GMVWardLocations.LoadWards;
    SetLB(lbWards, GMVWardLocations.Entries);
  except
    sErr := sErr + 'Failed to load Locations'#13#10;
  end;

  try
    if GMVTeams.Entries.Count < 1 then GMVTeams.LoadEntries('100.21');
    SetLB(lbTeams, GMVTeams.Entries);
  except
    sErr := sErr + 'Failed to load Teams Units'#13#10;
  end;
  try
{$IFDEF LOADLIMITPARAM}
  setLoadLimit;
{$ENDIF}
  if GMVClinics.Entries.Count < 1 then
    begin
      SL := getFileEntriesByStringList(
        FEng.getClinicFileEntriesByName('',intToStr(iLoadLimit),'1')
        );
      if Assigned(SL) then
        begin
          GMVClinics.Entries.Assign(SL);
          SetLB(lbClinics, GMVClinics.Entries);
        end;
      sLastClinicFound := SL[SL.Count-1];
      SL.Free;
    end;
//  tmrLoad.Enabled := true; -- no background load

  if (lbClinics.Items.Count > 0) and (pcMain.ActivePage= tsClinic) then
    begin
      lbClinics.setFocus;
      UpdateScrollBar;
    end;
  except
    sErr := sErr + 'Failed to load Clinics'#13#10;
  end;

  iMSecondsToStart := round(3*1000.0);
  iLoadLimit := 10; // test version
  iLoadLimit := 500; // production version

  if sErr <> '' then
    ShowMessage(sErr);
end;

procedure TfrmGMV_PatientSelector.setSelectedPatient(aPatient:TPatient);
begin
  if Assigned(fSelectedPatient) then
    FreeAndNil(fSelectedPatient);
  fSelectedPatient := aPatient;
  DefaultOnPatientChange(fSelectedPatient);
  if Assigned(fOnPatientChange) then
    fOnPatientChange(fSelectedPatient);

  AddHistoryRecord(fSelectedpatient);
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmGMV_PatientSelector.ReportFoundItems(aCount:Integer;aMessage:String);
begin
  if aCount > 0 then
    PerformByParent(WM_NEXTDLGCTL, 0, 0)
end;

function TfrmGMV_PatientSelector.getUnitList:TStringList;
var
  RetList: TStringList;
begin
  RetList := FEng.getNursingUnitPatients(fLocationID);
  if RetList.Count < 1 then
    fFound := 0
  else
    fFound := UpdateListView(RetList,lvUnitPatients.Items,2,3,[4],0);

  sStatus := Format('%d patients found for nursing unit %s',[fFound,fLocationName]);
  ReportFoundItems(fFound,sStatus);

  Result := Retlist;
end;

function TfrmGMV_PatientSelector.getWardList:TStringList;
var
  RetList: TStringList;
begin
  RetList := FEng.getWardPatients(fLocationName);
  if RetList.Count < 1 then
    fFound := 0
  else
    fFound := UpdateListView(RetList,lvWardPatients.Items,2,3,[4],1);

  sStatus := Format('%d patients found for the ward <%s>',[fFound,fLocationName]);
  ReportFoundItems(fFound,sStatus);

  Result := retList;
end;

function TfrmGMV_PatientSelector.getTeamList:TStringList;
var
  RetList: TStringList;
begin
  RetList := FEng.getTeampatients(fLocationID);

  if RetList.Count < 1 then
    fFound := 0
  else
    if RetList[0] = 'NO PATIENTS' then fFound := 0
    else fFound := UpdateListView(RetList,lvTeamPatients.Items,1,3,[4],2);

  sStatus := Format('%d patients found for the team <%s>',[fFound,fLocationName]);
  ReportFoundItems(fFound,sStatus);

  Result := RetList;
end;

function TfrmGMV_PatientSelector.getClinicList:TStringList;
var
  RetList: TStringList;
  sFailourReason:String;
begin
  if (fLocationName<>'') and (cmbPeriod.Text <> '') then
    begin
      RetList := FEng.getClinicPatients(fLocationCaption,cmbPeriod.Text);

      sFailourReason := '';
      if  (RetList.Count < 1) then
        fFound := 0
      else if pos('No patient',RetList[0]) <> 0 then
        fFound := 0
      else if pos('No clinic',RetList[0]) <> 0 then
        begin
          fFound := 0;
          sFailourReason := 'Check clinic name';
        end
      else if pos('ERROR',Uppercase(RetList[0])) <> 0 then
        begin
          fFound := 0;
          if pos('^',RetList[0]) > 0 then
            sFailourReason := piece(RetList[0],'^',2)
          else
            sFailourReason := RetList[0];
        end
      else
        fFound := UpdateListView(RetList,lvClinicPatients.Items,2,5,[6,4],3);

      sStatus := Format('%d patient apointments found for:'+#13+
        #13+'Clinic: <%s>'+
        #13+'Date:   <%s>'+
        #13+#13+'%s',[fFound,fLocationName,cmbPeriod.Text,sFailourReason]);

      if fFound > 0 then
        begin
          lvClinicPatients.ItemFocused := lvClinicPatients.Items[0];
          PerformByParent(CM_SELECTPTLIST, 0, 0);       // zzzzzzandria 20090324
        end;
      ReportFoundItems(fFound,sStatus);

      Result := RetList;
    end
  else
    Result := nil;
end;

function TfrmGMV_PatientSelector.getAllPatientList:TStringList;
var
  RetList: TStringList;
begin
  RetList := FEng.getPatientList(Target);
  if Piece(RetList[0], '^', 1) = '-1' then
    begin
      fFound := 0;
      PerformByParent(CM_PTLISTNOTFOUND, 0, 0);         // zzzzzzandria 20090324
      MessageDlg(Piece(RetList[0], '^', 2), mtInformation, [mbok], 0);
    end
  else
    begin
      RetList.Delete(0);
      fFound := UpdateListView(RetList,lvAllPatients.Items,2,11,[10],4);
    end;
  Result := RetList;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmGMV_PatientSelector.SilentSearch;
var
  tmpList: TStringList;
begin
  pcMain.Enabled := False; // zzzzzzandria 2008-04-15
  if assigned(fGetList) then
    begin
      ClearListView(fLV);
      tmSearch.Enabled := False;
      tmpList := fGetList;
      tmpList.Free;
      pcMain.Enabled := True; // zzzzzzandria 2008-05-12
      if fFound > 0 then
        begin
          fLV.TabStop := true;
          fLV.Enabled := true;
          Application.ProcessMessages;
          try
            fLV.Selected := fLV.Items[0];
            if self.Visible then // zzzzzzandria 2007-07-16
              fLV.SetFocus;
          except
          end;
        end
      else
        begin
          try
            fListBox.SetFocus;
          except
          end;
          // add code to focus on the target input line
          fLV.TabStop := False;
          fLV.Enabled := False;
        end;
    end;
  pcMain.Enabled := True; // zzzzzzandria 2008-04-15

  if not self.Visible then
    exit; // zzzzzzandria 2008-11-03

  if pcMain.ActivePage = tsClinic then
    try
      if fFound = 0 then
        cmbPeriod.SetFocus;
    except
    end;
end;

procedure TfrmGMV_PatientSelector.Search;
begin
  PerformByParent(CM_PTSEARCHING, 0, 0); //AAN 07/22/02
  SilentSearch;
  PerformByParent(CM_PTSEARCHDONE, 0, 0); //AAN 07/18/02
end;

procedure TfrmGMV_PatientSelector.tmSearchTimer(Sender: TObject);
begin
  if iMSecondsToStart >= 500 then
    begin
      iMSecondsToStart := iMSecondsToStart - 500;
      sSecondsToStart := Format('%3.1n',[iMSecondsToStart/1000.0]);
      PerformByParent(CM_PTSEARCHDelay, 0, 0); //AAN 07/22/02
    end
  else
    begin
      tmSearch.Enabled := False;
      if pcMain.ActivePage = tsAll then
        Search
      else
        if pcMain.ActivePage = tsClinic then
          FindClinics(cmbClinic.Text);
    end;
end;

procedure TfrmGMV_PatientSelector.clearInfo;
begin
//  lblPatientName.Caption := '...';
//  lblLocationName.Caption := '...';
//  lblSelectedPatientNameID.Caption := '';
//  lblSelectedPatientLocationNameID.Caption := '';
end;

procedure TfrmGMV_PatientSelector.setInfo;
begin
  if not assigned(SelectedPatient) then
    ClearInfo
  else
    try
//      lblSelectedPatientNameID.Caption := SelectedPatient.Name + ' /' + SelectedPatient.DFN;
//      lblSelectedPatientLocationNameID.Caption := SelectedPatient.LocationName + ' /' + SelectedPatient.LocationID;
//      lblLocationName.Caption := fLocationName + ' / ' + fLocationID;
//      lblPatientName.Caption := SelectedPatient.Name + ' / '+ SelectedPatient.DFN;
    except
      ClearInfo;
    end;
end;

procedure TfrmGMV_PatientSelector.SetCurrentList;
//var
//  i: Integer;
begin
(*
  mmList.Lines.Clear;
  for i := 0 to fLV.Items.Count - 1 do
    if (fLV.Items[i].Selected)
      and Assigned(fLV.Items[i].Data) // zzzzzzandria 2007-07-17
    then
      mmList.Lines.Add(fLV.Items[i].Caption+' / '+TGMV_FileEntry(fLV.Items[i].Data).IEN);
  PerformByParent(CM_PTLISTCHANGED, 0, 0); // zzzzzzandria 050518
*)  
end;

procedure TfrmGMV_PatientSelector.pcMainChange(Sender: TObject);
const
  iUnit = 0;
  iWard = 1;
  iTeam = 2;
  iClinic = 3;
  iAll = 4;

begin
  tmSearch.Enabled := False;
  clearInfo;
  if pcMain.ActivePage = tsUnit then
    begin
      fSource := cmbUnit;
      fLV := lvUnitPatients;
      fListBox := lbUnits;
      fGetList := getUnitList;//      bUseLocationID := False;
    end
  else if pcMain.ActivePage = tsWard then
    begin
      fSource := cmbWard;
      fLV := lvWardPatients;
      fListBox := lbWards;
      fGetList := getWardList;//      bUseLocationID := True;
    end
  else if pcMain.ActivePage = tsTeam then
    begin
      fSource := cmbTeam;
      fLV := lvTeampatients;
      fListBox := lbTeams;
      fGetList := getTeamList;//      bUseLocationID := False;
    end
  else if pcMain.ActivePage = tsClinic then
    begin
      fSource := cmbClinic;
      fLV := lvClinicPatients;
      fListBox := lbClinics;
      fGetList := getClinicList;//    bUseLocationID := True;
    end
  else if pcMain.ActivePage = tsAll then
    begin
      fSource := cmbAll;
      fLV := lvAllPatients;
      fListBox := nil;
      fGetList := getAllPatientList;//      bUseLocationID := False;
    end
  else if pcMain.ActivePage = tsUser then
    begin
      fSource := nil;
      fLV := lvCustom;
      fListBox := nil;
      fGetList := nil;//      bUseLocationID := False;
    end
  else
    Exit;

  Target := fSource.Text;

//    if assigned(fSource) and (fSource.Visible) and (fSource.Enabled)then
//      fSource.SetFocus;

  SetFocusedLocation;
  SetFocusedPatient;
  SetCurrentList;// list of selected patients, sends message to parent form
  SetInfo;
end;

procedure TfrmGMV_PatientSelector.setTarget(aValue:String);
begin
  tmSearch.Enabled := False;
  fTarget := aValue;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmGMV_PatientSelector.cmbUnitChange(Sender: TObject);
var
  i: integer;
  Found: Boolean;
  LookFor: string;
begin
  if fIgnore then Exit;

  if fListBox <> nil then
    begin
      Found := False;
      ClearListView(fLV);
      Target := fSource.Text; // get search target
      if Target <> '' then
        begin
          i := 0;
          LookFor := LowerCase(Target);
          while (i < fListBox.Items.Count) and (not Found) do
            begin
              if LowerCase(Copy(fListBox.Items[i], 1, Length(LookFor))) = LookFor then
                begin
                  fListBox.ItemIndex := i;
                  fSource.Text := fListBox.Items[i];
                  fSource.SelStart := Length(LookFor);
                  fSource.SelLength := Length(fSource.Text);
                  Found := True;
                end
              else
                inc(i);
            end;
        end;
      if not Found then  fListBox.ItemIndex := -1;
    end;

  SetInfo;
end;

procedure TfrmGMV_PatientSelector.cmbPeriodChange(Sender: TObject);
begin
  if fIgnore Then Exit;
  if (fSource.Text <> '') and (cmbPeriod.Text<>'') then
    lbUnitsDblClick(nil);
end;

procedure TfrmGMV_PatientSelector.cmbAllChange(Sender: TObject);
var
  s: String;
begin
  if fIgnore then s := 'True'
  else s := 'False';
  if fIgnore Then Exit;

  ClearListView(fLV);
  Target := fSource.Text; // get search target
  tmSearch.Enabled := fSource.Text <> ''; // start countdouwn
  PerformByParent(CM_PTSEARCHKBMODE, 0, 0); //AAN 07/18/02
  SetInfo;
end;

function TfrmGMV_PatientSelector.UpdateListView(aSource:TStrings;lvItems:TListItems;
  iCaption,iSSN:Integer; iSubItems: array of Integer;aMode:Integer):Integer;
var
  s:String;
  ii,jj,
  iFound: Integer;
const
  Delim = '^';

  procedure setNameWidth(aName:String);
  var
    lv: TListView;
    j: Integer;
  begin
    if lvItems.Owner is TListView then
      begin
        lv := TListView(lvItems.Owner);
        for j := 0 to lv.Columns.Count - 1 do
          begin
            if lv.Column[j].Caption <> 'Name' then
              continue;
            if lv.Columns[j].Width < lv.Canvas.TextWidth(aName)+8 then
              lv.Columns[j].Width := lv.Canvas.TextWidth(aName)+8;
          end;
      end;
  end;

begin
  iFound := 0;
  lvItems.BeginUpdate;
  for jj := 0 to aSource.Count - 1 do
    begin
      s := aSource[jj];
      if pos('-1',s)= 1 then Continue;
      with lvItems.Add do
        begin
          Caption := Piece(s,Delim,iCaption);
          setNameWidth(Caption);
          SubItems.Add(FormatSSN(Piece(s, Delim, iSSN)));
          for ii := Low(iSubItems) to High(iSubItems) do
            SubItems.Add(Piece(s, Delim, iSubItems[ii]));
          case aMode of
            0: Data := TGMV_FileEntry.CreateFromRPC('2;' + s);// Nursing Unit
            1: Data := TGMV_FileEntry.CreateFromRPC('2;' + s);// PtWard
            2: Data := TGMV_FileEntry.CreateFromRPC('2;' + Piece(s, '^', 2) + '^' + Piece(s, '^', 1)); // Team
            3: Data := TGMV_FileEntry.CreateFromRPC('2;' + s);// Clinic
            4: Data := TGMV_FileEntry.CreateFromRPC(s);// Patients
          end;
          inc(iFound);
        end;
    end;
  lvItems.EndUpdate;
  Result := iFound;
end;

procedure TfrmGMV_PatientSelector.ClearListView(aLV: TListView);
var
  i: integer;
begin
  aLV.Items.BeginUpdate;
  for i := 0 to aLV.Items.Count - 1 do
    if aLV.Items[i].Data <> nil then
      begin
        TGMV_FileEntry(aLV.Items[i].Data).Free;
        aLV.Items[i].Data := nil;
      end;
  aLV.Items.Clear;
  aLV.Items.EndUpdate;

  SetFocusedPatient;
  PerformByParent(CM_PTLISTCHANGED, 0, 0);
end;

procedure TfrmGMV_PatientSelector.lbUnitsClick(Sender: TObject);
begin
  try
    fSource.Text := fListBox.Items[fListBox.ItemIndex];

    if Sender <> lbClinics then // 2008-06-20
      begin
        if (fSource.Text <>'') and (pos(fSource.Text+#13,fSource.Items.Text)=0) then
          fSource.Items.Insert(0,fSource.Text);
        if fSource.Items.Count > 3 then
          fSource.Items.Delete(3);
      end;

    SetFocusedLocation;
    ClearListView(fLV);
    setInfo;
  except
  end;
end;

procedure TfrmGMV_PatientSelector.lbUnitsDblClick(Sender: TObject);
begin
  PerformByParent(CM_PTSEARCHSTART, 0, 0); //AAN 07/18/02
  tmSearch.Enabled := False;
  SilentSearch;
end;

procedure TfrmGMV_PatientSelector.lvUnitPatientsDblClick(Sender: TObject);
begin
  if fEng.RPCE.VAConnection.RPCBroker = nil then
    begin
      ShowMessage('You need restore connection to VistA');
      Exit;
    end;

  if fLV.Selected <> nil then
    begin
      if pcMain.ActivePage = tsHistory then
//        SelectedPatient := TPatient(lvHistory.Selected.Data)
        Exit
      else
        begin
//          SelectedPatient := SelectPatientByDFN(TGMV_FileEntry(fLV.Selected.Data).IEN)
          SelectedPatient := TPatient.CreatePatientByDFN(TGMV_FileEntry(fLV.Selected.Data).IEN);
        end;
    end
  else
    begin
    end;
  SetInfo;
end;

procedure TfrmGMV_PatientSelector.lbUnitsKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_RETURN: if (fListBox.ItemIndex > - 1) then lbUnitsDblClick(Sender);
  end;
end;

procedure TfrmGMV_PatientSelector.cmbUnitKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  with fSource do
    case Key of
     VK_RETURN:
      if (fListBox.ItemIndex > -1) then
        begin
          Key := 0;
          lbUnitsClick(nil);
          lbUnitsDblClick(Sender);
        end;
     VK_Back:
        if (SelLength > 0) then
          begin
            fIgnore := True;
            Text := Copy(Text, 1, SelStart - 1);
            Key := 0;
            fIgnore := False;
          end;
    end;
end;

procedure TfrmGMV_PatientSelector.cmbUnitEnter(Sender: TObject);
begin
  if Assigned(fSource) then
    fSource.Color := clTabIn;
end;

procedure TfrmGMV_PatientSelector.cmbUnitExit(Sender: TObject);
begin
  if Assigned(fSource) then
    fSource.Color := clTabOut;
end;

procedure TfrmGMV_PatientSelector.lbUnitsEnter(Sender: TObject);
begin
  fListBox.Color := clTabIn;
  fListBox.Invalidate;
  Application.ProcessMessages;
end;

procedure TfrmGMV_PatientSelector.lbUnitsExit(Sender: TObject);
begin
  fListBox.Color := clTabOut;
  fListBox.Invalidate;
  Application.ProcessMessages;
end;

procedure TfrmGMV_PatientSelector.lvUnitPatientsEnter(Sender: TObject);
begin
  fLV.Color := clTabIn;
  fLV.TabStop := fLV.Items.Count>0;
end;

procedure TfrmGMV_PatientSelector.lvUnitPatientsExit(Sender: TObject);
begin
  fLV.Color := clTabOut;
end;

procedure TfrmGMV_PatientSelector.cmbPeriodEnter(Sender: TObject);
begin
  cmbPeriod.Color := clTabIn;
end;

procedure TfrmGMV_PatientSelector.cmbPeriodExit(Sender: TObject);
begin
  cmbPeriod.Color := clTabOut;
end;

procedure TfrmGMV_PatientSelector.lvAllPatientsKeyPress(Sender: TObject;
  var Key: Char);
begin
Exit;
  case Key of
    char(VK_RETURN):
      if fLV.SelCount = 1 then lvUnitPatientsDblClick(Sender);
  end;
end;

procedure TfrmGMV_PatientSelector.cmbAllKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = char(VK_RETURN)
    then Search;
end;

procedure TfrmGMV_PatientSelector.SetFocusedPatient;
begin
  if (fLV.Selected <> nil)
    and Assigned(fLV.Selected.Data) // zzzzzzandria 2007-07-17
  then
    begin
      try
        fFocusedPatientID := TGMV_FileEntry(fLV.Selected.Data).IEN;
        fFocusedPatientName := fLV.Selected.Caption;
      except
        fFocusedPatientID := '';
        fFocusedPatientName := '';
      end;
    end
  else
    begin
      fFocusedPatientID := '';
      fFocusedPatientName := '';
    end;
end;

procedure TfrmGMV_PatientSelector.lvUnitPatientsChange(Sender: TObject;
  Item: TListItem; Change: TItemChange);
begin
  SetFocusedPatient;
  setInfo;
  PerformByParent(CM_PTLISTCHANGED, fLV.Items.Count, 0);
end;

procedure TfrmGMV_PatientSelector.SetFocusedLocation;
begin
  fLocationID := '';
  fLocationCaption := '';
  fLocationName := '';

  if Assigned(fListBox) and (fListBox.ItemIndex>-1)
    and Assigned(fListBox.Items.Objects[fListBox.ItemIndex]) then
    try
      fLocationID := TGMV_FileEntry(fListBox.Items.Objects[fListBox.ItemIndex]).IEN;
      fLocationCaption := TGMV_FileEntry(fListBox.Items.Objects[fListBox.ItemIndex]).Caption;
      fLocationName := fListBox.Items[fListBox.ItemIndex];
    except
      fLocationID := '';
      fLocationCaption := '';
      fLocationName := '';
    end;
end;

procedure TfrmGMV_PatientSelector.lvUnitPatientsClick(Sender: TObject);
begin
  SetCurrentList;
  SetInfo;
end;

function TfrmGMV_PatientSelector.getSelectCount:Integer;
begin
  Result := fLV.SelCount;
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure TfrmGMV_PatientSelector.sbClinicsScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  case ScrollCode of
    scLineUp:   SendMessage(lbClinics.Handle, WM_KEYDOWN, VK_UP, 1);
    scLineDown: SendMessage(lbClinics.Handle, WM_KEYDOWN, VK_DOWN, 1);
  end;
end;

procedure TfrmGMV_PatientSelector.UpdateScrollBar;
begin
  sbClinics.Min := 0;
  if GMVClinics.Entries.Count > 0 then
    sbClinics.Max := GMVClinics.Entries.Count - 1
  else
    sbClinics.Max := 0;
  sbClinics.enabled := sbClinics.Max > 0;
end;

procedure TfrmGMV_PatientSelector.sbClinicsChange(Sender: TObject);
begin
  if not lbClinics.Focused then
    lbClinics.SetFocus;
  lbClinics.ItemIndex := sbClinics.Position;
end;

function TfrmGMV_PatientSelector.LookupClinicInTheList(aTarget:String):integer;
var
  i: integer;
  LookFor: string;
begin
  Result := -1;
  if fListBox <> nil then
    begin
      ClearListView(fLV);
      if aTarget <> '' then
        begin
          i := 0;
          LookFor := LowerCase(aTarget);
          while (i < fListBox.Items.Count) do
            begin
              if LowerCase(Copy(fListBox.Items[i], 1, Length(LookFor))) = LookFor then
                begin
                  Result := i;
                  break;
                end
              else
                inc(i);
            end;
        end;
    end;
end;

procedure TfrmGMV_PatientSelector.cmbClinicChange(Sender: TObject);
var
  i: integer;
  iLen: Integer;
begin
  if fIgnore then Exit;
  iLen := Length(fSource.Text);
  i := LookupClinicInTheList(fSource.Text);
  if i >=0 then
    begin
      fListBox.ItemIndex := i;
      fSource.Text := fListBox.Items[i];
      fSource.SelStart := iLen;
      fSource.SelLength := iLen;
    end
  else
    fListBox.ItemIndex := -1;
  SetInfo;
end;

function TfrmGMV_PatientSelector.UploadClinics(aTarget,aDirection:String;anOption:Word): Integer;
var
  s, sSelected,
  sTarget,
  sCount: String;
  iSelected,
  iSL, iIndex: Integer;
  fe: TGMV_FileEntry;
  SL: TStringList;
begin
  Result := 0;
  sCount := IntToStr(iLoadLimit);
  sTarget := aTarget;
  iSelected := fListBox.ItemIndex;
  if iSelected < 0 then iSelected := 0;
  sSelected := fListBox.Items[iSelected];
  SL := getFileEntriesByStringList(
    FEng.getClinicFileEntriesByName(aTarget,sCount,aDirection)
    );

  if Assigned(SL) then
    begin
      Result := SL.Count;
      for iSL := 0 to SL.Count - 1 do
        begin
          s := SL[iSL];
          iIndex := GMVClinics.Entries.IndexOf(s);
          fe := TGMV_FileEntry(SL.Objects[iSL]);
          if iIndex >= 0 then
            try
              if Assigned(fe) then fe.Free;
            except
            end
          else
            begin
              if aDirection = '1' then
                begin
                  GMVClinics.Entries.AddObject(SL[iSL],fe);
                  fListBox.Items.Add(SL[iSL]);    // zzzzzzandria 2008-04-15
                end
              else
                begin
                  GMVClinics.Entries.InsertObject(0,SL[iSL],fe);
                  fListBox.Items.Insert(0,SL[iSL]); // zzzzzzandria 2008-04-15
                end;
            end;
        end;
      SL.Free;
    end;
    UpdateScrollBar;
end;

// zzzzzzandria 2008-04-11 =============================================== begin
procedure TfrmGMV_PatientSelector.FindClinics(aTarget:String);
var
  iPos: Integer;
  iCount: Integer;
  iLen: Integer;

  procedure ClearClinics;
  var
    i: Integer;
    fe: TGMV_FileEntry;
  begin
    for i := 0 to GMVClinics.Entries.Count - 1 do
      begin
        fe := TGMV_FileEntry(GMVClinics.Entries.Objects[i]);
        if Assigned(fe) then
          fe.Free;
      end;
    GMVClinics.Entries.Clear;
  end;

  procedure setPos(aPos,aLen:Integer);
  begin
    fListBox.ItemIndex := aPos;
    fSource.Text := fListBox.Items[aPos];
    fSource.SelStart := aLen;
    fSource.SelLength := Length(fSource.Text);
  end;

begin
  iLen := Length(aTarget);
  iPos := LookupClinicInTheList(aTarget);
  if iPos >= 0 then
    setPos(iPos,iLen)
  else
    begin
      ClearClinics;                            // Clean up GMVClinics list
      iCount := UploadClinics(aTarget,'1',0);  // Reload Clinics based on target
      if iCount > 0 then
        begin
          try
            lbClinics.Items.Clear;
            lbClinics.Items.Assign(GMVClinics.Entries);
            lbClinics.setFocus;
          except
          end;
          bLastClinicFound := iCount < iLoadLimit;
          // added zzzzzzandria 20080701 11:45
          iPos := LookupClinicInTheList(aTarget);
          if iPos >= 0 then
            setPos(iPos,iLen);
        end
      else
        MessageDLG('No records found'+#13#10+'Search target: "'+
          aTarget+ '"', mtWarning,[mbOK],0);
      UpdateScrollBar;
    end;
end;

procedure TfrmGMV_PatientSelector.cmbClinicKeyPress(Sender: TObject;
  var Key: Char);
var
  s: String;
begin
  if Key = char(VK_RETURN) then
    begin
      if tmSearch.enabled then
        begin // stop timer and cleanup indicator
          tmSearch.Enabled :=false;
          PerformByParent(CM_PTSEARCHDONE, 0, 0);
        end;

      s := cmbClinic.Text;
      if cmbClinic.SelLength > 0 then
        s := copy(s,1,cmbClinic.SelStart - 1);

      FindClinics(s);
    end;
end;
// zzzzzzandria 2008-04-11 ================================================= end

procedure TfrmGMV_PatientSelector.lbClinics0KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var
  iTop,iBottom, iSize, iTopPos,
  i: Integer;

  function LoadMoreDown(bKB:Boolean=True): Integer;
  begin
    iBottom := fListBox.Items.Count - 1;
    i := UploadClinics(fListBox.Items[iBottom],'1',Key);
    fListBox.Items.Assign(GMVClinics.Entries); // zzzzzzandria 20080609
    Result := i;
    if bKB then // k/b request
      begin
        if i > 0 then
          fListBox.ItemIndex := iTop;
      end
    else
      if i > 0 then
        fListBox.ItemIndex := min(iBottom+iSize,fListBox.Items.Count - 1)
      else
        fListBox.ItemIndex := iBottom;
  end;

  procedure LoadMoreUp;
  begin
    i := UploadClinics(fListBox.Items[iTopPos],'-1',Key);
    fListBox.Items.Assign(GMVClinics.Entries); // zzzzzzandria 20080609
    if i > 0 then
      fListBox.ItemIndex := i - 1
    else
      fListBox.ItemIndex := 0;
  end;

begin
  if Key = VK_RETURN then
    cmbPeriod.SetFocus
  else
    begin
      iTop := fListBox.ItemIndex;
      iTopPos := fListBox.TopIndex;
      iSize := (fListBox.Height div fListBox.ItemHeight) - 1;
      iBottom := iTop + iSize;
      case Key of
        SB_TOP:
            if iTopPos = 0 then
              LoadMoreUp;
        SB_BOTTOM:
            if not bLastClinicFound then
              LoadMoreDown(False)
            else
              fListBox.ItemIndex :=
                min(iTopPos+iSize,fListBox.Items.Count - 1);
        VK_DOWN, VK_Next {VK_end,}:
            if not bLastClinicFound and (fListBox.ItemIndex = fListBox.Items.Count - 1) then
                LoadMoreDown(True);
        VK_Up, VK_Prior:
            if not bLastClinicFound and (fListBox.ItemIndex = 0) then
              LoadMoreUp;
      end;
    end;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmGMV_PatientSelector.tmrLoadTimer(Sender: TObject);
var
  fe: TGMV_FileEntry;
  iSL: Integer;
  iIndex: Integer;
  s: String;
  aTarget: String;
  SL: TStringList;
  bClinic: Boolean;
begin
  tmrLoad.Enabled := False;
  aTarget := sLastClinicFound;

  if pcMain.ActivePage = tsClinic then
    begin
      bClinic := pnlClinic.Enabled;
      tsClinic.Enabled := False;
      lblLoadStatus.Caption := 'Loading <'+aTarget+'>';
      lblLoadStatus.Visible := True;
      Application.ProcessMessages;
    end;

  SL := getFileEntriesByStringList(
    FEng.getClinicFileEntriesByName(aTarget,IntToStr(iLoadLimit),'1')
    );
  if Assigned(SL) then
    begin
      for iSL := 0 to SL.Count - 1 do
        begin
          s := SL[iSL];
          iIndex := GMVClinics.Entries.IndexOf(s);
          if iIndex < 0 then
            begin
              fe := TGMV_FileEntry(SL.Objects[iSL]);
              GMVClinics.Entries.AddObject(SL[iSL],fe);
            end;
        end;
      bLastClinicFound := SL.Count < iLoadLimit;
      sLastClinicFound := s;
      SL.Free;
    end;

  for iSL := 0 to GMVClinics.Entries.Count - 1 do
    begin
      iIndex := lbClinics.Items.IndexOf(GMVClinics.Entries[iSL]);
      if iIndex < 0 then
        lbClinics.Items.Add(GMVClinics.Entries[iSL]);
    end;

  if pcMain.ActivePage = tsClinic then
    begin
      tsClinic.Enabled := bLastClinicFound;
      pnlClinic.Enabled := bClinic;
    end;

  if bLastClinicFound then
    lblLoadStatus.Visible := false;

  tmrLoad.Enabled := not bLastClinicFound;
end;

procedure TfrmGMV_PatientSelector.DefaultOnPatientChange(Sender: TObject);
begin
  if (SelectedPatient = nil) and Assigned(fLV) then
    fLV.Selected := nil;
end;

procedure TfrmGMV_PatientSelector.HideTabs;
  var iPage: Integer;
begin
  for iPage := 0 to pcMain.PageCount - 1 do
    pcMain.Pages[iPage].TabVisible := False;
  pcMain.Style := tsButtons;
end;

procedure TfrmGMV_PatientSelector.RefreshTab(aTab: Integer);
begin
  pcMain.ActivePageIndex := aTab;
  pcMainChange(nil);
end;

procedure TfrmGMV_PatientSelector.lvAllPatientsKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);

  procedure AddSelection;
  var
    iCount,
    ii: integer;
    feTarget,
    feSource: TGMV_FileEntry;
    li: TListItem;

    function FindCustomItem(anItem: TListItem):TListItem;
    var
      i: Integer;
    begin
      Result := nil;
      lvCustom.Items.BeginUpdate;
      for i := 0 to lvCustom.Items.Count - 1 do
        begin
          if (anItem.Caption = lvCustom.Items[i].Caption) and
            (anItem.SubItems[0] = lvCustom.Items[i].SubItems[0]) and
            (anItem.SubItems[1] = lvCustom.Items[i].SubItems[1]) then
            begin
              Result := lvCustom.Items[i];
              Break;
            end;
        end;
      lvCustom.Items.EndUpdate;
    end;

  begin
    iCount := 0;
    for ii := fLV.Selected.Index to fLV.Items.Count - 1 do
      begin
        if not fLV.Items[ii].Selected then
          Continue;

        li := FindCustomItem(fLV.Items[ii]);
        if Assigned(li) then
          Continue;
        li := lvCustom.Items.Add;
        inc(iCount);
        feSource := fLV.Items[ii].Data;
        feTarget := CloneFileEntry(feSource);
        li.Data := feTarget;
        li.Caption := fLV.Items[ii].Caption;
        li.SubItems.Add(fLV.Items[ii].SubItems[0]);
        li.SubItems.Add(fLV.Items[ii].SubItems[1]);
      end;
    sMyListStatus := Format('%d items added to the Custom List',[iCount]);
    if Assigned(onMyListChange) then
      OnMyListChange(self);
  end;

  procedure DeleteSelection;
  var
    iCount,
    i: integer;
    fe: TGMV_FileEntry;
  begin
    iCount := 0;
    i := lvCustom.Selected.Index;
    if i <0 then
      Exit;
    lvCustom.Items.BeginUpdate;
    while i <= lvCustom.Items.Count - 1 do
      begin
        if lvCustom.Items[i].Selected then
          begin
            fe := TGMV_FileEntry(lvCustom.Items[i].Data);
            FreeAndNil(fe);
            lvCustom.Items.Delete(i);
            inc(iCount);
          end
        else
          inc(i);
      end;
    lvCustom.Items.EndUpdate;
    sMyListStatus := Format('%d items removed from the Custom List',[iCount]);
    if Assigned(onMyListChange) then
      OnMyListChange(self);
  end;

begin
  case Key of
    VK_RETURN:
      begin
        if ssCtrl in Shift then
          AddSelection
        else
          if fLV.SelCount = 1 then lvUnitPatientsDblClick(Sender);
      end;
    VK_DELETE:
      begin
        if pcMain.ActivePage <> tsUser then
          exit;
        DeleteSelection;
      end;
  end;
end;

procedure TfrmGMV_PatientSelector.acCustomListAddExecute(Sender: TObject);
begin
//
end;

procedure TfrmGMV_PatientSelector.addHistoryRecord(aPatient: TPatient);
var
  li: TListItem;
begin
  if not Assigned(aPatient) then
    Exit;
  li := lvHistory.Items.Add;
  li.Caption := aPatient.Name;
  li.SubItems.Add(aPatient.SSN);
  li.SubItems.Add(aPatient.DOB);
  li.SubItems.Add(FormatDateTime('dd/mm/yyyy hh:nn:ss',Now));
//  li.Data := aPatient;
end;

procedure TfrmGMV_PatientSelector.acSelectPatientGroupExecute(
  Sender: TObject);
begin
  RefreshTab(TSpeedButton(Sender).Tag);
  TSpeedButton(Sender).Down := True;
end;

procedure TfrmGMV_PatientSelector.BitBtn1Click(Sender: TObject);
begin
  lvUnitPatientsDblClick(nil);
  ModalResult := mrOK;
end;

end.
