unit uPROS_InventoryTransactionEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, StrUtils, NumEdit, CurrEdit, MyGrids, SortGrid,
  Grids, Trpcb, MFunStr, Fmcntrls, VA508AccessibilityManager, ActnList;

type
  TfrmInventoryTransactionEdit = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    edtQtyNew: TIntEdit;
    edtSerialNumber: TEdit;
    edtLotNumber: TEdit;
    chkExclude: TCheckBox;
    chkWaiver: TCheckBox;
    Label18: TLabel;
    edtIssuedHCPCS: TEdit;
    btnChangeHCPCS: TBitBtn;
    edtBarCodeHCPCS: TEdit;
    btnSave: TBitBtn;
    Panel1: TPanel;
    edtBarCodeHCPCSChangeDate: TEdit;
    Label5: TLabel;
    grdPatientCategory: TStringGrid;
    btnQuit: TBitBtn;
    grdMiniDis: TSortGrid;
    Label10: TLabel;
    edtBarCodeItemCost: TCurrencyEdit;
    Label19: TLabel;
    edtTotalCost: TCurrencyEdit;
    Label11: TLabel;
    edtItemDescription: TEdit;
    edtPatIEN: TEdit;
    edtIEN660: TEdit;
    edtExcludeWaiver: TEdit;
    edtIssuedHCPCSIEN: TEdit;
    edtEligibilityCode: TFMEdit;
    Label7: TLabel;
    Label12: TLabel;
    Label16: TLabel;
    edtSource: TEdit;
    edtDateOfReceipt: TEdit;
    edtExpirationDate: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    edtItemNumber: TEdit;
    edtVendor: TEdit;
    edtStoreRoom: TEdit;
    edtStationNumber: TEdit;
    edtExternalLotID: TEdit;
    edtTypeOfTransaction: TFMEdit;
    edtRemarks: TEdit;
    Label17: TLabel;
    edtQtyToSend: TIntEdit;
    edtQtyCurrent: TIntEdit;
    rgrpTypeOfTransaction: TFMRadioGroup;
    IntEdit1: TIntEdit;
    edtQty: TIntEdit;
    edtIEN668: TEdit;
    Label6: TLabel;
    edtContractNumber: TEdit;
    lblBannerName: TLabel;
    Panel2: TPanel;
    grpPatientCategory: TGroupBox;
    btnEligibility: TBitBtn;
    edtEligibilityDisplay: TEdit;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    VA508ComponentAccessibility1: TVA508ComponentAccessibility;
    ActionList1: TActionList;
    Action1: TAction;
    Action2: TAction;
    VA508ComponentAccessibility2: TVA508ComponentAccessibility;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnQuitClick(Sender: TObject);
    procedure edtQtyNewChange(Sender: TObject);
    procedure edtQtyNewClick(Sender: TObject);
    procedure edtQtyNewEnter(Sender: TObject);
    procedure edtQtyNewExit(Sender: TObject);
    procedure btnChangeHCPCSClick(Sender: TObject);
    procedure btnEligibilityClick(Sender: TObject);
    procedure grdPatientCategoryDblClick(Sender: TObject);
    procedure grdPatientCategoryKeyPress(Sender: TObject; var Key: Char);
    procedure chkExcludeClick(Sender: TObject);
    procedure chkWaiverClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure rgrpTypeOfTransactionClick(Sender: TObject);
    procedure edtLotNumberKeyPress(Sender: TObject; var Key: Char);
    procedure edtSerialNumberKeyPress(Sender: TObject; var Key: Char);
    procedure edtSerialNumberExit(Sender: TObject);
    procedure grdPatientCategoryMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnSaveClick(Sender: TObject);
    procedure VA508ComponentAccessibility1ValueQuery(Sender: TObject;
      var Text: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInventoryTransactionEdit: TfrmInventoryTransactionEdit;

implementation

uses PROS_Menu
    ,uPROS_SelectHCPCS, uPROS_InventoryTransactionDetail;

{$R *.dfm}

function buildOutput(o: TSortGrid): String;

var text: String;
const delim: string = '^';
var i: integer;

Begin
  o.SelectedRows.Sort;
  Text := delim + inttostr(o.RowCount-1) + delim;   // row count
  Text := Text + inttostr(o.colCount) + delim;    // column count

  for i := 0 to o.colCount-1 do // column headers
    Text := Text + o.Cells[i,0] + delim; // row 0 is column header
    Text := Text + IntToStr(o.Row) + delim; // current row number
    Text := Text + inttostr(0) + delim; // current column num will always be 0 when in row selection mode

  for i := 0 to o.colCount-1 do // data
    Text := Text + o.Cells[i,o.Row] + delim; // row 0 is column header
    Text := Text + intToStr(o.SelectedRows.Count) + delim; // row selection count
    Text := Text + intToStr(0) + delim; // col selection count

 for i := 0 to o.SelectedRows.Count - 1 do
  Begin
     if i = o.SelectedRows.Count -1 then
       Text := Text + o.SelectedRows[i] // selected rows
     Else
       Text := Text + o.SelectedRows[i] + ','; // selected rows
   End;

  Text := Text + delim;  // delim after selected rows
  Text := Text + IntToStr(0) + Delim; // selected columns

  buildOutput := Text;

End;

procedure TfrmInventoryTransactionEdit.VA508ComponentAccessibility1ValueQuery(Sender: TObject;
var Text: string);
begin
  Text := buildOutput(TSortGrid(TVA508ComponentAccessibility(sender).Component));
End;

procedure TfrmInventoryTransactionEdit.btnSaveClick(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to Edit this Record?',mtConfirmation,[mbNo,mbYes],0) = mrYes then
    begin
        frmMenu.brkrRPC.RemoteProcedure := 'RMPR INV MON EDIT';
        frmMenu.brkrRPC.Param[1].Value := edtIEN660.Text;
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := edtEligibilityCode.Text;
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := edtRemarks.Text;
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Value := edtQtyToSend.Text;
        frmMenu.brkrRPC.Param[4].PType := literal;
        frmMenu.brkrRPC.Param[5].Value := edtSerialNumber.Text;
        frmMenu.brkrRPC.Param[5].PType := literal;
        frmMenu.brkrRPC.Param[6].Value := edtLotNumber.Text;
        frmMenu.brkrRPC.Param[6].PType := literal;
        frmMenu.brkrRPC.Param[7].Value := edtExcludeWaiver.Text;
        frmMenu.brkrRPC.Param[7].PType := literal;
        frmMenu.brkrRPC.Param[8].Value := edtTypeOfTransaction.Text;
        frmMenu.brkrRPC.Param[8].PType := literal;
        frmMenu.brkrRPC.Param[9].Value := DateToStr(Now);//edtDateOfService.Text;
        frmMenu.brkrRPC.Param[9].PType := literal;
        frmMenu.brkrRPC.Param[10].Value := edtStationNumber.Text;
        frmMenu.brkrRPC.Param[10].PType := literal;


     Try
     //
      frmMenu.brkrRPC.Call;

     except
      on E:EBrokerError do
        begin
        Showmessage('Broker Error: '+ E.Message);
        end;
      on E:EAccessViolation do
        ShowMessage(E.Message);
      else
        raise;
      end;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
           MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);

//        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then  //Ok
//           begin
//            MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
//           end;
        close;
        frmInventoryTransactionDetail.btnDisplay.click;
   end
  else
  ShowMessage('Your changes have not been saved.');
 end;

procedure TfrmInventoryTransactionEdit.btnQuitClick(Sender: TObject);
begin
Close;
end;

procedure TfrmInventoryTransactionEdit.FormActivate(Sender: TObject);
var
 i : integer;
begin

 with grdMiniDis do       // Grid header
  begin
      Cells[0,0] := 'Disability';
      Cells[1,0] := ' %';
      Cells[2,0] := 'SC';
 end;

begin
   TRY
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR DIS LIST';
    frmMenu.brkrRPC.Param[0].Value := edtIEN668.Text;
    frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


 grdMiniDis.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do  //Tab 4
   begin
    with grdMiniDis do
      begin
         Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//Disab
         Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//% Disab
         Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);// SC YES/NO

      end; // with do
    end;
   Except
  end;//Try
 end;
end;

procedure TfrmInventoryTransactionEdit.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
release;
end;

procedure TfrmInventoryTransactionEdit.grdPatientCategoryDblClick(
  Sender: TObject);
begin
      edtEligibilityCode.text := grdPatientCategory.cells[1,grdPatientCategory.Row];
   edtEligibilityDisplay.Text := grdPatientCategory.Cells[0,grdPatientCategory.row];
   grdPatientCategory.Visible := False;
end;

procedure TfrmInventoryTransactionEdit.grdPatientCategoryKeyPress(
  Sender: TObject; var Key: Char);
begin
  if Key = char(VK_RETURN) then
  begin
      edtEligibilityCode.text := grdPatientCategory.cells[1,grdPatientCategory.Row];
   edtEligibilityDisplay.Text := grdPatientCategory.Cells[0,grdPatientCategory.row];
   grdPatientCategory.Visible := False;
  end;

 if Key = char(VK_Escape) then
  begin
   grdPatientCategory.Visible := False;
   btnEligibility.SetFocus;
  end;
end;

procedure TfrmInventoryTransactionEdit.grdPatientCategoryMouseUp(
  Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
      edtEligibilityCode.text := grdPatientCategory.cells[1,grdPatientCategory.Row];
   edtEligibilityDisplay.Text := grdPatientCategory.Cells[0,grdPatientCategory.row];
   grdPatientCategory.Visible := False;
end;

procedure TfrmInventoryTransactionEdit.rgrpTypeOfTransactionClick(
  Sender: TObject);
begin
 edtTypeOfTransaction.Text
  := rgrpTypeOfTransaction.FMInternalCodes.Strings[rgrpTypeOfTransaction.ItemIndex];
end;

procedure TfrmInventoryTransactionEdit.btnChangeHCPCSClick(Sender: TObject);
begin
  Application.CreateForm(TfrmSelHCPCS, frmSelHCPCS);
  frmSelHCPCS.lblHCPCSTopMessage.Caption := 'Select New HCPCS Code';
  frmSelHCPCS.lblHCPCSErrorMsg.Caption := '';
  frmSelHCPCS.ShowModal;
end;

procedure TfrmInventoryTransactionEdit.btnEligibilityClick(Sender: TObject);
var
  i : integer;
begin
//     grdPatientCategory.Visible := True;
//     grdPatientCategory.SetFocus;

    frmMenu.brkrRPC.RemoteProcedure := 'RMPR PATIENT CATEGORY LIST'; // 'RMPR INV ISSUE POST';


  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
  End;

    if frmMenu.brkrRPC.Results.Count > 0 then
        grdPatientCategory.RowCount := frmMenu.brkrRPC.Results.Count +1;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1  do  //Tab 4


    with grdPatientCategory do
    begin

      Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1); //Catagory
      Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2); //Code

    end;
    grdPatientCategory.Visible := True;
    grdPatientCategory.SetFocus;
//    edtEligibility.text := grdPatientCategory.cells[2,grdPatientCategory.Row];  //Sets first DFN
//   end
//  else
//   ShowMessage('Please enter at least 2 characters.');

end;


procedure TfrmInventoryTransactionEdit.chkExcludeClick(Sender: TObject);
begin
 if chkExclude.Checked = True then
 begin
  chkWaiver.Checked := False;
  edtExcludeWaiver.Text := 'E';
 end
  else
  edtExcludeWaiver.Text := '';
end;

procedure TfrmInventoryTransactionEdit.chkWaiverClick(Sender: TObject);
begin
 if chkWaiver.Checked = True then
 begin
  chkExclude.Checked := False;
  edtExcludeWaiver.Text := 'W';
 end
  else
  edtExcludeWaiver.Text := '';
end;

procedure TfrmInventoryTransactionEdit.edtLotNumberKeyPress(Sender: TObject;
  var Key: Char);
begin
if Key = '^' then Key := #0;

//For lot number, the length must between 1 and 20 characters and cannot contain an ^.
end;

procedure TfrmInventoryTransactionEdit.edtQtyNewChange(Sender: TObject);
begin
  edtTotalCost.Value :=  (edtQtyNew.Value *  edtBarCodeItemCost.Value);
  edtQtyToSend.Value := (edtQtyNew.Value - edtQtyCurrent.Value);
end;

procedure TfrmInventoryTransactionEdit.edtQtyNewClick(Sender: TObject);
begin
 edtQtyNew.SelectAll;
end;

procedure TfrmInventoryTransactionEdit.edtQtyNewEnter(Sender: TObject);
begin
 edtQtyNew.SelectAll;
end;

procedure TfrmInventoryTransactionEdit.edtQtyNewExit(Sender: TObject);
begin
 if edtQtyNew.Value < 1 then
  begin
   Showmessage('Please enter a quantity of 1 or more.');
   edtQtyNew.Value := edtQtyCurrent.Value;
   edtQtyNew.SetFocus;
  end;
if edtQtyNew.Value > 1000 then
  begin
   Showmessage('Please enter a quantity of 1000 or less.');
   edtQtyNew.Value := edtQtyCurrent.Value;
   edtQtyNew.SetFocus;
  end;

end;

procedure TfrmInventoryTransactionEdit.edtSerialNumberExit(Sender: TObject);
begin
 if LeftStr(edtSerialNumber.Text,1) = '-' then
  begin
    ShowMessage('The FIRST character must not be the '' - '' ');
    edtSerialNumber.SetFocus;
  end;
end;

procedure TfrmInventoryTransactionEdit.edtSerialNumberKeyPress(Sender: TObject;
  var Key: Char);
begin
  begin
   if (Key = '-') and (edtSerialNumber.SelStart = 0) then  Key := #0;
  end;

if (Key = '"') or (Key = '^') then Key := #0;

//For serial # the length must be between 1 and 20 characters in length and cannot  begin with   or  contain  or an ^.
end;

end.
