unit uPROS_InventoryTransactionMonitor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, MyGrids, SortGrid, StdCtrls, Buttons, ComCtrls, ExtCtrls,
  Fmcntrls, Rpcconf1, Trpcb, MFunStr, ProgBar, AppEvnts, Menus, FileCtrl,
  ShellAPI, ESBDates, VA508AccessibilityManager;

type
  TfrmInventoryTransactionMonitor = class(TForm)
    grdInventoryTransactionMonitor: TSortGrid;
    btnExcel: TBitBtn;
    btnDisplay: TBitBtn;
    dtpkrFromDate: TDateTimePicker;
    dtpkrToDate: TDateTimePicker;
    btnViewRequest: TBitBtn;
    btnViewCPRS: TBitBtn;
    btnView2319: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    lblRecords: TLabel;
    edtDateTime: TEdit;
    pnlProgressBar: TPanel;
    btnClear: TBitBtn;
    btnClose: TBitBtn;
    Panel2: TPanel;
    btnViewDetail: TBitBtn;
    appInventoryTransactionMonitor: TApplicationEvents;
    MainMenu1: TMainMenu;
    svDlgInventoryTransactionMonitor: TSaveDialog;
    dlgPrint: TPrintDialog;
    lblExcelPath: TLabel;
    edtSiteSearchString: TEdit;
    grdSelectSite: TStringGrid;
    edtSiteIEN: TEdit;
    Label3: TLabel;
    File1: TMenuItem;
    SelectDisplay1: TMenuItem;
    FromDate1: TMenuItem;
    ToDate1: TMenuItem;
    N1: TMenuItem;
    DisplayRefresh1: TMenuItem;
    View1: TMenuItem;
    View23191: TMenuItem;
    ViewCPRS1: TMenuItem;
    ViewRequest1: TMenuItem;
    ExcelExport1: TMenuItem;
    ViewDetail1: TMenuItem;
    FilterBySite1: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    Close1: TMenuItem;
    StatusBar1: TStatusBar;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    VA508ComponentAccessibility1: TVA508ComponentAccessibility;
    mnuMenu: TMenuItem;
    N4: TMenuItem;
    edtNumberOfTotalRecords: TEdit;
    VA508ComponentAccessibility2: TVA508ComponentAccessibility;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnDisplayClick(Sender: TObject);
    procedure chkExcludeClick(Sender: TObject);
    procedure chkWaiverClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure grdInventoryTransactionMonitorDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnCloseClick(Sender: TObject);
    procedure btnViewDetailClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure grdInventoryTransactionMonitorDblClick(Sender: TObject);
    procedure appInventoryTransactionMonitorMessage(var Msg: tagMSG;
      var Handled: Boolean);
    procedure btnView2319Click(Sender: TObject);
    procedure grdInventoryTransactionMonitorGetSortStyle(Sender: TObject;
      Col: Integer; var SortStyle: TSortStyle);
    procedure grdInventoryTransactionMonitorClick(Sender: TObject);
    procedure btnViewCPRSClick(Sender: TObject);
    procedure btnViewRequestClick(Sender: TObject);
    procedure btnExcelClick(Sender: TObject);
    procedure edtSiteSearchStringKeyPress(Sender: TObject; var Key: Char);
    procedure grdSelectSiteClick(Sender: TObject);
    procedure grdSelectSiteDblClick(Sender: TObject);
    procedure grdSelectSiteKeyPress(Sender: TObject; var Key: Char);
    procedure edtSiteSearchStringEnter(Sender: TObject);
    procedure FromDate1Click(Sender: TObject);
    procedure ToDate1Click(Sender: TObject);
    procedure FilterBySite1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure grdSelectSiteExit(Sender: TObject);
    procedure VA508ComponentAccessibility1ValueQuery(Sender: TObject;
      var Text: string);
    procedure edtSiteSearchStringExit(Sender: TObject);

  private
    { Private declarations }
    ExcelFile : string;
    procedure CurrentRecord;
    procedure SiteSearch;



  public
    { Public declarations }
  end;

var
  frmInventoryTransactionMonitor: TfrmInventoryTransactionMonitor;
  ITMIEN668 : string;


implementation


uses
 PROS_Menu
 ,PROS_Menu_About
 ,uPROS_InventoryTransactionDetail
 ,PROS_DOR_View2319
 ,PROS_DOR_ViewCPRS, PROS_DOR_ViewReq ;

{$R *.dfm}

function buildOutput(o: TSortGrid): String;

var text: String;
const delim: string = '^';
var i: integer;

Begin
  o.SelectedRows.Sort;
  Text := delim + inttostr(o.RowCount-1) + delim;   // row count
  Text := Text + inttostr(o.colCount) + delim;    // column count

  for i := 0 to o.colCount-1 do // column headers
    Text := Text + o.Cells[i,0] + delim; // row 0 is column header
    Text := Text + IntToStr(o.Row) + delim; // current row number
    Text := Text + inttostr(0) + delim; // current column num will always be 0 when in row selection mode

  for i := 0 to o.colCount-1 do // data
    Text := Text + o.Cells[i,o.Row] + delim; // row 0 is column header
    Text := Text + intToStr(o.SelectedRows.Count) + delim; // row selection count
    Text := Text + intToStr(0) + delim; // col selection count

 for i := 0 to o.SelectedRows.Count - 1 do
  Begin
     if i = o.SelectedRows.Count -1 then
       Text := Text + o.SelectedRows[i] // selected rows
     Else
       Text := Text + o.SelectedRows[i] + ','; // selected rows
   End;

  Text := Text + delim;  // delim after selected rows
  Text := Text + IntToStr(0) + Delim; // selected columns

  buildOutput := Text;

End;

procedure TfrmInventoryTransactionMonitor.VA508ComponentAccessibility1ValueQuery(Sender: TObject;
var Text: string);
begin
  Text := buildOutput(TSortGrid(TVA508ComponentAccessibility(sender).Component));
End;

procedure TfrmInventoryTransactionMonitor.Close1Click(Sender: TObject);
begin
close;
end;

procedure TfrmInventoryTransactionMonitor.CurrentRecord;
begin
// PatName := grdConsult.Cells[8,grdConsult.Row]; //For display in other forms
// PatSSN  := grdConsult.Cells[9,grdConsult.Row];
 ITMIEN668  := grdInventoryTransactionMonitor.Cells[36,grdInventoryTransactionMonitor.Row]; //For display in other forms
// PatIEN  := grdConsult.Cells[14,grdConsult.Row];
// RowID   := grdConsult.Row; //For display in other forms

// if PatLookupIEN <> '' then PatIEN := PatLookupIEN; //If Patient Lookup is Sender

// PatLookupIEN :='';    //Clears it for next time the procedure is called

end;



procedure TfrmInventoryTransactionMonitor.SiteSearch;
var
 i : integer;
begin
 if length(edtSiteSearchString.Text) > -1 then
  begin
//  btnClearList.Click;

  frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  frmMenu.brkrRPC.RemoteProcedure := 'RMPR SITE PARAMETER LOOKUP';
  frmMenu.brkrRPC.Param[0].Value := edtSiteSearchString.Text;
  frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

    if frmMenu.brkrRPC.Results.Count > 0 then
        grdSelectSite.RowCount := frmMenu.brkrRPC.Results.Count +1;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1  do


    with grdSelectSite do
    begin
      Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2); //Site Name
      Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3); //Site Number
      Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1); //IEN 669.9
      Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4); //IEN 4
    end;
    grdSelectSite.Visible := True;
    grdSelectSite.SetFocus;
    edtSiteIEN.text := grdSelectSite.cells[2,grdSelectSite.Row];  //Sets first DFN
    edtSiteSearchString.Text := grdSelectSite.Cells[0,grdSelectSite.row];
   end
  else
   ShowMessage('Please enter at least 2 characters.');
end;


procedure TfrmInventoryTransactionMonitor.edtSiteSearchStringEnter(
  Sender: TObject);
begin
edtSiteSearchString.Color := clWindow;
edtSiteIEN.Text := '';
edtSiteSearchString.Clear;
end;

procedure TfrmInventoryTransactionMonitor.edtSiteSearchStringExit(
  Sender: TObject);
begin
edtSiteSearchString.Color := clBtnFace;
end;

procedure TfrmInventoryTransactionMonitor.edtSiteSearchStringKeyPress(
  Sender: TObject; var Key: Char);
begin
 if Key = char(VK_RETURN)
    then SiteSearch;
end;

procedure TfrmInventoryTransactionMonitor.About1Click(Sender: TObject);
begin
  dlgAbout.ShowModal;
end;

procedure TfrmInventoryTransactionMonitor.appInventoryTransactionMonitorMessage(
  var Msg: tagMSG; var Handled: Boolean);
var
   i: SmallInt;
begin
  if grdInventoryTransactionMonitor.Focused then
  begin
   if Msg.message = WM_MOUSEWHEEL then
   begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

    SendMessage(grdInventoryTransactionMonitor.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

      end
     else
    SendMessage(grdInventoryTransactionMonitor.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


     Handled := False;
   end;
  end;
end;

procedure TfrmInventoryTransactionMonitor.btnExcelClick(Sender: TObject);
var
    DIR : String;
    buttonSelected : Integer;
    currdir : String;
    i : Integer;  //addes RMPR*143
    briefdesc : String;    //added RMPR*143
    fromDate,f1,f2,f3,toDate,t1,t2,t3 : string;        //Creates the Jun 01,2002 display date

 begin
  if frmMenu.brkrRPC.Connected = false then      //Checks if user is logged on
      MessageDlg('Please Sign On first.', mtInformation,
      [mbOk], 0)
  else

 begin

  //*********************
  // This section converts the date to format Oct 31, 2010 for Excel

   begin                           //from the tossed calendar pick
    fromDate := '';                      //Clears everything
//    if dtpkrFromDate.Text <> '' then
//      begin
        f1 := Date2ShortMonth(dtpkrFromDate.Date);
       if Date2Day(dtpkrFromDate.Date) < 10 then  //Pad with 0 if needed
        f2:= '0'+ IntToStr(Date2Day(dtpkrFromDate.Date))
       else
        f2 := IntToStr(Date2Day(dtpkrFromDate.Date));  //Or not
        f3 := IntToStr(Date2Year(dtpkrFromDate.Date));

     fromDate := f1+' '+f2+', '+f3; //Assembles the pieces
//   end;
   end;

   begin                           //Ending/To date  pick
    toDate := '';                      //Clears everything
//    if dtpkrFromDate.Text <> '' then
//      begin
        t1 := Date2ShortMonth(dtpkrToDate.Date);
       if Date2Day(dtpkrToDate.Date) < 10 then  //Pad with 0 if needed
        t2:= '0'+ IntToStr(Date2Day(dtpkrToDate.Date))
       else
        t2 := IntToStr(Date2Day(dtpkrToDate.Date));  //Or not
        t3 := IntToStr(Date2Year(dtpkrToDate.Date));

     toDate := t1+' '+t2+', '+t3; //Assembles the pieces
//   end;
   end;
//****************************************



   if fileexists(excelfile) then
    begin
      if SysUtils.DeleteFile(ExcelFile) = False then
        raise Exception.Create('Please close the temporary Excel (.csv) file before continuing')     //rmpr*136
      else
        lblExcelPath.Caption := '';
    end;


  begin
  if grdInventoryTransactionMonitor.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to send to Excel.', mtInformation,
      [mbOk], 0)
  else
  begin
     begin    //Check for default CSV folder and create it
      if not DirectoryExists('c:\NPPDDownload') then
      if not CreateDir('c:\NPPDDownload') then
      raise Exception.Create('Cannot create c:\NPPDDownload');
     end;

     DIR := 'c:\NPPDDownload';

      buttonSelected := Application.MessageBox('The data you are about to export may'+
      ' contain Patient Identifiable Information, which requires appropriate measures '+
      'to ensure its confidentiality.  Please select only a secure, encrypted location'+
      ' to save this data.','Security Reminder',MB_OK + MB_DEFBUTTON1);


    if buttonSelected = ID_OK  then
     begin
        currdir := GetCurrentDir;    //capture current directory
        if SelectDirectory(DIR, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
        begin
          ExcelFile := DIR+'\'+fromDate+'_'+toDate+'.csv';
          grdInventoryTransactionMonitor.SaveToCSV(ExcelFile);
          ShellExecute(frmInventoryTransactionMonitor.Handle, nil, PChar(ExcelFile), nil, nil, SW_SHOWNORMAL);
          lblExcelPath.Caption := DIR;

        end;
        SetCurrentDir(currdir);  //reset current directory
     end;
    end;
    end;
 end;
end;


procedure TfrmInventoryTransactionMonitor.btnClearClick(Sender: TObject);
var
  i : integer;

begin

  for i :=1 to grdInventoryTransactionMonitor.RowCount -1 do   //If selected will clear the grid
    grdInventoryTransactionMonitor.Rows[i].Clear;

 grdInventoryTransactionMonitor.RowCount := 2;
 grdInventoryTransactionMonitor.Row := 1;
 grdInventoryTransactionMonitor.Cells[0,1] :='';
 edtDateTime.Visible := False;
 edtNumberOfTotalRecords.Text := '0';
end;



procedure TfrmInventoryTransactionMonitor.btnCloseClick(Sender: TObject);
begin
Close;
end;

procedure TfrmInventoryTransactionMonitor.btnDisplayClick(Sender: TObject);
var
  i : integer;
  ani: TAnimationThread;
  r: TRect;

begin
    edtNumberOfTotalRecords.Text := '0'; // For display
    btnClear.Click;

    btnDisplay.Caption := 'Searching';

    frmMenu.brkrRPC.RemoteProcedure := 'RMPR INV MON';
    frmMenu.brkrRPC.Param[1].Value := DateToStr(dtpkrFromDate.Date);
    frmMenu.brkrRPC.Param[1].Ptype := literal;
    frmMenu.brkrRPC.Param[2].Value := DateToStr(dtpkrToDate.Date);;
    frmMenu.brkrRPC.Param[2].Ptype := literal;
    frmMenu.brkrRPC.Param[3].Value := edtSiteIEN.Text;
    frmMenu.brkrRPC.Param[3].PType := literal;

 TRY
  begin
  edtDateTime.Visible := False;
  pnlProgressBar.Visible := true;
  r := pnlProgressBar.clientrect;
  InflateRect( r, - pnlProgressBar.bevelwidth, - pnlProgressBar.bevelwidth );

  //Start progress bar in thread
  ani := TanimationThread.Create( pnlProgressBar, r, pnlProgressBar.color, clWindowText, 25 );

  Application.ProcessMessages;
      frmMenu.brkrRPC.Call;//Sleep( 1000 );  {replace with query.Open or such}

  //Stop progress bar
  pnlProgressBar.Visible := False;
  ani.Terminate;
  end;
 Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
  END;

 btnDisplay.Caption := '&Display / Refresh';

 if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
 begin

 edtNumberOfTotalRecords.Text := IntToStr(frmMenu.brkrRPC.Results.Count);//

 if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then
    begin //b2
      MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
      edtNumberOfTotalRecords.Text := '0';
    end  //b2
 else

 begin  //b3

    edtDateTime.Text := DateTimeToStr(now); //Displays D&T of call
    edtDateTime.Visible := True;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
    begin  //b4 // Getting data from the broker call
     with grdInventoryTransactionMonitor do
      begin
         Cells[0,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',5);    // Current Status
         Cells[1,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',32);   // Action Type
         Cells[2,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',6);    // TRANSACTION DATE
         Cells[3,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',9);    // TYPE OF TRANSACTION
         Cells[4,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',8);    // USER NAME
         Cells[5,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',1);    // Pt Name
         Cells[6,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',2);    // Pt SSN
         Cells[7,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',23);   // PSAS HCPCS
         Cells[8,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',12);   // ITEM CODE
         Cells[9,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',13);   // ItemDesc
         Cells[10,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',22);   // QUANTITY
         Cells[11,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',21);   // ITEM COST
         Cells[12,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',18);   // SOURCE
         Cells[13,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',17);   // EXTERNAL STATION
         Cells[14,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',16);   // STOREROOM
         Cells[15,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',24);   // SERIAL NBR
         Cells[16,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',25);   // LOT NUMBER
         Cells[17,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',26);   // EXCLUDE/WAIVER
         Cells[18,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',15);   // VENDOR
         Cells[19,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',20);   // CONTRACT #
         Cells[20,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',19);   // DATE OF RECEIPT
         Cells[21,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',14);   // ITEM EXPIRATION DATE
         Cells[22,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',29);   // PATIENT CATEGORY
         Cells[23,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',30);   // REMARKS

//         Cells[24,i+1] :=
//         Cells[25,i+1] :=
//         Cells[26,i+1] :=
//         Cells[27,i+1] :=
//         Cells[28,i+1] :=
//         Cells[29,i+1] :=

         Cells[30,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',27);   // BARCODE HCPCS
         Cells[31,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',28);   // HCPCS VERSION DATE
         Cells[32,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',33 );  // Qty Sent
         Cells[33,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',11);   // Ext Lot #
         Cells[34,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',10);   // HL7 MESSAGE ID
         Cells[35,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',7);    // IEN 660
         Cells[36,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',34 );  // IEN 668
         Cells[37,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',31 );  // IEN 666.10
         Cells[38,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);    // PSAS Ref #
         Cells[39,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);    // External Ref #
//         Cells[40,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',35 );

       end;









(*
1  Patient Name
2  SSN in the form NNN-NN-NNNN
3  PSAS REFERENCE NUMBER
4  EXTERNAL REFERENCE NUMBER
5  CURRENT STATUS
6  TRANSACTION DATE
7  2319 RECORD
8  USER NAME
9  TYPE OF TRANSACTION
10 HL7 MESSAGE ID
11 EXTERNAL MESSAGE RESULT
12 ITEM CODE
13 ITEM DESCRIPTION
14 ITEM EXPIRATION DATE
15 VENDOR
16 STOREROOM
17 EXTERNAL STATION
18 SOURCE
19 DATE OF RECEIPT
20 CONTRACT #
21 ITEM COST
22 QUANTITY
23 PSAS HCPCS
24 SERIAL NBR
25 LOT NUMBER
26 EXCLUDE/WAIVER
27 BARCODE HCPCS
28 HCPCS VERSION DATE
29 PATIENT CATEGORY
30 REMARKS


*)
   end;
  end;
      if frmMenu.brkrRPC.Results.Count > 0 then
      begin
        grdInventoryTransactionMonitor.RowCount := frmMenu.brkrRPC.Results.Count +1; //Sizes grid to match results
        CurrentRecord;
        grdInventoryTransactionMonitor.SetFocus;
  end
   else grdInventoryTransactionMonitor.RowCount := 2;
  end;
end;

procedure TfrmInventoryTransactionMonitor.btnView2319Click(Sender: TObject);
begin
 if ITMIEN668 <> '' then
  begin
  Application.CreateForm(TfrmView2319, frmView2319);
  frmView2319.edtVarIEN668.Text  := ITMIEN668; //sends IEN668 to View2319
  frmView2319.ShowModal;
  end
 else ShowMessage('Please select a RECORD to view');
end;


procedure TfrmInventoryTransactionMonitor.btnViewCPRSClick(Sender: TObject);
begin
 if ITMIEN668 <> '' then
  begin
  Application.CreateForm(TfrmViewCPRS, frmViewCPRS);
  frmViewCPRS.edtVarIEN668.Text := ITMIEN668; //sends IEN668 to ViewCPRS
  frmViewCPRS.ShowModal;
  end
 else ShowMessage('Please select a RECORD to view');
end;

procedure TfrmInventoryTransactionMonitor.btnViewDetailClick(Sender: TObject);
begin
  if grdInventoryTransactionMonitor.Cells[38,grdInventoryTransactionMonitor.Row] <> '' then
   begin
    Application.CreateForm(TfrmInventoryTransactionDetail, frmInventoryTransactionDetail);

    frmInventoryTransactionDetail.edtInventoryTransactionIEN.Text :=
            grdInventoryTransactionMonitor.Cells[38,grdInventoryTransactionMonitor.Row];

    frmInventoryTransactionDetail.Caption := 'Inventory Transaction Detail  '+
            grdInventoryTransactionMonitor.Cells[5,grdInventoryTransactionMonitor.Row] +' '+ grdInventoryTransactionMonitor.Cells[6,grdInventoryTransactionMonitor.Row];

    frmInventoryTransactionDetail.btnDisplay.Click; //called to check for bad record first
    frmInventoryTransactionDetail.ShowModal;  //Moved to btnDisplay after brkr call
   end
   else
    ShowMessage('Please select a RECORD to view.');
end;

procedure TfrmInventoryTransactionMonitor.btnViewRequestClick(Sender: TObject);
begin
 if ITMIEN668 <> '' then
   begin
   Application.CreateForm(TfrmViewReq, frmViewReq);
   frmViewReq.edtVarIEN668.Text := ITMIEN668; //sends IEN668 to ViewRequest
   frmViewReq.ShowModal;
  end
 else ShowMessage('Please select a RECORD to view');
end;

procedure TfrmInventoryTransactionMonitor.chkExcludeClick(Sender: TObject);
begin
//if chkExclude.Checked = True then chkWaiver.Checked := False;
end;

procedure TfrmInventoryTransactionMonitor.chkWaiverClick(Sender: TObject);
begin
//if chkWaiver.Checked = True then chkExclude.Checked := False;
end;

procedure TfrmInventoryTransactionMonitor.FilterBySite1Click(Sender: TObject);
begin
edtSiteSearchString.SetFocus;
end;

procedure TfrmInventoryTransactionMonitor.FormActivate(Sender: TObject);
begin
frmInventoryTransactionMonitor.WindowState := wsMaximized; //open as full window

end;

procedure TfrmInventoryTransactionMonitor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
      if fileexists(excelfile) then
    begin
      if SysUtils.DeleteFile(ExcelFile) = False then
        raise Exception.Create('Please close the temporary .csv file before navigating from this form')    //RMPR*136
    end;
release;
end;

procedure TfrmInventoryTransactionMonitor.FormCreate(Sender: TObject);
begin

frmInventoryTransactionMonitor.Caption := '   You are logged onto '+frmMenu.brkrRPC.Server;
dtpkrFromDate.Date := Now - 15;
dtpkrToDate.Date := Now;

with grdInventoryTransactionMonitor do
 begin
      Cells[0,0] := 'Status';                      
      ColWidths[0] := 75;                          
                                                   
      Cells[1,0] := 'Action Type';                 
      ColWidths[1] := 100;                         
                                                   
      Cells[2,0] := 'Action Date';                 
      ColWidths[2] := 150;                         
                                                   
      Cells[3,0] := 'Type of Trans';               
      ColWidths[3] := 100;                         
                                                   
      Cells[4,0] := 'User Name';
      ColWidths[4] := 125;

      Cells[5,0] := 'Patient Name';
      ColWidths[5] := 125;

      Cells[6,0] := 'SSN';
      ColWidths[6] := 75;

      Cells[7,0] := 'HCPCS';
      ColWidths[7] := 50;

      Cells[8,0] := 'Item Code';
      ColWidths[8] := 75;

      Cells[9,0] := 'Item Description';  
      ColWidths[9] := 100;               
                                         
      Cells[10,0] := 'Qty';              
      ColWidths[10] := 30;               
                                         
      Cells[11,0] := 'Item Cost';        
      ColWidths[11] := 75;               
                                         
      Cells[12,0] := 'Source';           
      ColWidths[12] := 100;              
                                         
      Cells[13,0] := 'Station';
      ColWidths[13] := 50;

      Cells[14,0] := 'Storeroom';
      ColWidths[14] := 60;

      Cells[15,0] := 'Serial #';
      ColWidths[15] := 100;

      Cells[16,0] := 'Lot #';
      ColWidths[16] := 100;

      Cells[17,0] := 'Exc/Wav';
      ColWidths[17] := 100;

      Cells[18,0] := 'Vendor';
      ColWidths[18] := 100;

      Cells[19,0] := 'Contract #';
      ColWidths[19] := 125;

      Cells[20,0] := 'Date of Receipt';
      ColWidths[20] := 100;

      Cells[21,0] := 'Expiration';
      ColWidths[21] := 100;

      Cells[22,0] := 'Pt Cat';
      ColWidths[22] := 100;

      Cells[23,0] := 'Remarks';
      ColWidths[23] := 200;

      Cells[24,0] := '';
      ColWidths[24] := -1;

      Cells[25,0] := '';
      ColWidths[25] := -1;

      Cells[26,0] := '';
      ColWidths[26] := -1;

      Cells[27,0] := '';
      ColWidths[27] := -1;

      Cells[28,0] := '';
      ColWidths[28] := -1;

      Cells[29,0] := '';                      
      ColWidths[29] := -1;                    
                                              
      Cells[30,0] := 'Barcode HCPCS';         
      ColWidths[30] := 100;                   
                                              
      Cells[31,0] := 'HCPCS Date';            
      ColWidths[31] := 100;                   
                                              
      Cells[32,0] := 'Qty Sent';              
      ColWidths[32] := 40;

      Cells[33,0] := 'Ext Lot';
      ColWidths[33] := 100;

      Cells[34,0] := 'HL7 ID';
      ColWidths[34] := 100;

      Cells[35,0] := 'IEN 660';
      ColWidths[35] := 75;

      Cells[36,0] := 'IEN 668';
      ColWidths[36] := 75;

      Cells[37,0] := 'IEN 666.10';
      ColWidths[37] := 75;

      Cells[38,0] := 'Vista Ref';
      ColWidths[38] := 100;

      Cells[39,0] := 'External Ref';
      ColWidths[39] := 100;

 end;

  with grdSelectSite do               // Sets column headers
    begin
     Cells[0,0] := 'Station Name';
     Cells[1,0] := 'Station #';
     //  ColWidths[0] := 270;
    end;

end;

procedure TfrmInventoryTransactionMonitor.FromDate1Click(Sender: TObject);
begin
dtpkrFromDate.SetFocus;
dtpkrFromDate.Perform(WM_KEYDOWN, VK_F4, 0); //Calls Calendar from menu
dtpkrFromDate.Perform(WM_KEYUP, VK_F4, 0);
end;

procedure TfrmInventoryTransactionMonitor.grdInventoryTransactionMonitorClick(
  Sender: TObject);
begin
CurrentRecord;
end;

procedure TfrmInventoryTransactionMonitor.grdInventoryTransactionMonitorDblClick(
  Sender: TObject);
begin
btnViewDetail.Click;
end;

procedure TfrmInventoryTransactionMonitor.grdInventoryTransactionMonitorDrawCell(Sender: TObject;
  ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
    i : integer;
    S: string;
    SavedAlign: word;

begin
  with grdInventoryTransactionMonitor do
  begin
      if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
      else
      begin

    case ACol of

        0: for i := 1 to grdInventoryTransactionMonitor.RowCount do//sets cell color
            begin
             if (ARow = i) and (Cells[0,i] = 'ERROR') then
             begin
               Canvas.Font.Style := [fsBold];
               Canvas.Font.Color := clWhite;
               Canvas.Brush.Color := clRed;
             end;
//             Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[0, arow]);
//             Canvas.FrameRect(Rect);
            end;

        end;

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;

  end;

//Final draw of grid

        Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
        Canvas.FrameRect(Rect);
  end;
 end;
//**********************************
// begin
//  if ACol = 11 then
//  begin  // ACol is zero based
//    S := grdInventoryTransactionMonitor.Cells[ACol, ARow]; // cell contents
//    SavedAlign := SetTextAlign(grdInventoryTransactionMonitor.Canvas.Handle, TA_LEFT);//TA_RIGHT  CENTER
//    grdInventoryTransactionMonitor.Canvas.TextRect(Rect,
//      Rect.Left + (Rect.Right - Rect.Left) div 2, Rect.Top + 2, S);
//    SetTextAlign(grdInventoryTransactionMonitor.Canvas.Handle, SavedAlign);
//  end;
// end;
//***********************************


end;



procedure TfrmInventoryTransactionMonitor.grdInventoryTransactionMonitorGetSortStyle(
  Sender: TObject; Col: Integer; var SortStyle: TSortStyle);
begin
if Col=2 then SortStyle := ssDateTime; //Sort PSAS Ref as a Date
if Col=20 then SortStyle := ssDateTime; //Sort Ext Ref as a Date
if Col=21 then SortStyle := ssDateTime; //Sort Ext Ref as a Date
if Col=31 then SortStyle := ssDateTime; //Sort Ext Ref as a Date
if Col=38 then SortStyle := ssNumeric; //Sort PSAS Ref as a number
if Col=39 then SortStyle := ssNumeric; //Sort Ext Ref as a number

end;

procedure TfrmInventoryTransactionMonitor.grdSelectSiteClick(Sender: TObject);
begin
  edtSiteIEN.text := grdSelectSite.cells[2,grdSelectSite.Row];
  edtSiteSearchString.Text := grdSelectSite.Cells[0,grdSelectSite.row];
end;

procedure TfrmInventoryTransactionMonitor.grdSelectSiteDblClick(
  Sender: TObject);
begin
  edtSiteIEN.text := grdSelectSite.cells[2,grdSelectSite.Row];
  edtSiteSearchString.Text := grdSelectSite.Cells[0,grdSelectSite.row];
  grdSelectSite.Visible := False;
  btnDisplay.SetFocus;
end;

procedure TfrmInventoryTransactionMonitor.grdSelectSiteExit(Sender: TObject);
begin
  grdSelectSite.Visible := False;
  edtSiteSearchString.Color := clBtnFace;
//  btnDisplay.Click;
end;

procedure TfrmInventoryTransactionMonitor.grdSelectSiteKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = char(VK_RETURN) then
  begin
   edtSiteIEN.text := grdSelectSite.cells[2,grdSelectSite.Row];
   edtSiteSearchString.Text := grdSelectSite.Cells[0,grdSelectSite.row];
   grdSelectSite.Visible := False;
   btnDisplay.Click;
  end;
end;

procedure TfrmInventoryTransactionMonitor.ToDate1Click(Sender: TObject);
begin
dtpkrToDate.SetFocus;
dtpkrToDate.Perform(WM_KEYDOWN, VK_F4, 0); //Calls Calendar from menu
dtpkrToDate.Perform(WM_KEYUP, VK_F4, 0);
end;

end.
