{*****************************************************
  Prosthetic VistA Suite Menu - GUI    ver 3.6.75   November 24,2006
  Office of Information Field Office
  Department of Veterans Affairs
  Hines,Illinois

  Developers: Helen Corkwell, Sam Spencer, Al Cardilli, Ken Nelson
  Technical Writer: Al Bustamante
  Description: GUI to SignOn and call other VistA GUI programs
  Requires: RMPR*3.0*71 - RMPR*3.0*59 - RMPR*3.0*96 - RMPR*3.0*90 - PRC*5.1*68
            RMPR*3.0*116 - RMPR*3.0*75, RMPR*3*136, RMPR*3*143

*******************************************************}

unit Pros_Menu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ShellAPI, SRGrad, Rpcconf1, ExtCtrls, Trpcb, ProgBar,
  CCOWRPCBroker, AppEvnts, System.UITypes, System.Win.Registry, HtmlHelpViewer,
  U_HelpMGR;


type
  TfrmMenu = class(TForm)
    btnVistaSignOn: TBitBtn;
    btnDetailDisplay: TBitBtn;
    btnPurchasing: TBitBtn;
    btnClose: TBitBtn;
    imgGradiantTop: TSRGradient;
    imgGradiantBottom: TSRGradient;
    lblProsthetics: TLabel;
    imgVALogo: TImage;
    btnDelayedOrderReport: TBitBtn;
    btnHelp: TBitBtn;
    btnAbout: TBitBtn;
    btnViewBilling: TBitBtn;
    btnOWL: TBitBtn;
    brkrRPC: TCCOWRPCBroker;
    procedure btnDetailDisplayClick(Sender: TObject);
    procedure btnVistaSignOnClick(Sender: TObject);
    procedure btnPurchasingClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnDelayedOrderReportClick(Sender: TObject);
    procedure SignOnVista;
    procedure btnAboutClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnHelpClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnViewBillingClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOWLClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckHelpFile;

  private
    f508Active: Boolean;
    fInit508: Boolean;
    function Read508Active: Boolean;
    procedure Write508Active(aValue: Boolean);
  public
    property Is508Active: Boolean read Read508Active write Write508Active;
  end;

//  procedure ShowForm;stdcall;external 'PROS_EZ3.dll' name 'ShowDllForm';
//  function ShowFormModal:integer;stdcall;external 'PROS_EZ3.dll' name 'ShowDllFormModal';

var
  frmMenu: TfrmMenu;
  UserDUZ : String;

  gDebug: Boolean; // CodeCR PROST431

  const Reg508Key = '\Software\Vista\PROS'; //registry key for Section 508 toggle

implementation

uses PROS_NPPDDetailDisplay_Main, PROS_DOR_Consult, PROS_Menu_About,
  PROS_ViewBilling, PROS_POC_PurOrderConsult, uPROS_OWL;

{$R *.DFM}

procedure TfrmMenu.SignOnVista;  //Sign onto the Vista System
var
strServer, strPort: string;
begin
  brkrRPC.Connected := false;  //Forces disconnection
  frmMenu.Caption := '   You are not logged on . . .';
  brkrRPC.Server := '';    //Clears specified server name/addr
  brkrRPC.ListenerPort := 0 ;
  frmViewBilling.btnClear.Click; //Clears View Billing grid
  frmConsult.btnClear.Click;  //Clears DOR grid
  frmMain.btnClear.Click;     //Clears Detail Display grid
  frmPurOrderConsult.btnClear.Click;  //Clears the P.O. grid
  frmOWL.btnClear.Click; //Clears all 3 OWL grids

  if ( brkrRPC.Connected = False) and (GetServerInfo(strServer, strPort)<> mrCancel) then
   begin //getsvrinfo
     brkrRPC.Server := strServer;          //use specified server name/addr
     brkrRPC.ListenerPort := StrToInt(strPort);  //use specified port
     brkrRPC.RPCTimeLimit := 120;
     brkrRPC.Connected := true;
     frmMenu.Caption := '   You are logged onto '+brkrRPC.Server;
   end
   else
    begin
     ShowMessage('Connection to Broker Server: '+strServer + #13#10 +
     'Canceled.  Exiting Application.');
     Application.Terminate;
     Halt;
    end;


//     brkrRPC.ListenerPort := 9200;
//     brkrRPC.Server := '127.000.0.1';
//     brkrRPC.Connected := true;
  brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  brkrRPC.RemoteProcedure := 'XWB GET VARIABLE VALUE';
  brkrRPC.Param[0].Value := 'DUZ';
  brkrRPC.Param[0].PType := reference ;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
//    	 frmMenu.brkrRPC.Connected := true;
//    	 frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


  UserDUZ := frmMenu.brkrRPC.Results[0];


end;


procedure TfrmMenu.btnVistaSignOnClick(Sender: TObject);
begin
 if MessageDlg('The following displayed information may contain individually-identifiable information related to'+#13+
               'vendors, patients, or employees requiring appropriate measures be taken to secure the information'+#13+
               'and ensure the confidentiality of the information is maintained.'+#13+
               ''+#13+
               'I understand that when viewing, printing or saving this information appropriate security and'+#13+
               'privacy policies should be followed.',
               mtConfirmation, [mbYes, mbNo], 0) = mrYes then

 begin
  if  brkrRPC.Connected = true then      //Checks if user really wants to
    begin                                  //log off then log on again
     if MessageDlg('You are about to log off of VISTA - Continue?',
       mtConfirmation, [mbYes, mbNo], 0) = mrYes then SignOnVista;
    end
   else SignOnVista;
 end;
end;



procedure TfrmMenu.btnDetailDisplayClick(Sender: TObject);
begin
if brkrRPC.Connected = false then
  //begin
   MessageDlg('Please Sign-On to VISTA first.', mtInformation,
   [mbOk], 0)
  else
   frmMain.ShowModal;
end;

procedure TfrmMenu.btnPurchasingClick(Sender: TObject);
begin
if brkrRPC.Connected = false then
   MessageDlg('Please Sign-On to VISTA first.', mtInformation,
   [mbOk], 0)
  else
   frmPurOrderConsult.ShowModal;
end;

procedure TfrmMenu.btnCloseClick(Sender: TObject);
begin
Close;
end;

procedure TfrmMenu.btnDelayedOrderReportClick(Sender: TObject);
begin

if brkrRPC.Connected = false then
   MessageDlg('Please Sign-On to VISTA first.', mtInformation,
   [mbOk], 0)
  else
   frmConsult.ShowModal;


end;

procedure TfrmMenu.btnAboutClick(Sender: TObject);
begin
dlgAbout.ShowModal;
end;

procedure TfrmMenu.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 if MessageDlg('Are you sure you want to EXIT the Prosthetics Application Suite?', mtConfirmation,
    [mbOk, mbCancel], 0) = mrCancel then
     CanClose := False;

end;

procedure TfrmMenu.btnHelpClick(Sender: TObject);
begin
Application.HelpFile := 'PROS_MENU_HELPFILE.CHM'; //Needed here
CheckHelpFile;
Application.HelpCommand(Help_Index,0);

end;

procedure TfrmMenu.FormActivate(Sender: TObject);
begin
Application.HelpFile := 'PROS_MENU_HELPFILE.CHM'; //Needed here
end;

procedure TfrmMenu.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (Key = VK_F1) then
   begin
    Application.HelpFile := 'PROS_MENU_HELPFILE.CHM'; //Needed here
    btnHelp.Click;
   end;
end;

procedure TfrmMenu.btnViewBillingClick(Sender: TObject);
begin
if brkrRPC.Connected = false then
   MessageDlg('Please Sign-On to VISTA first.', mtInformation,
   [mbOk], 0)
  else
   frmViewBilling.ShowModal;
end;

procedure TfrmMenu.FormClose(Sender: TObject; var Action: TCloseAction);
begin
brkrRPC.Connected := False;
end;

procedure TfrmMenu.btnOWLClick(Sender: TObject);
begin
if brkrRPC.Connected = false then
   MessageDlg('Please Sign-On to VISTA first.', mtInformation,
   [mbOk], 0)
  else
   frmOWL.ShowModal;

end;

// CodeCR PROST 431 ---- begin
procedure TfrmMenu.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  for i := 1 to ParamCount do
    begin
      if copy(ParamStr(i),1,6)='/DEBUG' then
        begin
          gDebug := True;
          break;
        end;
    end;

   fInit508 := True;
end;
// CodeCR PROST 431 ---- end

function TfrmMenu.Read508Active: Boolean;
var
  reg: TRegistry;
begin
  if fInit508 then
  begin
    reg := TRegistry.Create(KEY_READ OR KEY_WOW64_32KEY);
    try
      reg.rootkey := HKEY_CURRENT_USER;
      if reg.KeyExists(Reg508Key) then
      begin
      reg.OpenKey(Reg508Key, false);
      f508Active := reg.ReadBool('Sec508');
      reg.CloseKey;
      end else
      f508Active := false;
      fInit508 := false;
      finally
      reg.Free;
    end;
  end;
    Result := f508Active;
end;

procedure TfrmMenu.Write508Active(aValue: Boolean);
const
  dlgMessage = 'Do you wish to %s Section 508 assistance?';
var
  reg: TRegistry; // Toggle Sec 508 screen settings in registry
  msgVar: string;
begin
  if not aValue then
    msgVar := 'turn off'
  else
    msgVar := 'activate';

  if MessageDlg(Format(dlgMessage, [msgVar]), mtConfirmation, [mbYes, mbNo], 0)
    = mrYes then
  begin
    f508Active := aValue;
    reg := TRegistry.Create(KEY_WRITE OR KEY_WOW64_32KEY);
    try
      reg.rootkey := HKEY_CURRENT_USER;
      if not reg.KeyExists(Reg508Key) then
       Reg.CreateKey(Reg508Key);

      reg.OpenKey(Reg508Key, false);
      reg.WriteBool('Sec508', f508Active); // Turn it on
      reg.CloseKey;
    finally
      reg.Free;
    end;

    ShowMessage
      ('Please EXIT and RESTART the program for the changes to take effect');
  end;

end;

procedure TfrmMenu.CheckHelpFile;
begin
  LoadHelpFile(Application.HelpFile);
end; //end CheckHelpFile

end.
