(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson, Robert Ades
Requires: RMPR*3.0*143
Description: Orthotic Work order and Lab (OWL) program is a used to collect and report lab costs.

*******************************************)
unit uPROS_OWL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Vcl.Grids, UExtendedStringGrid, StdCtrls, Buttons, Fmcntrls, ExtCtrls,
  Menus, Trpcb, Rpcconf1, MFunstr, ProgBar, ComCtrls, Diaccess, Fmcmpnts, ESBDates,
  CurrEdit, AppEvnts, System.UITypes;

type
  TfrmOWL = class(TForm)
    grdOWLWorkOrders: TSortGrid;
    btnDisplay: TBitBtn;
    lblWorkOrders: TFMLabel;
    grdOWLItemList: TSortGrid;
    lblWorkOrderNumber: TFMLabel;
    btnMaterialAdd: TBitBtn;
    btnLaborAdd: TBitBtn;
    chkPending: TFMCheckBox;
    chkCompleted: TFMCheckBox;
    chkCancelled: TFMCheckBox;
    pnlProgressBar: TPanel;
    btnClose: TBitBtn;
    mnuOWLMainMenu: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    mnuFIleSeperator: TMenuItem;
    mnuPrintOWL: TMenuItem;
    btnClear: TBitBtn;
    stsbrOWL: TStatusBar;
    lblNumberOfTotalOWLRecords: TFMLabel;
    dbsGets664_1: TFMGets;
    btnClearItemListGrid: TBitBtn;
    grdOWLMaterialList: TSortGrid;
    lblMaterialForHCPCS: TFMLabel;
    btnHCPCSDetail: TBitBtn;
    btnMaterialDetail: TBitBtn;
    lblTotalOWLRecords: TFMLabel;
    lblTotalBaseCodes: TFMLabel;
    lblNumberOfTotalBaseCodes: TFMLabel;
    pnlOWLHCPCS: TPanel;
    btnClearMaterialListGrid: TBitBtn;
    lblTotalMaterialEntries: TFMLabel;
    lblNumberOfTotalMaterialEntries: TFMLabel;
    pnlOWLMaterials: TPanel;
    btnHCPCSAdd: TBitBtn;
    btnRefreshItemListGrid: TBitBtn;
    dbsGets664_22: TFMGets;
    dbsGets664_2: TFMGets;
    btnRefreshMaterialListGrid: TBitBtn;
    grdOWLLaborList: TSortGrid;
    lblLaborForHCPCS: TFMLabel;
    pnlOWLWorkOrder: TPanel;
    dbsGets664_16: TFMGets;
    pnlOWLLabor: TPanel;
    btnLaborDetail: TBitBtn;
    btnClearLaborListGrid: TBitBtn;
    btnRefreshLaborListGrid: TBitBtn;
    lblNumberOfLaborEnteries: TFMLabel;
    lblTotalLaborEntries: TFMLabel;
    dbsGets664_3: TFMGets;
    dbsGets664_33: TFMGets;
    btnOWLAssignTechnician: TBitBtn;
    btnOWLPrint: TBitBtn;
    dbsGets661_1: TFMGets;
    chkAssigned: TFMCheckBox;
    btnOWLComplete: TBitBtn;
    mnuWorkOrder: TMenuItem;
    mnuDetail: TMenuItem;
    mnuAssignTech: TMenuItem;
    mnuComplete: TMenuItem;
    mnuHCPCS: TMenuItem;
    mnuDetailEditHCPCS: TMenuItem;
    mnuAddHCPCS: TMenuItem;
    mnuMaterials: TMenuItem;
    mnuDetailEditMaterial: TMenuItem;
    mnuAddMaterial: TMenuItem;
    mnuLabor: TMenuItem;
    mnuDetailEditLabor: TMenuItem;
    mnuAddLabor: TMenuItem;
    mnuHelp: TMenuItem;
    mnuPrintOWL2: TMenuItem;
    mnuSelectDisplay: TMenuItem;
    mnuChkPendingAssignment: TMenuItem;
    mnuChkAssigned: TMenuItem;
    mnuChkCompleted: TMenuItem;
    mnuChkCancelled: TMenuItem;
    mnuSelectDisplaySeperator: TMenuItem;
    mnuDisplayRefresh: TMenuItem;
    btnView2319: TBitBtn;
    btnViewCPRS: TBitBtn;
    btnViewRequest: TBitBtn;
    btnWorkOrderDetail: TBitBtn;
    edtHCPCSTotalCost: TCurrencyEdit;
    lblTotalWorkOrderCost: TFMLabel;
    edtMaterialsTotalCost: TCurrencyEdit;
    edtLaborTotalCost: TCurrencyEdit;
    lblOWLMaterialsTotalCost: TFMLabel;
    lblLaborTotalCost: TFMLabel;
    btnOWLCancel: TBitBtn;
    edtSeperator: TEdit;
    mnuView: TMenuItem;
    mnuView2319: TMenuItem;
    mnuViewCPRS: TMenuItem;
    mnuViewRequest: TMenuItem;
    mnuCancelOWL: TMenuItem;
    mnuContents: TMenuItem;
    mnuHelpSeperator: TMenuItem;
    mnuAbout: TMenuItem;
    appOWL: TApplicationEvents;
    procedure FormCreate(Sender: TObject);
    procedure btnDisplayClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnClearItemListGridClick(Sender: TObject);
    procedure btnWorkOrderDetailClick(Sender: TObject);
    procedure grdOWLWorkOrdersDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnClearMaterialListGridClick(Sender: TObject);
    procedure btnMaterialAddClick(Sender: TObject);
    procedure grdOWLWorkOrdersClick(Sender: TObject);
    procedure btnMaterialDetailClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnHCPCSAddClick(Sender: TObject);
    procedure btnRefreshItemListGridClick(Sender: TObject);
    procedure btnRefreshMaterialListGridClick(Sender: TObject);
    procedure btnHCPCSDetailClick(Sender: TObject);
    procedure grdOWLItemListRowSelected(Sender: TObject);
    procedure grdOWLItemListEndUpdate(Sender: TObject);
    procedure grdOWLMaterialListRowSelected(Sender: TObject);
    procedure grdOWLMaterialListClick(Sender: TObject);
    procedure grdOWLItemListClick(Sender: TObject);
    procedure btnClearLaborListGridClick(Sender: TObject);
    procedure btnRefreshLaborListGridClick(Sender: TObject);
    procedure btnLaborAddClick(Sender: TObject);
    procedure grdOWLLaborListClick(Sender: TObject);
    procedure btnLaborDetailClick(Sender: TObject);
    procedure btnOWLAssignTechnicianClick(Sender: TObject);
    procedure btnOWLPrintClick(Sender: TObject);
    procedure btnOWLCompleteClick(Sender: TObject);
    procedure btnView2319Click(Sender: TObject);
    procedure btnViewCPRSClick(Sender: TObject);
    procedure btnViewRequestClick(Sender: TObject);
    procedure CalcHCPCSTotalCost;
    procedure CalcMaterialsTotalCost;
    procedure CalcLaborTotalCost;
    function OWLLockRecord :integer;
    function OWLUnLockRecord :integer;
    procedure grdOWLWorkOrdersGetSortStyle(Sender: TObject; Col: Integer;
      var SortStyle: TSortStyle);
    procedure grdOWLLaborListGetSortStyle(Sender: TObject; Col: Integer;
      var SortStyle: TSortStyle);
    procedure grdOWLWorkOrdersGetCellFormat(Sender: TObject; Col,
      Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions);
    procedure grdOWLItemListGetCellFormat(Sender: TObject; Col,
      Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions);
    procedure grdOWLMaterialListGetCellFormat(Sender: TObject; Col,
      Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions);
    procedure grdOWLLaborListGetCellFormat(Sender: TObject; Col,
      Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions);
    procedure btnOWLCancelClick(Sender: TObject);
    procedure mnuChkPendingAssignmentClick(Sender: TObject);
    procedure mnuChkAssignedClick(Sender: TObject);
    procedure mnuChkCompletedClick(Sender: TObject);
    procedure mnuChkCancelledClick(Sender: TObject);
    procedure mnuPrintOWLClick(Sender: TObject);
    procedure mnuClearClick(Sender: TObject);
    procedure mnuDisplayRefreshClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuAssignTechClick(Sender: TObject);
    procedure mnuAddHCPCSClick(Sender: TObject);
    procedure mnuAddMaterialClick(Sender: TObject);
    procedure mnuAddLaborClick(Sender: TObject);
    procedure mnuDetailEditHCPCSClick(Sender: TObject);
    procedure mnuPrintOWL2Click(Sender: TObject);
    procedure mnuDetailEditMaterialClick(Sender: TObject);
    procedure mnuDetailEditLaborClick(Sender: TObject);
    procedure mnuView2319Click(Sender: TObject);
    procedure mnuViewCPRSClick(Sender: TObject);
    procedure mnuViewRequestClick(Sender: TObject);
    procedure mnuDetailClick(Sender: TObject);
    procedure mnuCompleteClick(Sender: TObject);
    procedure mnuCancelOWLClick(Sender: TObject);
    procedure mnuContentsClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure mnuSelectDisplayClick(Sender: TObject);
    procedure appOWLMessage(var Msg: tagMSG;
      var Handled: Boolean);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWL: TfrmOWL;
  ConsultStatus, OWLPrinterIEN, OWLPatientIEN, OWLPatientName,
  OWLPAtientSSN, IEN664_1, IEN664_16, IEN664_2, IEN664_22, IEN664_3,
  IEN664_33, IEN669_9, OWL_IEN668 : string;

  ConsultDate : TDate;

  OWLRowID, OWLEditRowID,
  OWLItemListRowID,OWLItemListEditRowID,
  OWLMaterialListRowID, OWLMaterialListEditRowID,
  OWLLaborListRowID, OWLLaborListEditRowID : integer;

implementation

uses PROS_POC_PurOrderConsult, Pros_Menu, uPROS_OWL_WorkOrderDetail,
  uPROS_OWL_AddMaterial, uPROS_OWL_AddHCPCS, uPROS_OWL_AddLabor,
  uPROS_OWL_AssignTechnician, uPROS_OWL_SelPrinter, uPROS_OWL_PrintOWL,
  PROS_DOR_View2319, PROS_DOR_ViewCPRS, PROS_DOR_ViewReq, PROS_Menu_About,
  uPROS_OWL_Complete, uPROS_OWL_Cancel;

{$R *.dfm}


procedure TfrmOWL.CalcHCPCSTotalCost;
var
 r : integer;
 HCPCSTotal, LineAmount : extended;
begin
 HCPCSTotal := 0;  //Clear all values

 for r := 1 to frmOWL.grdOWLItemList.RowCount -1  do    //Get line count
 begin
   If frmOWL.grdOWLItemList.Cells[3,r] <>'' then //Error checks for value
    begin
     LineAmount := StrToFloat(frmOWL.grdOWLItemList.Cells[3,r]);
     HCPCSTotal := HCPCSTotal + LineAmount;
    end;
  end;
  edtHCPCSTotalCost.Value := HCPCSTotal;
 end; //End of Calc


procedure TfrmOWL.CalcMaterialsTotalCost;
var
 r : integer;
 MaterialsTotal, LineAmount : extended;
begin
 MaterialsTotal := 0;  //Clear all values

 for r := 1 to frmOWL.grdOWLMaterialList.RowCount -1  do    //Get line count
 begin
   If frmOWL.grdOWLMaterialList.Cells[3,r] <>'' then //Error checks for value
    begin
     LineAmount := (StrToFloat(frmOWL.grdOWLMaterialList.Cells[1,r])*(StrToFloat(frmOWL.grdOWLMaterialList.Cells[3,r])));
     MaterialsTotal := MaterialsTotal + LineAmount;
    end;
  end;
  edtMaterialsTotalCost.Value := MaterialsTotal;
 end; //End of Calc


procedure TfrmOWL.CalcLaborTotalCost;
var
 r : integer;
 LaborTotal, LineAmount : extended;
begin
 LaborTotal := 0;  //Clear all values

 for r := 1 to frmOWL.grdOWLLaborList.RowCount -1  do    //Get line count
 begin
   If frmOWL.grdOWLLaborList.Cells[3,r] <>'' then //Error checks for value
    begin
     LineAmount := (StrToFloat(frmOWL.grdOWLLaborList.Cells[2,r]) * (StrToFloat(frmOWL.grdOWLLaborList.Cells[3,r])));
     LaborTotal := LaborTotal + LineAmount;
    end;
  end;
  edtLaborTotalCost.Value := LaborTotal;
end; //End of Calc


function TfrmOWL.OWLLockRecord : integer;
begin
 Result := 1;
 if IEN664_1 <> '' then
  begin
   frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL LOCK FILE';
   frmMenu.brkrRPC.Param[1].Value := IEN664_1;
   frmMenu.brkrRPC.Param[1].PType := literal;

  Try
    //
  frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


 if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
   begin
     if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then
      begin //b2
       MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
       Result := 1;
       end
       else
       Result := 0;
      end;
   end;
end;


function TfrmOWL.OWLUnLockRecord : integer;
begin
 Result := 1;
 if IEN664_1 <> '' then
  begin
   frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL UNLOCK FILE';
   frmMenu.brkrRPC.Param[1].Value := IEN664_1;
   frmMenu.brkrRPC.Param[1].PType := literal;

  Try
    //
  frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


 if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
   begin
     if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then
      begin //b2
       MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
       Result := 1;
       end
       else
       Result := 0;
      end;
   end;
end;


procedure TfrmOWL.FormCreate(Sender: TObject);
begin

with grdOWLWorkOrders do               // Sets column headers
 begin
      Cells[0,0] := 'LWO Number';
      Cells[1,0] := 'Type';
      Cells[2,0] := 'Status';
      Cells[3,0] := 'OWL Date';
      Cells[4,0] := 'Assigned Tech';
      Cells[5,0] := 'Consult Date';
      Cells[6,0] := 'Patient';
      Cells[7,0] := 'SSN';
      Cells[8,0] := 'NPPD Station';
      Cells[9,0] := 'Recv Station';
      Cells[10,0] := 'Req Station';
      Cells[11,0] := 'Pt IEN';
      Cells[12,0] := 'IEN 664.1';
      Cells[13,0] := 'IEN 669.9';
      Cells[14,0] := 'IEN 668';
  end;

with grdOWLItemList do               // Sets column headers
 begin
      Cells[0,0]  := 'Pri';
      Cells[1,0]  := 'HCPCS';
      Cells[2,0]  := 'HCPCS Item';
      Cells[3,0]  := 'Total $ ';
      Cells[4,0]  := 'UoI';
      Cells[5,0]  := 'Qty';
      Cells[6,0]  := 'Trans Type';
      Cells[7,0]  := 'IEN 660';
      Cells[8,0]  := 'IEN 664.2';
      Cells[9,0]  := 'IEN 664.16';
  end;

with grdOWLMaterialList do
  begin
      Cells[0,0]  := 'Material';
      Cells[1,0]  := 'Qty';
      Cells[2,0]  := 'UoI';
      Cells[3,0]  := 'Unit Cost $';
      Cells[4,0]  := 'Src';
      Cells[5,0]  := 'Vendor';
      Cells[6,0]  := 'Serial #';
      Cells[7,0]  := 'IEN 664.22';
   end;

with grdOWLLaborList do
  begin
      Cells[0,0]  := 'Date';
      Cells[1,0]  := 'Technician';
      Cells[2,0]  := 'Hrs';
      Cells[3,0]  := 'Rate $';
      Cells[4,0]  := 'IEN664.2';
      Cells[5,0]  := 'DUZ';
      Cells[6,0]  := 'IEN664.3';
      Cells[7,0]  := 'IEN664.33';
   end;

// btnDisplay.Click;

end;


procedure TfrmOWL.btnDisplayClick(Sender: TObject);
var
  i : integer;
  PE,CA,CL,ASG : string;
  ani: TAnimationThread;
  r: TRect;

begin

  begin
    btnClear.Click; //Clear the OWL grid first
    btnClearItemListGrid.Click; //Clear HCPCS grid
    btnClearMaterialListGrid.Click; //Clear Material grid
    btnClearLaborListGrid.Click; //Clear Labor grid
  end;

   PE := '';
   CA := '';
   CL := '';
  ASG := '';

  if chkPending.Checked then PE := 'P';  // In Progress
  if chkCancelled.Checked then CA := 'X';
  if chkCompleted.Checked then CL := 'C';
  if chkAssigned.Checked then ASG := 'A';
  ConsultStatus := PE+CA+CL+ASG;


  btnDisplay.Caption := 'Searching';

  frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL WORK ORDER LIST';
  frmMenu.brkrRPC.Param[1].Value := ConsultStatus;
  frmMenu.brkrRPC.Param[1].Ptype := literal;


  TRY
   begin
   pnlProgressBar.Visible := true;
   r := pnlProgressBar.clientrect;
   InflateRect( r, - pnlProgressBar.bevelwidth, - pnlProgressBar.bevelwidth );

   //Start progress bar in thread
   ani := TanimationThread.Create( pnlProgressBar, r, pnlProgressBar.color, clWhite, 25 );
   ani.Start;
   Application.ProcessMessages;

   frmMenu.brkrRPC.Call;//Sleep( 1000 );  {replace with query.Open or such}

   //Stop progress bar
   pnlProgressBar.Visible := False;
   ani.Terminate;
   end;
  Except
    on E:EBrokerError do
       begin
        Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
        Showmessage(E.Message);
     else
       raise;
  END;

  btnDisplay.Caption := '&Display/Refresh';

  if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
   begin
     if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then //error
      begin //b2
       MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
       lblNumberOfTotalOWLRecords.Caption := '0';
      end  //b2
   else
   begin  //b3

     for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
      begin
       frmOWL.grdOWLWorkOrders.Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',12);//Work Order
       frmOWL.grdOWLWorkOrders.Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',15);//Type
       frmOWL.grdOWLWorkOrders.Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',8);//Status
       frmOWL.grdOWLWorkOrders.Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',23);//LWO Date
       frmOWL.grdOWLWorkOrders.Cells[4,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',14);//Tech
       frmOWL.grdOWLWorkOrders.Cells[5,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1); //Consult Date
       frmOWL.grdOWLWorkOrders.Cells[6,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3); //Patient
       frmOWL.grdOWLWorkOrders.Cells[7,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5); //SSN
       frmOWL.grdOWLWorkOrders.Cells[8,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',16);//NPPD Station
       frmOWL.grdOWLWorkOrders.Cells[9,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',20);//Recv Station
       frmOWL.grdOWLWorkOrders.Cells[10,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',18);//Req Station
       frmOWL.grdOWLWorkOrders.Cells[11,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2); //Pt IEN
       frmOWL.grdOWLWorkOrders.Cells[12,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',10);//IEN 664.1
       frmOWL.grdOWLWorkOrders.Cells[13,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',22);//IEN 669.9
       frmOWL.grdOWLWorkOrders.Cells[14,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',9);//IEN 668

      end;

      lblNumberOfTotalOWLRecords.Caption := IntToStr(frmMenu.brkrRPC.Results.Count);
//      lblWorkOrderNumber.Caption := 'Work Order Detail - '+grdOWLWorkOrders.Cells[0,1];
     end; //b5




// Set default from first record in grid in
         IEN664_1  := grdOWLWorkOrders.Cells[12,1]; //For display in other forms
          OWLRowID := 1; //For display in other forms
    OWLPatientName := grdOWLWorkOrders.Cells[6,1]; //For display in other forms
    OWLPatientSSN  := grdOWLWorkOrders.Cells[7,1]; //+'     SSN: '+PatSSN;
    OWLPatientIEN  := grdOWLWorkOrders.Cells[11,1];
          IEN669_9 := grdOWLWorkOrders.Cells[13,1]; //NPPD Site
      OWL_IEN668   := grdOWLWorkOrders.Cells[14,1];

//    lblWorkOrderNumber.Caption := 'Base Codes for Work Order: '+grdOWLWorkOrders.Cells[0,grdOWLWorkOrders.Row];

   if frmMenu.brkrRPC.Results.Count > 0 then
       frmOWL.grdOWLWorkOrders.RowCount := frmMenu.brkrRPC.Results.Count + 1 //Sizes grid to match results
  else frmOWL.grdOWLWorkOrders.RowCount := 2;

  lblNumberOfTotalBaseCodes.Caption := IntToStr(frmMenu.brkrRPC.Results.Count);



//****** REMOVED - The sort is now done on the server side - faster

//This section forces the grid to place the latest OWL date at the top
//  grdOWLWorkOrders.SortColumn(12); //Sets and trigers the update
//  grdOWLWorkOrders.SortOptions.SortDirection := sdDescending;
//  grdOWLWorkOrders.Update;//Not needed
  grdOWLWorkOrders.Row := 1;

  btnRefreshItemListGrid.Click;
  btnRefreshMaterialListGrid.Click;
  btnRefreshLaborListGrid.Click;
  

 end; // check for null reults
end; //b1




procedure TfrmOWL.btnClearClick(Sender: TObject);
var
 i : integer;
begin
 for i :=1 to grdOWLWorkOrders.RowCount -1 do   //If selected will clear the grid
  grdOWLWorkOrders.Rows[i].Clear;
  grdOWLWorkOrders.RowCount := 15;
  grdOWLWorkOrders.Row := 1;
  edtHCPCSTotalCost.Value := 0;
  edtMaterialsTotalCost.Value := 0;
  edtLaborTotalCost.Value := 0;
  OWLRowID := grdOWLWorkOrders.Row;
  grdOWLWorkOrders.Cells[0,1] :='';
  lblNumberOfTotalOWLRecords.Caption := '0';
  btnClearItemListGrid.Click;
  btnClearMaterialListGrid.Click;
  btnClearLaborListGrid.Click;
end;


procedure TfrmOWL.btnWorkOrderDetailClick(Sender: TObject);
begin
if OWLLockRecord = 0 then
begin
  if IEN664_1 <> '' then
   begin
    OWL_IEN668 := grdOWLWorkOrders.Cells[14,grdOWLWorkOrders.Row];
    Application.CreateForm(TfrmOWLWorkOrderDetail, frmOWLWorkOrderDetail);
    frmOWLWorkOrderDetail.ShowModal;
   end
   else ShowMessage('Please select a Work Order to view');
 end;
end;  


procedure TfrmOWL.grdOWLWorkOrdersDblClick(Sender: TObject);
begin
 begin
  IEN664_1 := grdOWLWorkOrders.Cells[12,grdOWLWorkOrders.Row]; //For display in other forms
 end;
// btnViewDetail.Click;
end;

procedure TfrmOWL.FormShow(Sender: TObject);
begin
btnDisplay.Click;
end;

procedure TfrmOWL.btnClearItemListGridClick(Sender: TObject);
var
 i : integer;
begin
 begin
  for i :=1 to grdOWLItemList.RowCount -1 do   //If selected will clear the grid
  grdOWLItemList.Rows[i].Clear;
  grdOWLItemList.RowCount := 2;
  grdOWLItemList.Row := 1;
  OWLItemListRowID := grdOWLItemList.Row;
  lblNumberOfTotalBaseCodes.Caption := '0';
 end;
end;

procedure TfrmOWL.btnClearMaterialListGridClick(Sender: TObject);
var
 i : integer;
begin
 begin
  for i :=1 to grdOWLMaterialList.RowCount -1 do   //If selected will clear the grid
  grdOWLMaterialList.Rows[i].Clear;
  grdOWLMaterialList.RowCount := 2;
  grdOWLMaterialList.Row := 1;
  OWLMaterialListRowID := grdOWLMaterialList.Row;
  lblNumberOfTotalMaterialEntries.Caption := '0';
 end;
end;

procedure TfrmOWL.btnMaterialAddClick(Sender: TObject);
begin
if OWLLockRecord = 0 then
 begin
if ((grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'COMPLETED') or
     (grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'CANCELLED')) then
      ShowMessage('Can not add, this Work order is COMPLETED/CANCELLED')
  else
  begin
  Application.CreateForm(TfrmOWLAddMaterial, frmOWLAddMaterial);
  AddMaterialIEN664_1 := IEN664_1;
  AddMaterialIEN664_2 := IEN664_2;
  OWLItemListEditRowID := grdOWLItemList.Row; //Stores Row ID of selected record
  OWLMaterialListEditRowID := grdOWLMaterialList.Row;
  frmOWLAddMaterial.btnOWLMaterialAdd.Visible := True;
  frmOWLAddMaterial.cbxOwlMaterials.Visible := True;
  frmOWLAddMaterial.cbxOWLMaterialUnitOfIssue.Visible := True;
  frmOWLAddMaterial.cbxOWLMaterialVendor.Visible := True;
  frmOWLAddMaterial.ShowModal;
  end;
 end;
end; 

procedure TfrmOWL.grdOWLWorkOrdersClick(Sender: TObject);
begin
  btnRefreshItemListGrid.Click;
  btnRefreshMaterialListGrid.Click;
  btnRefreshLaborListGrid.Click;
   ConsultDate   := StrToDate(grdOWLWorkOrders.Cells[5,grdOWLWorkOrders.Row]);
  OWLPatientSSN  := grdOWLWorkOrders.Cells[7,grdOWLWorkOrders.Row];
  OWLPatientName := grdOWLWorkOrders.Cells[6,grdOWLWorkOrders.Row];
        IEN664_1 := grdOWLWorkOrders.Cells[12,grdOWLWorkOrders.Row]; //For display in other forms
    OWL_IEN668   := grdOWLWorkOrders.Cells[14,grdOWLWorkOrders.Row];
    IEN669_9 := grdOWLWorkOrders.Cells[13,grdOWLWorkOrders.Row]; //NPPD Site added RMPR*143
end;

procedure TfrmOWL.btnMaterialDetailClick(Sender: TObject);
begin
if OWLLockRecord = 0 then
 begin
 if IEN664_22 <> '' then
  begin
      OWLItemListEditRowID := grdOWLItemList.Row; //Stores Row ID of selected record
  OWLMaterialListEditRowID := grdOWLMaterialList.Row; //Stores Row ID of selected record

  Application.CreateForm(TfrmOWLAddMaterial, frmOWLAddMaterial);
  AddMaterialIEN664_1  := IEN664_1;
  AddMaterialIEN664_2  := IEN664_2;
  AddMaterialIEN664_22 := IEN664_22;

  dbsGets664_22.IENS := AddMaterialIEN664_22+','+ AddMaterialIEN664_2;
  dbsGets664_22.GetData;

        frmOWLAddMaterial.cbxOwlMaterials.Visible := True;
       frmOWLAddMaterial.cbxOWLMaterials.SelText := dbsGets664_22.GetField('.01').FMDBExternal;
       frmOWLAddMaterial.edtOWLMaterialsIEN.Text := dbsGets664_22.GetField('.01').FMDBInternal;
           frmOWLAddMaterial.edtOWLMaterials.Text := dbsGets664_22.GetField('.01').FMDBExternal;

       if dbsGets664_22.GetField('1').FMDBExternal <>'' then
            frmOWLAddMaterial.edtOWLMaterialQty.Value := StrToInt(dbsGets664_22.GetField('1').FMDBExternal)
            else frmOWLAddMaterial.edtOWLMaterialQty.Value := 0;

       if dbsGets664_22.GetField('2').FMDBExternal <>'' then
           frmOWLAddMaterial.edtOWLMaterialCost.Value := StrToFloat(dbsGets664_22.GetField('2').FMDBExternal)
           else frmOWLAddMaterial.edtOWLMaterialCost.Value := 0;

       frmOWLAddMaterial.edtOWLMaterialSourceCode.Text := dbsGets664_22.GetField('3').FMDBInternal;
       if frmOWLAddMaterial.edtOWLMaterialSourceCode.Text = 'V' then
          frmOWLAddMaterial.rgrpOWLMaterialSource.ItemIndex := 0;
       if frmOWLAddMaterial.edtOWLMaterialSourceCode.Text = 'C' then
          frmOWLAddMaterial.rgrpOWLMaterialSource.ItemIndex := 1;

       frmOWLAddMaterial.cbxOWLMaterialVendor.Visible := True;
       frmOWLAddMaterial.cbxOWLMaterialVendor.SelText := dbsGets664_22.GetField('5').FMDBExternal;
       frmOWLAddMaterial.edtOWLMaterialVendorIEN.Text := dbsGets664_22.GetField('5').FMDBInternal;
          frmOWLAddMaterial.edtOWLMaterialVendor.Text := dbsGets664_22.GetField('5').FMDBExternal;

  frmOWLAddMaterial.cbxOWLMaterialUnitOfIssue.Visible := True;
  frmOWLAddMaterial.cbxOWLMaterialUnitOfIssue.SelText := dbsGets664_22.GetField('6').FMDBExternal;
  frmOWLAddMaterial.edtOWLMaterialUnitOfIssueIEN.Text := dbsGets664_22.GetField('6').FMDBInternal;
     frmOWLAddMaterial.edtOWLMaterialUnitOfIssue.Text := dbsGets664_22.GetField('6').FMDBExternal;

    frmOWLAddMaterial.edtOWLMaterialSerialNumber.Text := dbsGets664_22.GetField('7').FMDBExternal;

      frmOWLAddMaterial.edtOWLMaterialPurchaseStatusCode.Text := dbsGets664_22.GetField('13').FMDBInternal;
      if frmOWLAddMaterial.edtOWLMaterialPurchaseStatusCode.Text = 'PD' then
         frmOWLAddMaterial.rgrpOWLMaterialPurchaseStatus.ItemIndex := 0;
      if frmOWLAddMaterial.edtOWLMaterialPurchaseStatusCode.Text = 'D' then
         frmOWLAddMaterial.rgrpOWLMaterialPurchaseStatus.ItemIndex := 1;

   dbsGets664_22.GetField('9').FMWordProc := true;  //Must be set to true for memo
   frmOWLAddMaterial.memOWLMaterialRemarks.Lines := dbsGets664_22.GetField('9').FMWPTextLines;


  frmOWLAddMaterial.btnOWLMaterialUpdate.Visible := True;
  frmOWLAddMaterial.btnOWLMaterialDelete.Visible := True;

     if ((grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'COMPLETED') or
       (grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'CANCELLED')) then
     begin
      ShowMessage('                            VIEW ONLY'+#13+#13+
                  'This Work order is COMPLETED/CANCELLED');
     //Set up for read only
      frmOWLAddMaterial.btnOWLMaterialUpdate.Visible := False;
      frmOWLAddMaterial.btnOWLMaterialDelete.Visible := False;

      frmOWLAddMaterial.edtOWLMaterials.Visible := True;
      frmOWLAddMaterial.cbxOwlMaterials.Enabled := False;

      frmOWLAddMaterial.edtOWLMaterialQty.ReadOnly := True;
      frmOWLAddMaterial.edtOWLMaterialQty.Color := $00CFFFFF;

      frmOWLAddMaterial.edtOWLMaterialUnitOfIssue.Visible := True;
      frmOWLAddMaterial.cbxOWLMaterialUnitOfIssue.Enabled := False;

      frmOWLAddMaterial.edtOWLMaterialCost.ReadOnly := True;
      frmOWLAddMaterial.edtOWLMaterialCost.Color := $00CFFFFF;

      frmOWLAddMaterial.edtOWLMaterialSerialNumber.ReadOnly := True;
      frmOWLAddMaterial.edtOWLMaterialSerialNumber.Color := $00CFFFFF;

      frmOWLAddMaterial.edtOWLMaterialVendor.Visible := True;
      frmOWLAddMaterial.cbxOWLMaterialVendor.Enabled := False;

      frmOWLAddMaterial.memOWLMaterialRemarks.ReadOnly := True;
      frmOWLAddMaterial.memOWLMaterialRemarks.Color := $00CFFFFF;

     end;

  frmOWLAddMaterial.ShowModal;
 end
 else
 ShowMessage('Please select a Material item to view.');
 end;
end;

procedure TfrmOWL.btnCloseClick(Sender: TObject);
begin
Close;
end;

procedure TfrmOWL.btnHCPCSAddClick(Sender: TObject);
begin
if OWLLockRecord = 0 then
 begin
 if ((grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'COMPLETED') or
     (grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'CANCELLED')) then
      ShowMessage('Can not add, this Work order is COMPLETED/CANCELLED')
  else
  begin
  Application.CreateForm(TfrmOWLAddHCPCS, frmOWLAddHCPCS);
  AddHCPCSIEN664_1  := IEN664_1;
  AddHCPCSIEN664_2  := IEN664_2;
  AddHCPCSIEN664_16 := IEN664_16;
  AddHCPCSIEN669_9  := IEN669_9;
  frmOWLAddHCPCS.btnOWLHCPCSAdd.Visible := True;
  frmOWLAddHCPCS.cbxOWLAddHCPCSBillingItem.Visible := True;
  frmOWLAddHCPCS.cbxOWLAddHCPCS_HCPCS.Visible := True;
  frmOWLAddHCPCS.ShowModal;
  end;
 end;
end; 

procedure TfrmOWL.btnRefreshItemListGridClick(Sender: TObject);
var
 i : integer;
 s : String;     //modified RMPR*143
begin
 btnClearMaterialListGrid.Click;
 btnClearItemListGrid.Click;

 IEN664_1 := grdOWLWorkOrders.Cells[12,grdOWLWorkOrders.Row]; //For display in other forms
 if IEN664_1 <> '' then
  begin
  lblWorkOrderNumber.Caption := 'HCPCS for Work Order: '+grdOWLWorkOrders.Cells[0,grdOWLWorkOrders.Row];


// GET LIST OF ITEMS
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL ITEM LIST';
    frmMenu.brkrRPC.Param[1].Value := IEN664_1;
    frmMenu.brkrRPC.Param[1].Ptype := literal;

    TRY
     frmMenu.brkrRPC.Call;
    EXCEPT
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

//Fill the ITEM grid

  if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
   begin
     if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then
      begin //b2
       MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
//       lblNumberOfTotalOWLRecords.Caption := '0';
      end  //b2
   else
   begin  //b3
     for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
      begin
       s := Piece(frmMenu.brkrRPC.Results[i],'^',2); //IEN 664.16
       if s = '1' then frmOWL.grdOWLItemList.Cells[0,i+1] := 'Yes';
       frmOWL.grdOWLItemList.Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',11);//HCPCS Code
       frmOWL.grdOWLItemList.Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);//Item
       frmOWL.grdOWLItemList.Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',13);//Total Cost
       frmOWL.grdOWLItemList.Cells[4,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5); //Unit of Issue
       frmOWL.grdOWLItemList.Cells[5,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4); //Qty
       frmOWL.grdOWLItemList.Cells[6,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',9); //Type of Transaction
       frmOWL.grdOWLItemList.Cells[7,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',7);//IEN 660
       frmOWL.grdOWLItemList.Cells[8,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',8);//IEN 664.2
       frmOWL.grdOWLItemList.Cells[9,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2); //IEN 664.16
      end;

  lblNumberOfTotalBaseCodes.Caption := IntToStr(frmMenu.brkrRPC.Results.Count );

  if frmMenu.brkrRPC.Results.Count > 0 then
       frmOWL.grdOWLItemList.RowCount := frmMenu.brkrRPC.Results.Count + 1 //Sizes grid to match results
  else frmOWL.grdOWLItemList.RowCount := 2;


  IEN664_2 := grdOWLItemList.Cells[8,1];  //Resets after refresh
  IEN664_16 := grdOWLItemList.Cells[9,1];
  btnRefreshMaterialListGrid.Click;

   end;
  end;
 end;
 CalcHCPCSTotalCost;
end;

procedure TfrmOWL.btnRefreshMaterialListGridClick(Sender: TObject);
var
 i : integer;
begin
 btnClearMaterialListGrid.Click;
 IEN664_2  := '';
 IEN664_22 :='';
 IEN664_2 := grdOWLItemList.Cells[8,grdOWLItemList.Row];
 IEN664_16 := grdOWLItemList.Cells[9,grdOWLItemList.Row]; //IEN of Item Multiple
 lblMaterialForHCPCS.Caption := 'Materials for HCPCS: '+grdOWLItemList.Cells[1,grdOWLItemList.Row];

 if IEN664_2 <> '' then
  begin

// GET LIST OF ADD ON'S
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL ADD ON LIST';
    frmMenu.brkrRPC.Param[1].Value := IEN664_2;
    frmMenu.brkrRPC.Param[1].Ptype := literal;

    TRY
     frmMenu.brkrRPC.Call;
    EXCEPT
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

//Fill the ADD ON grid
  if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
   begin
     if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then
      begin //b2
       MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
//       lblNumberOfTotalOWLRecords.Caption := '0';
      end  //b2
   else
   begin  //b3
     for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
      begin
       frmOWL.grdOWLMaterialList.Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);//Material
       frmOWL.grdOWLMaterialList.Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);//Qty
       frmOWL.grdOWLMaterialList.Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',8);//UoI
       frmOWL.grdOWLMaterialList.Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5);//Cost
       frmOWL.grdOWLMaterialList.Cells[4,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',6);//Source VA-C
       frmOWL.grdOWLMaterialList.Cells[5,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',7);//Vendor
       frmOWL.grdOWLMaterialList.Cells[6,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',9);//Serial #
       frmOWL.grdOWLMaterialList.Cells[7,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2); //IEN 664.22
      end;

  lblNumberOfTotalMaterialEntries.Caption := IntToStr(frmMenu.brkrRPC.Results.Count );

  if frmMenu.brkrRPC.Results.Count > 0 then
       frmOWL.grdOWLMaterialList.RowCount := frmMenu.brkrRPC.Results.Count + 1 //Sizes grid to match results
  else frmOWL.grdOWLMaterialList.RowCount := 2;

//   IEN664_22 := grdOWLMaterialList.Cells[0,1];
   IEN664_22 := grdOWLMaterialList.Cells[7,1];

   end;
  end;
 end;
 grdOWLMaterialList.SortColumn(0);
 grdOWLMaterialList.SortOptions.SortDirection := sdAscending;
 grdOWLMaterialList.Update;
 grdOWLMaterialList.Row := 1;

 CalcMaterialsTotalCost;
end;

procedure TfrmOWL.btnHCPCSDetailClick(Sender: TObject);
begin
  if OWLLockRecord = 0 then
begin
if IEN664_16 <> '' then
 begin
  OWLItemListEditRowID := grdOWLItemList.Row; //Stores Row ID of selected record
  Application.CreateForm(TfrmOWLAddHCPCS, frmOWLAddHCPCS);
  AddHCPCSIEN664_1   := IEN664_1;
  AddHCPCSIEN664_16  := IEN664_16;
  AddHCPCSIEN669_9   := IEN669_9;

  dbsGets664_16.IENS := AddHCPCSIEN664_16 +','+ AddHCPCSIEN664_1;
  dbsGets664_16.GetData;

       frmOWLAddHCPCS.cbxOWLAddHCPCSBillingItem.Visible := True;
       frmOWLAddHCPCS.cbxOWLAddHCPCSBillingItem.SelText := dbsGets664_16.GetField('.01').FMDBExternal;
       frmOWLAddHCPCS.edtOWLAddHCPCSBillingItemIEN.Text := dbsGets664_16.GetField('.01').FMDBInternal;
          frmOWLAddHCPCS.edtOWLAddHCPCSBillingItem.Text := dbsGets664_16.GetField('.01').FMDBExternal;

       frmOWLAddHCPCS.edtOWLAddHCPCS_HCPCSIEN.Text := dbsGets664_16.GetField('13').FMDBInternal;//IEN

      dbsGets661_1.IENS := dbsGets664_16.GetField('13').FMDBInternal; //IEN of the HCPCS code
      dbsGets661_1.GetData;
         frmOWLAddHCPCS.cbxOWLAddHCPCS_HCPCS.Visible := True;
         frmOWLAddHCPCS.cbxOWLAddHCPCS_HCPCS.Text := dbsGets661_1.GetField('.02').FMDBExternal;//Text from 669.1
         frmOWLAddHCPCS.edtOWLAddHCPCS_HCPCS.Text := dbsGets661_1.GetField('.02').FMDBExternal;//Text from 669.1

    frmOWLAddHCPCS.edtOWLAddHCPCSBriefDescription.Text := dbsGets664_16.GetField('6.5').FMDBExternal;

       dbsGets661_1.IENS := dbsGets664_16.GetField('13').FMDBInternal; //IEN of the HCPCS code


       if dbsGets664_16.GetField('2').FMDBExternal <>'' then
            frmOWLAddHCPCS.edtOWLAddHCPCSQty.Value := StrToInt(dbsGets664_16.GetField('2').FMDBExternal)
            else frmOWLAddHCPCS.edtOWLAddHCPCSQty.Value := 0;

       if dbsGets664_16.GetField('11').FMDBExternal <>'' then
           frmOWLAddHCPCS.edtOWLAddHCPCSTotalCost.Value := StrToFloat(dbsGets664_16.GetField('11').FMDBExternal)
           else frmOWLAddHCPCS.edtOWLAddHCPCSTotalCost.Value := 0;

       frmOWLAddHCPCS.edtOWLAddHCPCSCPTModifier.Text := dbsGets664_16.GetField('13.1').FMDBInternal;
       if frmOWLAddHCPCS.edtOWLAddHCPCSCPTModifier.Text = 'LT' then
          frmOWLAddHCPCS.rgrpOWLAddHCPCSCPTModifier.ItemIndex := 0;
       if frmOWLAddHCPCS.edtOWLAddHCPCSCPTModifier.Text = 'RT' then
          frmOWLAddHCPCS.rgrpOWLAddHCPCSCPTModifier.ItemIndex := 1;
       if frmOWLAddHCPCS.edtOWLAddHCPCSCPTModifier.Text = 'LT,RT' then
          frmOWLAddHCPCS.rgrpOWLAddHCPCSCPTModifier.ItemIndex := 2;
       if frmOWLAddHCPCS.edtOWLAddHCPCSCPTModifier.Text = '' then
          frmOWLAddHCPCS.rgrpOWLAddHCPCSCPTModifier.ItemIndex := 3;

       frmOWLAddHCPCS.edtOWLAddHCPCSHiTechItem.Text := dbsGets664_16.GetField('13.2').FMDBInternal;
       if frmOWLAddHCPCS.edtOWLAddHCPCSHiTechItem.Text = '1' then
               frmOWLAddHCPCS.chkOWLAddHCPCSHiTechItem.Checked := True
          else frmOWLAddHCPCS.chkOWLAddHCPCSHiTechItem.Checked := False;

       frmOWLAddHCPCS.edtOWLAddHCPCSTypeOfTransaction.Text := dbsGets664_16.GetField('8').FMDBInternal;
       if frmOWLAddHCPCS.edtOWLAddHCPCSTypeOfTransaction.Text = 'I' then
          frmOWLAddHCPCS.rgrpOWLAddHCPCSTypeOfTransaction.ItemIndex := 0;
       if frmOWLAddHCPCS.edtOWLAddHCPCSTypeOfTransaction.Text = 'X' then
          frmOWLAddHCPCS.rgrpOWLAddHCPCSTypeOfTransaction.ItemIndex := 1;

       frmOWLAddHCPCS.edtOWLAddHCPCSEligibility.Text := dbsGets664_16.GetField('9').FMDBInternal;
       if frmOWLAddHCPCS.edtOWLAddHCPCSEligibility.Text = '2' then
          frmOWLAddHCPCS.rgrpOWLAddHCPCSEligibility.ItemIndex := 0;
       if frmOWLAddHCPCS.edtOWLAddHCPCSEligibility.Text = '3' then
          frmOWLAddHCPCS.rgrpOWLAddHCPCSEligibility.ItemIndex := 1;

       frmOWLAddHCPCS.cbxOWLAddHCPCSVendor.SelText := dbsGets664_16.GetField('15').FMDBExternal;
       frmOWLAddHCPCS.edtOWLAddHCPCSVendorIEN.Text := dbsGets664_16.GetField('15').FMDBInternal;

  frmOWLAddHCPCS.cbxOWLAddHCPCSUnitOfIssue.SelText := dbsGets664_16.GetField('3').FMDBExternal;
     frmOWLAddHCPCS.edtOWLAddHCPCSUnitOfIssue.Text := dbsGets664_16.GetField('3').FMDBExternal;  
  frmOWLAddHCPCS.edtOWLAddHCPCSUnitOfIssueIEN.Text := dbsGets664_16.GetField('3').FMDBInternal;

    frmOWLAddHCPCS.edtOWLAddHCPCSSerialNumber.Text := dbsGets664_16.GetField('12').FMDBExternal;

   dbsGets664_16.GetField('7').FMWordProc := true;  //Must be set to true for memo
   frmOWLAddHCPCS.memOWLAddHCPCSExtendedDescription.Lines := dbsGets664_16.GetField('7').FMWPTextLines;



  frmOWLAddHCPCS.btnOWLHCPCSUpdate.Visible := True;
  frmOWLAddHCPCS.btnOWLHCPCSDelete.Visible := True;

  if frmOWL.grdOWLItemList.Cells[0,grdOWLItemList.Row] = 'Yes' then
     begin
       frmOWLAddHCPCS.lblOWLHCPCSEditType.Caption := 'Primary Item';
       frmOWLAddHCPCS.cbxOWLAddHCPCSUnitOfIssue.Enabled := False;
       frmOWLAddHCPCS.cbxOWLAddHCPCSUnitOfIssue.Color := $00CFFFFF;
       frmOWLAddHCPCS.btnOWLHCPCSDelete.Enabled := False; //Shows btn grayed out
       frmOWLAddHCPCS.lblOWLAddHCPCSPrimaryItem.Visible := True;
       frmOWLAddHCPCS.rgrpOWLAddHCPCSEligibility.Visible := True;
       frmOWLAddHCPCS.rgrpOWLAddHCPCSTypeOfTransaction.Visible := True;
//       frmOWLAddHCPCS.edtOWLAddHCPCSUnitOfIssue.Text := 'Job';
     end;

   if ((grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'COMPLETED') or
       (grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'CANCELLED')) then
     begin
      ShowMessage('                            VIEW ONLY'+#13+#13+
                  'This Work order is COMPLETED/CANCELLED');
      //Set up for read only display
      frmOWLAddHCPCS.btnOWLHCPCSUpdate.Visible := False; 
      frmOWLAddHCPCS.btnOWLHCPCSAdd.Visible := False;
      frmOWLAddHCPCS.btnOWLHCPCSDelete.Visible := False;
      frmOWLAddHCPCS.lblOWLAddHCPCSPrimaryItem.Visible := False;
      frmOWLAddHCPCS.edtOWLAddHCPCSBillingItem.Visible := True;
      frmOWLAddHCPCS.edtOWLAddHCPCS_HCPCS.Visible := True;
      frmOWLAddHCPCS.rgrpOWLAddHCPCSTypeOfTransaction.Enabled := False;
      frmOWLAddHCPCS.rgrpOWLAddHCPCSEligibility.Enabled := False;
      frmOWLAddHCPCS.rgrpOWLAddHCPCSCPTModifier.Enabled := False;
      frmOWLAddHCPCS.chkOWLAddHCPCSHiTechItem.Enabled :=False;

      frmOWLAddHCPCS.edtOWLAddHCPCSBriefDescription.ReadOnly := True;
      frmOWLAddHCPCS.edtOWLAddHCPCSBriefDescription.Color := $00CFFFFF;

      frmOWLAddHCPCS.edtOWLAddHCPCSSerialNumber.ReadOnly := True;
      frmOWLAddHCPCS.edtOWLAddHCPCSSerialNumber.Color := $00CFFFFF;

      frmOWLAddHCPCS.memOWLAddHCPCSExtendedDescription.ReadOnly := True;
      frmOWLAddHCPCS.memOWLAddHCPCSExtendedDescription.Color := $00CFFFFF;

      frmOWLAddHCPCS.cbxOWLAddHCPCSBillingItem.Enabled := False;

      frmOWLAddHCPCS.cbxOWLAddHCPCS_HCPCS.Enabled := False;

     end;


   frmOWLAddHCPCS.ShowModal;
   end
  else
   ShowMessage('Please select a HCPCS to view.');
 end;//check locked record
end;

procedure TfrmOWL.grdOWLItemListRowSelected(Sender: TObject);
begin
// IEN664_2 := '';
// IEN664_2 := grdOWLItemList.Cells[8,grdOWLItemList.Row];
// IEN664_16 := grdOWLItemList.Cells[9,grdOWLItemList.Row];
// OWLItemListRowID := grdOWLItemList.Row;
// btnRefreshMaterialListGrid.Click;
end;

procedure TfrmOWL.grdOWLItemListEndUpdate(Sender: TObject);
begin
// IEN664_2 := '';
// IEN664_2 := grdOWLItemList.Cells[8,grdOWLItemList.Row];
// IEN664_16 := grdOWLItemList.Cells[9,grdOWLItemList.Row];
// OWLItemListRowID := grdOWLItemList.Row;
// btnRefreshMaterialListGrid.Click;
end;

procedure TfrmOWL.grdOWLMaterialListRowSelected(Sender: TObject);
begin
// IEN664_22 := grdOWLMaterialList.Cells[0,grdOWLMaterialList.Row];
end;

procedure TfrmOWL.grdOWLMaterialListClick(Sender: TObject);
begin
 IEN664_22 := grdOWLMaterialList.Cells[7,grdOWLMaterialList.Row];
end;

procedure TfrmOWL.grdOWLItemListClick(Sender: TObject);
begin
 IEN664_2 := '';
 IEN664_2 := grdOWLItemList.Cells[8,grdOWLItemList.Row];
 IEN664_16 := grdOWLItemList.Cells[9,grdOWLItemList.Row];
 OWLItemListRowID := grdOWLItemList.Row;
 btnRefreshMaterialListGrid.Click;
 btnRefreshLaborListGrid.Click;
end;

procedure TfrmOWL.btnClearLaborListGridClick(Sender: TObject);
var
 i : integer;
begin
 begin
  for i :=1 to grdOWLLaborList.RowCount -1 do   //If selected will clear the grid
  grdOWLLaborList.Rows[i].Clear;
  grdOWLLaborList.RowCount := 2;
  grdOWLLaborList.Row := 1;
  OWLLaborListRowID := grdOWLLaborList.Row;
  lblNumberOfLaborEnteries.Caption := '0';
 end;
end;

procedure TfrmOWL.btnRefreshLaborListGridClick(Sender: TObject);
var
 i : integer;
begin
 btnClearLaborListGrid.Click;
 IEN664_2  := '';
 IEN664_3  :='';
 IEN664_33 :='';
 IEN664_2  := grdOWLItemList.Cells[8,grdOWLItemList.Row];
 lblLaborForHCPCS.Caption := 'Labor for HCPCS: '+grdOWLItemList.Cells[1,grdOWLItemList.Row];

 if IEN664_2 <> '' then
  begin


// GET LIST OF ADD ON'S
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL TECH/HOUR/RATE LIST';
    frmMenu.brkrRPC.Param[1].Value := IEN664_2;
    frmMenu.brkrRPC.Param[1].Ptype := literal;

    TRY
     frmMenu.brkrRPC.Call;
    EXCEPT
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

//Fill the Labor Grid
  if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
   begin
     if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then
      begin //b2
       MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
         lblNumberOfLaborEnteries.Caption := '0';
      end  //b2
   else
   begin  //b3
     for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
      begin

       frmOWL.grdOWLLaborList.Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//Date
       frmOWL.grdOWLLaborList.Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);//Technician
       frmOWL.grdOWLLaborList.Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);//Hours
       frmOWL.grdOWLLaborList.Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5);//Rate
       frmOWL.grdOWLLaborList.Cells[4,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',6);//IEN664.2
       frmOWL.grdOWLLaborList.Cells[5,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',7);//DUZ Tech
       frmOWL.grdOWLLaborList.Cells[6,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',8);//IEN664.3
       frmOWL.grdOWLLaborList.Cells[7,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',9);//IEN664.33
      end;

  lblNumberOfLaborEnteries.Caption := IntToStr(frmMenu.brkrRPC.Results.Count );

  if frmMenu.brkrRPC.Results.Count > 0 then
       frmOWL.grdOWLLaborList.RowCount := frmMenu.brkrRPC.Results.Count + 1 //Sizes grid to match results
  else frmOWL.grdOWLLaborList.RowCount := 2;


 IEN664_3  := grdOWLLaborList.Cells[6,1];
 IEN664_33 := grdOWLLaborList.Cells[7,1];

   end;
  end;
 end;
 grdOWLLaborList.SortColumn(0); //Sets and trigers the update
 grdOWLLaborList.SortOptions.SortDirection := sdDescending;
// grdOWLLaborList.Update; //Not needed
 grdOWLLaborList.Row := 1;

 CalcLaborTotalCost;
end;

procedure TfrmOWL.btnLaborAddClick(Sender: TObject);
begin
if OWLLockRecord = 0 then
 begin
 if ((grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'COMPLETED') or
     (grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'CANCELLED')) then
      ShowMessage('Can not add, this Work order is COMPLETED/CANCELLED')
  else
  begin
  Application.CreateForm(TfrmOWLAddLabor, frmOWLAddLabor);
  AddLaborIEN664_1 := IEN664_1;
  AddLaborIEN664_2 := IEN664_2;
  OWLItemListEditRowID := grdOWLItemList.Row; //Stores Row ID of selected record
  OWLLaborListEditRowID := grdOWLLaborList.Row;
  frmOWLAddLabor.dtpOWLLaborDate.Date := Date;
  frmOWLAddLabor.btnOWLLaborAdd.Visible := True;
  frmOWLAddLabor.cbxOWLLaborTechnician.Visible := True;
  frmOWLAddLabor.dtpOWLLaborDate.Visible := True;
  frmOWLAddLabor.ShowModal;
  end;
 end;
end;

procedure TfrmOWL.grdOWLLaborListClick(Sender: TObject);
begin
// IEN664_22 := grdOWLLaborList.Cells[0,grdOWLMaterialList.Row];
 IEN664_3  := grdOWLLaborList.Cells[6,grdOWLLaborList.Row];
 IEN664_33 := grdOWLLaborList.Cells[7,grdOWLLaborList.Row];
end;

procedure TfrmOWL.btnLaborDetailClick(Sender: TObject);
begin
if OWLLockRecord = 0 then
 begin
 if IEN664_3 <> '' then
 begin
  if IEN664_2 <> '' then
   begin
    OWLItemListEditRowID := grdOWLItemList.Row; //Stores Row ID of selected record
    OWLLaborListEditRowID := grdOWLLaborList.Row; //Stores Row ID of selected record

    Application.CreateForm(TfrmOWLAddLabor, frmOWLAddLabor);
    AddLaborIEN664_1 := IEN664_1;
    AddLaborIEN664_2  := IEN664_2;
    AddLaborIEN664_3  := IEN664_3;
    AddLaborIEN664_33 := IEN664_33;



    dbsGets664_3.IENS := AddLaborIEN664_3;
    dbsGets664_3.GetData;

//      frmOWLAddLabor.dtpOWLLaborDate.Date := Str2Date(dbGets664_3.GetField('.01').FMDBExternal);
     frmOWLAddLabor.dtpOWLLaborDate.Visible := True;
        frmOWLAddLabor.dtpOWLLaborDate.Date := Str2Date(grdOWLLaborList.Cells[0,grdOWLLaborList.Row]);
        frmOWLAddLabor.edtOWLLaborDate.Text := grdOWLLaborList.Cells[0,grdOWLLaborList.Row];

    dbsGets664_33.IENS := AddLaborIEN664_33 +','+ AddLaborIEN664_3;
    dbsGets664_33.GetData;

  frmOWLAddLabor.cbxOWLLaborTechnician.SelText := dbsGets664_33.GetField('.01').FMDBExternal;
     frmOWLAddLabor.edtOWLLaborTechnician.Text := dbsGets664_33.GetField('.01').FMDBExternal;
  frmOWLAddLabor.edtOWLLaborTechnicianIEN.Text := dbsGets664_33.GetField('.01').FMDBInternal;
         frmOWLAddLabor.edtOWLLaborHours.Value := StrToFloat(dbsGets664_33.GetField('1').FMDBExternal);
          frmOWLAddLabor.edtOWLLaborRate.Value := StrToFloat(dbsGets664_33.GetField('2').FMDBExternal);

    frmOWLAddLabor.btnOWLLaborUpdate.Visible := True;
    frmOWLAddLabor.btnOWLLaborDelete.Visible := True;
    frmOWLAddLabor.edtOWLLaborTechnician.Visible := True;


     if ((grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'COMPLETED') or
       (grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'CANCELLED')) then
     begin
     ShowMessage('                            VIEW ONLY'+#13+#13+
                  'This Work order is COMPLETED/CANCELLED');
      //Set up for read only
      frmOWLAddLabor.btnOWLLaborUpdate.Visible := False;
      frmOWLAddLabor.btnOWLLaborDelete.Visible := False;

      frmOWLAddLabor.edtOWLLaborDate.Visible := True;

      frmOWLAddLabor.edtOWLLaborHours.ReadOnly := True;
      frmOWLAddLabor.edtOWLLaborHours.Color := $00CFFFFF;

      frmOWLAddLabor.edtOWLLaborRate.ReadOnly := True;
      frmOWLAddLabor.edtOWLLaborRate.Color := $00CFFFFF;


     end;

  frmOWLAddLabor.ShowModal;
 end;
 end
 else
 ShowMessage('Please select a Labor item to view.');
end;
end;

procedure TfrmOWL.btnOWLAssignTechnicianClick(Sender: TObject);
begin
if OWLLockRecord = 0 then
 begin
 if ((grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'COMPLETED') or
    (grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'CANCELLED')) then

    ShowMessage('View only, this Work order is COMPLETED/CANCELLED')
 else
  begin
 if grdOWLWorkOrders.Cells[4,grdOWLWorkOrders.Row] = '' then
  begin
   OWLEditRowID := grdOWLWorkOrders.Row; // Get edit row for later reset
   Application.CreateForm(TfrmOWLAssignTechnician, frmOWLAssignTechnician);
   frmOWLAssignTechnician.ShowModal;
  end
  else
   if MessageDlg('This Work Order has already been assigned.'+#13+
                 '  Do you wish to change the assignment?',mtConfirmation,[mbYes,mbNo],0)= mrYes then
               begin
                 OWLEditRowID := grdOWLWorkOrders.Row; // Get edit row for later reset
                 Application.CreateForm(TfrmOWLAssignTechnician, frmOWLAssignTechnician);
                 frmOWLAssignTechnician.ShowModal;
                end;
  end;
 end;
end; 

procedure TfrmOWL.btnOWLPrintClick(Sender: TObject);
begin
if OWLLockRecord = 0 then
 begin
  Application.CreateForm(TfrmOWLPrint, frmOWLPrint);
  frmOWLPrint.edtSelectedPrinterIEN.Text := '0';
  OWLPrinterIEN := '0';
  frmOWLPrint.edtSelectedPrinter.Text := 'Default VistA Printer';
  frmOWLPrint.ShowModal;
 end;
end; 

procedure TfrmOWL.btnOWLCompleteClick(Sender: TObject);
begin
if OWLLockRecord = 0 then
 begin
   if ((grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'COMPLETED') or
    (grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'CANCELLED')) then

    ShowMessage('View only, this Work order is COMPLETED/CANCELLED')
 else
  begin
    Application.CreateForm(TfrmOWLComplete, frmOWLComplete);

    frmOWLComplete.lblOWLCompleteWorkOrder.Caption := grdOWLWorkOrders.Cells[0,grdOWLWorkOrders.Row];
    frmOWLComplete.lblOWLCompleteWorkOrder.Alignment := taCenter;

    frmOWLComplete.lbOWLlCompletePatient.Caption := OWLPatientName;
    frmOWLComplete.lbOWLlCompletePatient.Alignment := taCenter;

    frmOWLComplete.lblOWLCompleteSSN.Caption := OWLPatientSSN;
    frmOWLComplete.lblOWLCompleteSSN.Alignment := taCenter;

    frmOWLComplete.ShowModal;
  end;
 end;
end;


procedure TfrmOWL.btnView2319Click(Sender: TObject);
begin
if OWL_IEN668 <> '' then
  begin
  Application.CreateForm(TfrmView2319, frmView2319);
  frmView2319.edtVarIEN668.Text  := OWL_IEN668; //sends OWL_IEN668 to View2319
  frmView2319.ShowModal;
  end
 else ShowMessage('Please select a Work Order to view');
end;

procedure TfrmOWL.btnViewCPRSClick(Sender: TObject);
begin
 if OWL_IEN668 <> '' then
  begin
  Application.CreateForm(TfrmViewCPRS, frmViewCPRS);
  frmViewCPRS.edtVarIEN668.Text := OWL_IEN668; //sends OWL_IEN668 to ViewCPRS
  frmViewCPRS.ShowModal;
  end
  else ShowMessage('Please select a Work Order to view');
end;

procedure TfrmOWL.btnViewRequestClick(Sender: TObject);
begin
 if OWL_IEN668 <> '' then
   begin
   Application.CreateForm(TfrmViewReq, frmViewReq);
   frmViewReq.edtVarIEN668.Text := OWL_IEN668; //sends OWL_IEN668 to ViewRequest
   frmViewReq.ShowModal;
   end
   else ShowMessage('Please select a Work Order to view');
end;

procedure TfrmOWL.grdOWLWorkOrdersGetSortStyle(Sender: TObject;
  Col: Integer; var SortStyle: TSortStyle);
begin
if Col=3  then SortStyle := ssDateTime; //Sort OWL Date as date
if Col=5  then SortStyle := ssDateTime; //Sort Consult Date as date  //Can't use here
if Col=12 then SortStyle := ssNumeric;  //Sort IEN664.1 as Number
end;

procedure TfrmOWL.grdOWLLaborListGetSortStyle(Sender: TObject;
  Col: Integer; var SortStyle: TSortStyle);
begin
if Col=0 then SortStyle := ssDateTime; //Sort Date as date
end;

procedure TfrmOWL.grdOWLWorkOrdersGetCellFormat(Sender: TObject; Col,
  Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions);
begin
//if (Col =  0) and (Row > 0) then formatoptions.AlignmentHorz := taRightJustify;
//if Col = 4  then formatoptions.AlignmentHorz := taRightJustify;
//if Col = 5  then formatoptions.AlignmentHorz := taRightJustify;
//if Col = 6  then formatoptions.AlignmentHorz := taRightJustify;
//if Col = 7  then formatoptions.AlignmentHorz := taRightJustify;
//if Col = 8  then formatoptions.AlignmentHorz := taRightJustify;
//if Col = 9  then formatoptions.AlignmentHorz := taRightJustify;
//if Col = 10 then formatoptions.AlignmentHorz := taRightJustify;
//if Col = 11 then formatoptions.AlignmentHorz := taRightJustify;
//if Col = 16 then formatoptions.AlignmentHorz := taRightJustify;
end;

procedure TfrmOWL.grdOWLItemListGetCellFormat(Sender: TObject; Col,
  Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions);
begin
if Col =  3 then formatoptions.AlignmentHorz := taRightJustify;
if Col =  4 then formatoptions.AlignmentHorz := taCenter;

end;

procedure TfrmOWL.grdOWLMaterialListGetCellFormat(Sender: TObject; Col,
  Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions);
begin
if Col =  1 then formatoptions.AlignmentHorz := taRightJustify;
if Col =  2 then formatoptions.AlignmentHorz := taCenter;
if Col =  3 then formatoptions.AlignmentHorz := taRightJustify;
if Col =  4 then formatoptions.AlignmentHorz := taCenter;
end;

procedure TfrmOWL.grdOWLLaborListGetCellFormat(Sender: TObject; Col,
  Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions);
begin
if Col =  2 then formatoptions.AlignmentHorz := taRightJustify;
if Col =  3 then formatoptions.AlignmentHorz := taRightJustify;
if Col =  4 then formatoptions.AlignmentHorz := taCenter;
end;

procedure TfrmOWL.btnOWLCancelClick(Sender: TObject);
begin
 if OWLLockRecord = 0 then
 begin
 if ((grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'COMPLETED') or
    (grdOWLWorkOrders.Cells[2,grdOWLWorkOrders.Row] = 'CANCELLED')) then

    ShowMessage('View only, this Work order is COMPLETED/CANCELLED')
 else
  begin
    Application.CreateForm(TfrmOWLCancel, frmOWLCancel);

    frmOWLCancel.lblOWLCancelWorkOrder.Caption := grdOWLWorkOrders.Cells[0,grdOWLWorkOrders.Row];
    frmOWLCancel.lblOWLCancelWorkOrder.Alignment := taCenter;

    frmOWLCancel.lblOWLCancelPatient.Caption := OWLPatientName;
    frmOWLCancel.lblOWLCancelPatient.Alignment := taCenter;

    frmOWLCancel.lblOWLCancelSSN.Caption := OWLPatientSSN;
    frmOWLCancel.lblOWLCancelSSN.Alignment := taCenter;

    frmOWLCancel.ShowModal;
  end;
 end;
end; 

procedure TfrmOWL.mnuChkPendingAssignmentClick(Sender: TObject);
begin
if chkPending.Checked then
   chkPending.Checked := False
  else
   chkPending.Checked := True;
end;

procedure TfrmOWL.mnuChkAssignedClick(Sender: TObject);
begin
if chkAssigned.Checked then
   chkAssigned.Checked := False
  else
   chkAssigned.Checked := True;
end;

procedure TfrmOWL.mnuChkCompletedClick(Sender: TObject);
begin
if chkCompleted.Checked then
   chkCompleted.Checked := False
  else
   chkCompleted.Checked := True;
end;

procedure TfrmOWL.mnuChkCancelledClick(Sender: TObject);
begin
if chkCancelled.Checked then
   chkCancelled.Checked := False
  else
   chkCancelled.Checked := True;
end;

procedure TfrmOWL.mnuPrintOWLClick(Sender: TObject);
begin
btnOWLPrint.Click;
end;

procedure TfrmOWL.mnuClearClick(Sender: TObject);
begin
btnClear.Click;
end;

procedure TfrmOWL.mnuDisplayRefreshClick(Sender: TObject);
begin
btnDisplay.Click;
end;

procedure TfrmOWL.mnuExitClick(Sender: TObject);
begin
btnClose.Click;
end;

procedure TfrmOWL.mnuAssignTechClick(Sender: TObject);
begin
btnOWLAssignTechnician.Click;
end;

procedure TfrmOWL.mnuAddHCPCSClick(Sender: TObject);
begin
btnHCPCSAdd.Click;
end;

procedure TfrmOWL.mnuAddMaterialClick(Sender: TObject);
begin
btnMaterialAdd.Click;
end;

procedure TfrmOWL.mnuAddLaborClick(Sender: TObject);
begin
btnLaborAdd.Click;
end;

procedure TfrmOWL.mnuDetailEditHCPCSClick(Sender: TObject);
begin
btnHCPCSDetail.Click;
end;

procedure TfrmOWL.mnuPrintOWL2Click(Sender: TObject);
begin
mnuPrintOWL.Click; //Uses &File->Print Owl menu item
end;

procedure TfrmOWL.mnuDetailEditMaterialClick(Sender: TObject);
begin
btnMaterialDetail.Click;
end;

procedure TfrmOWL.mnuDetailEditLaborClick(Sender: TObject);
begin
btnLaborDetail.Click;
end;

procedure TfrmOWL.mnuView2319Click(Sender: TObject);
begin
btnView2319.Click;
end;

procedure TfrmOWL.mnuViewCPRSClick(Sender: TObject);
begin
btnViewCPRS.Click;
end;

procedure TfrmOWL.mnuViewRequestClick(Sender: TObject);
begin
btnViewRequest.Click;
end;

procedure TfrmOWL.mnuDetailClick(Sender: TObject);
begin
btnWorkOrderDetail.Click;
end;

procedure TfrmOWL.mnuCompleteClick(Sender: TObject);
begin
btnOWLComplete.Click;
end;

procedure TfrmOWL.mnuCancelOWLClick(Sender: TObject);
begin
btnOWLCancel.Click;
end;

procedure TfrmOWL.mnuContentsClick(Sender: TObject);
begin
frmMenu.CheckHelpFile;
Application.HelpCommand (Help_Index,0);
end;

procedure TfrmOWL.mnuAboutClick(Sender: TObject);
begin
dlgAbout.ShowModal;
end;

procedure TfrmOWL.FormActivate(Sender: TObject);
begin
 Application.HelpFile := 'PROS_OWL_HELPFILE.CHM'; //Needed here
 btnDisplay.Click;
end;

procedure TfrmOWL.mnuSelectDisplayClick(Sender: TObject);
begin
if chkPending.Checked then mnuChkPendingAssignment.Checked := True    //Sets begining status
  else mnuChkPendingAssignment.Checked := False;
if chkAssigned.Checked then mnuChkAssigned.Checked := True
  else mnuChkAssigned.Checked := False;
if chkCompleted.Checked then mnuChkCompleted.Checked := True
  else mnuChkCompleted.Checked := False;
if chkCancelled.Checked then mnuChkCancelled.Checked := True
  else mnuChkCancelled.Checked := False;
end;

procedure TfrmOWL.appOWLMessage(var Msg: tagMSG;
  var Handled: Boolean);
var
   i: SmallInt;
begin

// ************** For the work order grid
 if grdOWLWorkOrders.Focused then
  begin
    if Msg.message = WM_MOUSEWHEEL then
    begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

      SendMessage(grdOWLWorkOrders.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

       end
      else
       SendMessage(grdOWLWorkOrders.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


      Handled := False;
     end;
  end;

//************** For HCPCS grid

 if grdOWLItemList.Focused then
  begin
    if Msg.message = WM_MOUSEWHEEL then
    begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

      SendMessage(grdOWLItemList.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

       end
      else
       SendMessage(grdOWLItemList.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


      Handled := False;
     end;
  end;

//************** For Material grid

 if grdOWLMaterialList.Focused then
  begin
    if Msg.message = WM_MOUSEWHEEL then
    begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

      SendMessage(grdOWLMaterialList.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

       end
      else
       SendMessage(grdOWLMaterialList.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


      Handled := False;
     end;
  end;

//************** For Labor grid

 if grdOWLLaborList.Focused then
  begin
    if Msg.message = WM_MOUSEWHEEL then
    begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

      SendMessage(grdOWLLaborList.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

       end
      else
       SendMessage(grdOWLLaborList.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


      Handled := False;
     end;
  end;

end;

end.
