(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program add materials.

*******************************************)

unit uPROS_OWL_AddMaterial;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Fmcntrls, Fmcmpnts, Diaccess, ExtCtrls, NumEdit,
  Buttons, CurrEdit, Trpcb, MFunstr, System.UITypes;

type
  TfrmOWLAddMaterial = class(TForm)
    cbxOwlMaterials: TFMComboBoxLookUp;
    dbsLister661: TFMLister;
    lblOWLMaterial_Material: TFMLabel;
    edtOWLMaterialQty: TIntEdit;
    lblOWLMaterialQty: TFMLabel;
    lblOWLMaterialUnitCost: TFMLabel;
    cbxOWLMaterialUnitOfIssue: TFMComboBoxLookUp;
    lblOWLMaterialUnitOfIssue: TFMLabel;
    rgrpOWLMaterialSource: TFMRadioGroup;
    dbsLister420_5: TFMLister;
    edtOWLMaterialSerialNumber: TFMEdit;
    lblOWLMaterialSerialNumber: TFMLabel;
    rgrpOWLMaterialPurchaseStatus: TFMRadioGroup;
    edtOWLMaterialsIEN: TFMEdit;
    edtOWLMaterialUnitOfIssueIEN: TFMEdit;
    edtOWLMaterialPurchaseStatusCode: TFMEdit;
    edtOWLMaterialSourceCode: TFMEdit;
    edtOWLMaterialVendorIEN: TFMEdit;
    dbsLister440: TFMLister;
    cbxOWLMaterialVendor: TFMComboBoxLookUp;
    lblOWLMaterialVendor: TFMLabel;
    btnUpdate664_2: TBitBtn;
    edtOWLMaterialCost: TCurrencyEdit;
    btnOWLMaterialAdd: TBitBtn;
    btnOWLMaterialUpdate: TBitBtn;
    btnOWLMaterialDelete: TBitBtn;
    memOWLMaterialRemarks: TFMMemo;
    lblOWLMaterialRemarks: TFMLabel;
    btnOWLMaterialClose: TBitBtn;
    edtOWLMaterials: TFMEdit;
    edtOWLMaterialUnitOfIssue: TFMEdit;
    edtOWLMaterialVendor: TFMEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbxOwlMaterialsSelect(Sender: TObject);
    procedure rgrpOWLMaterialSourceClick(Sender: TObject);
    procedure cbxOWLMaterialVendorSelect(Sender: TObject);
    procedure rgrpOWLMaterialPurchaseStatusClick(Sender: TObject);
    procedure cbxOWLMaterialUnitOfIssueSelect(Sender: TObject);
    procedure btnUpdate664_2Click(Sender: TObject);
    procedure btnOWLMaterialAddClick(Sender: TObject);
    procedure btnOWLMaterialUpdateClick(Sender: TObject);
    procedure btnOWLMaterialDeleteClick(Sender: TObject);
    procedure btnOWLMaterialCloseClick(Sender: TObject);
    procedure cbxOwlMaterialsDropDown(Sender: TObject);
    procedure cbxOwlMaterialsExit(Sender: TObject);
    procedure cbxOWLMaterialUnitOfIssueExit(Sender: TObject);
    procedure edtOWLMaterialQtyExit(Sender: TObject);
    procedure edtOWLMaterialQtyKeyPress(Sender: TObject; var Key: Char);
    procedure edtOWLMaterialCostEnter(Sender: TObject);
    procedure edtOWLMaterialCostExit(Sender: TObject);
    procedure edtOWLMaterialSerialNumberKeyPress(Sender: TObject;
      var Key: Char);
    procedure cbxOWLMaterialVendorExit(Sender: TObject);
    procedure edtOWLMaterialSerialNumberExit(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLAddMaterial: TfrmOWLAddMaterial;
  AddMaterialIEN664_1, AddMaterialIEN664_2, AddMaterialIEN664_22,
  MaterialRecordFilingType, BaseCodeFilingType : string;

implementation

uses Pros_Menu,uPROS_OWL;

{$R *.dfm}

procedure TfrmOWLAddMaterial.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 Release;
end;

procedure TfrmOWLAddMaterial.cbxOwlMaterialsSelect(Sender: TObject);
begin
  if cbxOWLMaterialUnitOfIssue.ItemIndex >= 0 then
   begin
     cbxOWLMaterialUnitOfIssue.Perform(EM_SCROLLCARET,0,0);
     edtOWLMaterialUnitOfIssueIEN.Text := cbxOWLMaterialUnitOfIssue.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddMaterial.rgrpOWLMaterialSourceClick(Sender: TObject);
begin
 edtOWLMaterialSourceCode.Text
  := rgrpOWLMaterialSource.FMInternalCodes.Strings[rgrpOWLMaterialSource.ItemIndex];
end;

procedure TfrmOWLAddMaterial.cbxOWLMaterialVendorSelect(Sender: TObject);
begin
if cbxOWLMaterialVendor.ItemIndex >= 0 then
   begin
    edtOWLMaterialVendorIEN.Text := cbxOWLMaterialVendor.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddMaterial.rgrpOWLMaterialPurchaseStatusClick(
  Sender: TObject);
begin
 edtOWLMaterialPurchaseStatusCode.Text
  := rgrpOWLMaterialPurchaseStatus.FMInternalCodes.Strings[rgrpOWLMaterialPurchaseStatus.ItemIndex];
end;

procedure TfrmOWLAddMaterial.cbxOWLMaterialUnitOfIssueSelect(
  Sender: TObject);
begin
  if cbxOWLMaterialUnitOfIssue.ItemIndex >= 0 then
     begin
      cbxOWLMaterialUnitOfIssue.Perform(EM_SCROLLCARET,0,0);
      edtOWLMaterialUnitOfIssueIEN.Text := cbxOWLMaterialUnitOfIssue.GetSelectedRecord.IEN;
     end;
end;

procedure TfrmOWLAddMaterial.btnUpdate664_2Click(Sender: TObject);
var
           r : integer;
 OrgIEN664_1 : string;
begin
   begin
     if (edtOWLMaterialsIEN.Text = '') then
     MessageDlg('Please select a Material',mtInformation, [mbOk],0)
   else
   begin
     if (edtOWLMaterialQty.Value < 1) then //should be 0 for production
     MessageDlg('Please enter a Quantity',mtInformation, [mbOk],0)
   else
   begin
     if (edtOWLMaterialUnitOfIssueIEN.Text = '') then
     MessageDlg('Please select a Unit of Issue',mtInformation, [mbOk],0)
   else
   begin
     if (edtOWLMaterialCost.Value > 9999999.99) then
     MessageDlg('Please enter a COST less that $9,999,999.99',mtInformation, [mbOk],0)
   else
//   begin  //per user - not mandatory
//     if (edtOWLMaterialVendorIEN.Text = '') then
//     MessageDlg('Please select a Vendor',mtInformation, [mbOk],0)
//   else

   begin
  // Send

        frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL ENTER/EDIT ADD ON';
        frmMenu.brkrRPC.Param[1].Value := MaterialRecordFilingType;    //A-Add(Edit) D-Delete
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := AddMaterialIEN664_1;    //OWL
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := AddMaterialIEN664_2;  //Add On File
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Value := AddMaterialIEN664_22; //Add On Multiple (Null if add)
        frmMenu.brkrRPC.Param[4].PType := literal;
        frmMenu.brkrRPC.Param[5].Value := edtOWLMAterialsIEN.Text;//Material; Piece(IEN664_1,',',1);
        frmMenu.brkrRPC.Param[5].PType := literal;
        frmMenu.brkrRPC.Param[6].Value := edtOWLMaterialQty.Text;// IntToStr(edtOWLMaterialCost.Value);    //OWL
        frmMenu.brkrRPC.Param[6].PType := literal;
        frmMenu.brkrRPC.Param[7].Value := FormatCurr('0.00',edtOWLMaterialCost.Value);    //OWL
        frmMenu.brkrRPC.Param[7].PType := literal;
        frmMenu.brkrRPC.Param[8].Value := edtOWLMaterialSourceCode.Text;    //OWL
        frmMenu.brkrRPC.Param[8].PType := literal;
        frmMenu.brkrRPC.Param[9].Value := edtOWLMaterialVendorIEN.Text;    //OWL
        frmMenu.brkrRPC.Param[9].PType := literal;
        frmMenu.brkrRPC.Param[10].Value := edtOWLMaterialUnitOfIssueIEN.Text;    //OWL
        frmMenu.brkrRPC.Param[10].PType := literal;
        frmMenu.brkrRPC.Param[11].Value := edtOWLMaterialSerialNumber.Text ;    //OWL
        frmMenu.brkrRPC.Param[11].PType := literal;
        frmMenu.brkrRPC.Param[12].Value := edtOWLMaterialPurchaseStatusCode.Text;    //OWL
        frmMenu.brkrRPC.Param[12].PType := literal;
        frmMenu.brkrRPC.Param[13].Mult.Assign (memOWLMaterialRemarks.Lines);    //Remarks
        frmMenu.brkrRPC.Param[13].PType := list;
        frmMenu.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    Try
    //
  frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


 if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
   begin
     if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then
      begin //b2
       MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
      end;
   end;

// If no tech assigned auto assign stuffs user DUZ as tech, refreshes OWL
    if frmOWL.grdOWLWorkOrders.Cells[4,frmOWL.grdOWLWorkOrders.Row] = '' then //not assigned yet
    begin
    OrgIEN664_1 := IEN664_1;
    if frmOwl.chkAssigned.Checked = false then
       ShowMessage('NOTICE: You are currently not viewing work orders with the Status of "ASSIGNED".'+#13+
                   ''+#13+
                   'Because this work order now has a Status of "ASSIGNED" it has been removed from the list.'+#13+
                   ''+#13+
                   'Check the Status "ASSIGNED" then click Refresh to continue with this Work Order.');
    frmOWL.btnDisplay.Click;

  //If ASSIGNED is cheked for display, finds record and selects
   for r := 1 to frmOWL.grdOWLWorkOrders.RowCount -1  do
     begin
       if frmOWL.grdOWLWorkOrders.Cells[12,r] = OrgIEN664_1 then
          frmOWL.grdOWLWorkOrders.Row := r;
     end;
    end
//******************************
  else
   begin

   frmOWL.btnRefreshItemListGrid.Click;
   frmOWL.grdOWLItemList.Row := OWLItemListEditRowID; //Select current row after refersh

   frmOWL.btnRefreshMaterialListGrid.Click;
   If MaterialRecordFilingType <> 'D' then
     frmOWL.grdOWLMaterialList.Row := OWLMaterialListEditRowID;//Select current row after refersh
   end;
 Close;

     end;
    end;
   end;
  end;
 end;
end;

procedure TfrmOWLAddMaterial.btnOWLMaterialAddClick(Sender: TObject);
begin
MaterialRecordFilingType := 'A';
AddMaterialIEN664_22 := ''; //Must be null for add to work
btnUpdate664_2.Click;
end;

procedure TfrmOWLAddMaterial.btnOWLMaterialUpdateClick(Sender: TObject);
begin
MaterialRecordFilingType := 'A'; // IEN664.22 neeeded to update record
btnUpdate664_2.Click;
end;

procedure TfrmOWLAddMaterial.btnOWLMaterialDeleteClick(Sender: TObject);
begin
if MessageDlg('Confirm delete?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
   MaterialRecordFilingType := 'D';
   btnUpdate664_2.Click;
  end;
end;

procedure TfrmOWLAddMaterial.btnOWLMaterialCloseClick(Sender: TObject);
begin
if MessageDlg('Any changes will be discarded.',
    mtInformation, [mbOk], 0) = mrOk then
Close;
end;

procedure TfrmOWLAddMaterial.cbxOwlMaterialsDropDown(Sender: TObject);
begin
cbxOWLMaterials.Perform(CB_SETDROPPEDWIDTH, 350, 0);
end;

procedure TfrmOWLAddMaterial.cbxOwlMaterialsExit(Sender: TObject);
begin
 if cbxOWLMaterials.Text <>'' then
  begin
  if cbxOWLMaterials.ItemIndex >= 0 then
   begin
     cbxOWLMaterials.Perform(EM_SCROLLCARET,0,0);
     edtOWLMaterialsIEN.Text := cbxOWLMaterials.GetSelectedRecord.IEN;
   end
   else
   edtOWLMaterialsIEN.Text := '';
  end;
end;

procedure TfrmOWLAddMaterial.cbxOWLMaterialUnitOfIssueExit(
  Sender: TObject);
begin
 edtOWLMaterialUnitOfIssueIEN.Text := '';
 
  if cbxOWLMaterialUnitOfIssue.ItemIndex >= 0 then
     begin
      cbxOWLMaterialUnitOfIssue.Perform(EM_SCROLLCARET,0,0);
      edtOWLMaterialUnitOfIssueIEN.Text := cbxOWLMaterialUnitOfIssue.GetSelectedRecord.IEN;
     end;
end;

procedure TfrmOWLAddMaterial.edtOWLMaterialQtyExit(Sender: TObject);
begin
if ((edtOWLMaterialQty.Value > 999) or (edtOWLMaterialQty.Value < 0)) then
 begin
  ShowMessage('Please enter a valid QUANTITY less that 1000');
  edtOWLMaterialQty.SetFocus;
 end;
if edtOWLMaterialQty.Text = '' then
   edtOWLMaterialQty.Value := 0;
end;

procedure TfrmOWLAddMaterial.edtOWLMaterialQtyKeyPress(Sender: TObject;
  var Key: Char);
begin
 if edtOWLMaterialQty.Value > 9999 then
  begin
  ShowMessage('Please enter a valid QUANTITY less that 9,999');
  Key := #8; //Backspace
  end;
end;

procedure TfrmOWLAddMaterial.edtOWLMaterialCostEnter(Sender: TObject);
begin
edtOWLMaterialCost.SelectAll;
end;

procedure TfrmOWLAddMaterial.edtOWLMaterialCostExit(Sender: TObject);
begin
 if ((edtOWLMaterialCost.Value > 9999999.99) or (edtOWLMaterialCost.Value < 0)) then
  begin
  ShowMessage('Please enter a valid COST less that $9,999,999.99');
  edtOWLMaterialCost.SetFocus;
  end;
if edtOWLMaterialCost.Text = '' then
   edtOWLMaterialCost.Value := 0;
end;

procedure TfrmOWLAddMaterial.edtOWLMaterialSerialNumberKeyPress(
  Sender: TObject; var Key: Char);
begin
if edtOWLMaterialSerialNumber.GetTextLen > 50 then      //KLN Needs to set min at 3
  begin
   ShowMessage('You have exceded the 50 character maximum');
   Key := #8; //Backspace
  end;
end;

procedure TfrmOWLAddMaterial.cbxOWLMaterialVendorExit(Sender: TObject);
begin
edtOWLMaterialVendorIEN.Text := '';

if cbxOWLMaterialVendor.ItemIndex >= 0 then
   begin
    cbxOWLMaterialVendor.Perform(EM_SCROLLCARET,0,0);
    edtOWLMaterialVendorIEN.Text := cbxOWLMaterialVendor.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddMaterial.edtOWLMaterialSerialNumberExit(
  Sender: TObject);
begin
 if edtOWLMaterialSerialNumber.Text <> '' then
   begin
    if Length(edtOWLMaterialSerialNumber.Text) < 3 then
       begin
       ShowMessage('Please enter a minimum of 3 charactors or EMPTY');
       edtOWLMaterialSerialNumber.SetFocus;
       end;
    if Length(edtOWLMaterialSerialNumber.Text) > 20 then
       begin
       ShowMessage('The text entered exceeds the permited length of 20 characters');
       edtOWLMaterialSerialNumber.SetFocus;
       end;
   end;
end;

procedure TfrmOWLAddMaterial.FormKeyPress(Sender: TObject; var Key: Char);
begin
if Key = #27 then Close;
end;

end.
