(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program cancel work order.

*******************************************)

unit uPROS_OWL_Cancel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Fmcntrls, Trpcb, MFunStr, ExtCtrls, System.UITypes;

type
  TfrmOWLCancel = class(TForm)
    lblOWLCancelBanner1: TFMLabel;
    lblOWLCancelWorkOrder: TFMLabel;
    lblOWLCancelPatient: TFMLabel;
    lblOWLCancelSSN: TFMLabel;
    lblOWLCancelBanner2: TFMLabel;
    lblCancelBanner3: TFMLabel;
    chkOWLCancelClone: TFMCheckBox;
    memOWLCancelMessage: TFMMemo;
    lblCancelNote: TFMLabel;
    btnCancelWorkOrder: TBitBtn;
    btnOWLCancelClose: TBitBtn;
    imgCancel1: TImage;
    imgCancel2: TImage;
    procedure OWLCancel;
    procedure btnCancelWorkOrderClick(Sender: TObject);
    procedure btnOWLCancelCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLCancel: TfrmOWLCancel;

implementation

uses uPROS_OWL, Pros_Menu, PROS_POC_PurOrderConsult;

{$R *.dfm}

procedure TfrmOWLCancel.OWLCancel;
var
  StatusFlag : string;
           r : integer;
begin
//   memOWLCancelMessage.Lines.Clear;
   begin
      memOWLCancelMessage.Lines.Insert(0,'Prosthetic W.O. '
          +frmOWL.grdOWLWorkOrders.Cells[0,frmOWL.grdOWLWorkOrders.Row]+' Cancelled - '
          +frmOWL.grdOWLWorkOrders.Cells[1,frmOWL.grdOWLWorkOrders.Row]);
   end;

  begin
   if chkOWLCancelClone.Checked then StatusFlag := '4' else //Create a clone
      StatusFlag := '3'; //Do not create a clone
  end;

  // Send

        frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL SUSPENSE ACTIONS';
        frmMenu.brkrRPC.Param[1].Value := OWL_IEN668;    //Selected Consult IENs
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := UserDUZ;  //P.A.'s DUZ
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := StatusFlag;
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Value := Piece(IEN664_1,',',1);// IEN 664.1
        frmMenu.brkrRPC.Param[4].PType := literal;
        frmMenu.brkrRPC.Param[5].Mult.Assign (memOWLCancelMessage.Lines);//
        frmMenu.brkrRPC.Param[5].PType := list;
        frmMenu.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

   memOWLCancelMessage.Enabled:= False;  //grays out note with added header before sending

    if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
        MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);

    if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then  //Ok
       begin
        for r := 1 to frmPurOrderConsult.grdConsult.RowCount -1  do    //Get line count
         begin
          If frmPurOrderConsult.grdConsult.Cells[9,r] = OWL_IEN668 then //Finds POC record in grid
             frmPurOrderConsult.grdConsult.Cells[8,r] := 'CANCELLED'; //Update STATUS in grid
         end;
        ShowMessage(Piece(frmMenu.brkrRPC.Results[0],'^',2));
      end;
end;



procedure TfrmOWLCancel.btnCancelWorkOrderClick(Sender: TObject);
begin
 if MessageDlg('Are you sure you wish to CANCEL this Work Order?',
                mtConfirmation,[mbYes,mbNo],0) = mrYes then
               begin
                OWLCancel;
                Close;
               end;
end;

procedure TfrmOWLCancel.btnOWLCancelCloseClick(Sender: TObject);
begin
Close;
end;

procedure TfrmOWLCancel.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
frmOWL.btnDisplay.Click;
Release;
end;

end.
