(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program complete work order.

*******************************************)

unit uPROS_OWL_Complete;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Fmcntrls, Trpcb, MFunStr, ExtCtrls, System.UITypes;

type
  TfrmOWLComplete = class(TForm)
    lblOWLCompleteBanner: TFMLabel;
    lblOWLCompleteWorkOrder: TFMLabel;
    lbOWLlCompletePatient: TFMLabel;
    lblOWLCompleteSSN: TFMLabel;
    lblOWLCompleteBanner3: TFMLabel;
    lblOWLCompleteBanner2: TFMLabel;
    btnOWLComplete: TBitBtn;
    memOWLCompleteMessage: TFMMemo;
    btnOWLCompleteClose: TBitBtn;
    lblCompleteNote: TFMLabel;
    imgComplete1: TImage;
    imgComplete2: TImage;
    procedure OWLComplete;
    procedure btnOWLCompleteClick(Sender: TObject);
    procedure btnOWLCompleteCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLComplete: TfrmOWLComplete;

implementation

uses Pros_Menu, uPROS_OWL, PROS_POC_PurOrderConsult;

{$R *.dfm}

procedure TfrmOWLComplete.OWLComplete;
var
  StatusFlag : string;
           r : integer;
begin
//   memOWLCompleteMessage.Lines.Clear;
   begin
      memOWLCompleteMessage.Lines.Insert(0,'Prosthetic W.O. '
          +frmOWL.grdOWLWorkOrders.Cells[0,frmOWL.grdOWLWorkOrders.Row]+' Completed - '
          +frmOWL.grdOWLWorkOrders.Cells[1,frmOWL.grdOWLWorkOrders.Row]);
   end;

  begin
   StatusFlag := '1'; //Complete
  end;

  // Send

        frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL SUSPENSE ACTIONS';
        frmMenu.brkrRPC.Param[1].Value := OWL_IEN668;    //Selected Consult IENs
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := UserDUZ;  //P.A.'s DUZ
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := StatusFlag;
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Value := Piece(IEN664_1,',',1);// IEN 664.1
        frmMenu.brkrRPC.Param[4].PType := literal;
        frmMenu.brkrRPC.Param[5].Mult.Assign (memOWLCompleteMessage.Lines);//
        frmMenu.brkrRPC.Param[5].PType := list;
        frmMenu.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

   memOWLCompleteMessage.Enabled:= False;  //grays out note with added header before sending

    if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
        MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);

    if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then  //Ok
       begin
        for r := 1 to frmPurOrderConsult.grdConsult.RowCount -1  do    //Get line count
         begin
          If frmPurOrderConsult.grdConsult.Cells[9,r] = OWL_IEN668 then //Finds POC record in grid
             frmPurOrderConsult.grdConsult.Cells[8,r] := 'CLOSED'; //Update STATUS in grid
         end;
        ShowMessage(Piece(frmMenu.brkrRPC.Results[0],'^',2));
      end;
end;

procedure TfrmOWLComplete.btnOWLCompleteClick(Sender: TObject);
begin
if MessageDlg('Are you sure you wish to COMPLETE this Work Order?',
                mtConfirmation,[mbYes,mbNo],0) = mrYes then
               begin
                OWLComplete;
                Close;
               end;
end;

procedure TfrmOWLComplete.btnOWLCompleteCloseClick(Sender: TObject);
begin
Close;
end;

procedure TfrmOWLComplete.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
frmOWL.btnDisplay.Click;
Release;
end;

end.
