(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program create a work order.

*******************************************)

unit uPROS_OWL_Create;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Fmcntrls, ExtCtrls, Fmcmpnts, Trpcb, Diaccess, Buttons, ESBDates,
  Vcl.Grids, UExtendedStringGrid, NumEdit, MFunStr, ComCtrls, System.UITypes;

type
  TfrmOWLCreate = class(TForm)
    edtDate: TFMEdit;
    edtRequestingStation: TFMEdit;
    edtReceivingStation: TFMEdit;
    edtNPPDStation: TFMEdit;
    cbxSelRequestingStation: TFMComboBoxLookUp;
    cbxSelReceivingStation: TFMComboBoxLookUp;
    lblNPPDStation: TLabel;
    lblRequestingStation: TLabel;
    lblReceivingStation: TLabel;
    lblCreateDate: TLabel;
    btnCreateLabWorkOrder: TBitBtn;
    btnView2319: TBitBtn;
    btnViewCPRS: TBitBtn;
    btnViewRequest: TBitBtn;
    dbsStationLister669_9: TFMLister;
    dbsStationGets669_9: TFMGets;
    edtNPPDStationIEN: TFMEdit;
    edtRequestingStationIEN: TFMEdit;
    edtReceivingStationIEN: TFMEdit;
    edtLabType: TFMEdit;
    edtEligibility: TFMEdit;
    dbsFiler664_1: TFMFiler;
    dbsValidator664_1: TFMValidator;
    lblPatientName: TLabel;
    lblPatientSSN: TLabel;
    dbsStationLister4: TFMLister;
    dbsStationGets4: TFMGets;
    rgrpLabType: TFMRadioGroup;
    rgrpEligibility: TFMRadioGroup;
    cbxNPPDStation: TFMComboBoxLookUp;
    grpPrimaryItemInformation: TGroupBox;
    cbxBillingItem: TFMComboBoxLookUp;
    lblBillingItem: TLabel;
    cbxHCPCS: TFMComboBoxLookUp;
    lblHCPCS: TLabel;
    lblUnitOfIssue: TLabel;
    lblQty: TLabel;
    cbxUnitOfIssue: TFMComboBoxLookUp;
    dbsBillingItemLister: TFMLister;
    dbsUnitOfIssueLister: TFMLister;
    dbsBillingItemGets: TFMGets;
    dbsUnitOfIssueGets: TFMGets;
    edtQty: TIntEdit;
    grdMiniDis: TSortGrid;
    edtUnitOfIssueIEN: TFMEdit;
    edtBillingItemIEN: TFMEdit;
    edtHCPCSIEN: TFMEdit;
    dbsHCPCSLister: TFMLister;
    lblSiteNumber: TLabel;
    btnExtDesc: TBitBtn;
    rgrpTypeOfTransaction: TFMRadioGroup;
    edtTypeOfTransaction: TFMEdit;
    memExtDescSend: TFMMemo;
    pnlOWLStation: TPanel;
    btnQuitWork: TBitBtn;
    dbsFiler669_9: TFMFiler;
    memPostAutoNoteToCPRS: TFMMemo;
    edtUnitOfIssue: TFMEdit;
    grpOWLSelectedPrinter: TGroupBox;
    btnOWLChangePrinterLocation: TBitBtn;
    edtOWLSelectedPrinter: TFMEdit;
    btnOWLWorkOrderPrint: TBitBtn;
    memOWLWorkOrder: TRichEdit;
    rgrpCPTModifier: TFMRadioGroup;
    edtCPTModifier: TFMEdit;
    grpOWLDateRequired: TGroupBox;
    edtOWLDateRequired: TFMEdit;
    btnOWLDateRequired: TBitBtn;
    procedure cbxSelRequestingStationDropDown(Sender: TObject);
    procedure cbxSelReceivingStationDropDown(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbxSelRequestingStationSelect(Sender: TObject);
    procedure cbxSelReceivingStationSelect(Sender: TObject);
    procedure btnCreateLabWorkOrderClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rgrpLabTypeClick(Sender: TObject);
    procedure rgrpEligibilityClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure cbxHCPCSEnter(Sender: TObject);
    procedure cbxUnitOfIssueExit(Sender: TObject);
    procedure cbxBillingItemExit(Sender: TObject);
    procedure cbxHCPCSExit(Sender: TObject);
    procedure cbxUnitOfIssueKeyPress(Sender: TObject; var Key: Char);
    procedure cbxNPPDStationDropDown(Sender: TObject);
    procedure btnExtDescClick(Sender: TObject);
    procedure rgrpTypeOfTransactionClick(Sender: TObject);
    procedure edtQtyEnter(Sender: TObject);
    procedure cbxNPPDStationExit(Sender: TObject);
    procedure btnQuitWorkClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cbxNPPDStationSelect(Sender: TObject);
    procedure btnView2319Click(Sender: TObject);
    procedure btnViewCPRSClick(Sender: TObject);
    procedure btnViewRequestClick(Sender: TObject);
    procedure PostAutoNoteToCPRS;
    procedure btnOWLChangePrinterLocationClick(Sender: TObject);
    procedure btnOWLWorkOrderPrintClick(Sender: TObject);
    procedure cbxSelReceivingStationExit(Sender: TObject);
    procedure cbxSelRequestingStationExit(Sender: TObject);
    procedure rgrpCPTModifierClick(Sender: TObject);
    procedure edtQtyExit(Sender: TObject);
    procedure btnOWLDateRequiredClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edtOWLDateRequiredChange(Sender: TObject);
    procedure cbxBillingItemDropDown(Sender: TObject);
    procedure cbxHCPCSDropDown(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLCreate: TfrmOWLCreate;
  OWLMDate, OWLDateRequiredMDate,IEN664_1, IEN664_16, NPPDStationIEN, WorkOrderNumber,
  OWLCreatePrinterIEN, OWLPrinterName : string;

implementation

uses PROS_Menu, PROS_POC_PurOrderConsult, PROS_POC_CloseSuspense,
  uPROS_OWL_ExtDesc, PROS_DOR_View2319, PROS_DOR_ViewCPRS, PROS_DOR_ViewReq,
  uPROS_OWL_SelPrinter, uPROS_OWL_SelDateRequired;

{$R *.dfm}

procedure TfrmOWLCreate.PostAutoNoteToCPRS;
var
Status, StatusFlag : string;
CMaskTemp : String[15];

begin
   memPostAutoNoteToCPRS.Lines.Clear;
   begin
     if rgrpLabType.ItemIndex = 0 then  //Posts a default lab note at creation
        memPostAutoNoteToCPRS.Lines.Add('Prosthetic Work Order '+WorkOrderNumber+' Created - Orthotics/Prosthetics Lab');
     if rgrpLabType.ItemIndex = 1 then
        memPostAutoNoteToCPRS.Lines.Add('Prosthetic Work Order '+WorkOrderNumber+' Created - Optical Lab');
     if rgrpLabType.ItemIndex = 2 then
        memPostAutoNoteToCPRS.Lines.Add('Prosthetic Work Order '+WorkOrderNumber+' Created - Restoration Lab');
     if rgrpLabType.ItemIndex = 3 then
        memPostAutoNoteToCPRS.Lines.Add('Prosthetic Work Order '+WorkOrderNumber+' Created - Wheelchair Repair');
   end;

  begin
   StatusFlag := '';
  if Copy(CompletionMask,5,1) = '0' then
     begin
      StatusFlag := '0';   //Consult is Open - file as Pending
      Status := 'PENDING';
     end;
   if Copy(CompletionMask,5,1) = '1' then
     begin
      StatusFlag := '2';   //Consult in Pending - file note as Other
      Status := 'PENDING';
     end;
  end;

  // Send

        frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL SUSPENSE ACTIONS';
        frmMenu.brkrRPC.Param[1].Value := IEN668;    //Selected Consult IENs
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := PurchasingAgentID;  //P.A.'s DUZ
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := StatusFlag;
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Value := Piece(IEN664_1,',',1);// IEN 664.1
        frmMenu.brkrRPC.Param[4].PType := literal;
        frmMenu.brkrRPC.Param[5].Mult.Assign (memPostAutoNoteToCPRS.Lines);// := Mult1;    //
        frmMenu.brkrRPC.Param[5].PType := list;
        frmMenu.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
           begin
             begin
              CMaskTemp := '';
              CMaskTemp := CompletionMask;
              Delete (CMaskTemp,10,1);
              Insert('0',CMaskTemp,10); //Suspense not updated
              CompletionMask := CMaskTemp;
              CMaskTemp := '';
             end;
            MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
           end;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then  //Ok
           begin
            begin
             CMaskTemp := '';
             CMaskTemp := CompletionMask;
             Delete (CMaskTemp,10,1);
             Insert('1',CMaskTemp,10); //Update suspense/Post Note to CPRS ok
             CompletionMask := CMaskTemp;
             CMaskTemp := '';
            end;

            frmPurOrderConsult.grdConsult.Cells[0,RowID] := 'Yes'; //Update DONE in grid
            frmPurOrderConsult.grdConsult.Cells[1,RowID] := 'LAB'; //Update TYPE in grid
            frmPurOrderConsult.grdConsult.Cells[8,RowID] := Status; //Update STATUS in grid
            frmPurOrderConsult.grdConsult.Cells[11,RowID] := Piece(IEN664_1,',',1); //IEN 664.1
            frmPurOrderConsult.grdConsult.Cells[12,RowID] := WorkOrderNumber;

            ShowMessage(Piece(frmMenu.brkrRPC.Results[0],'^',2));

//            frmOWLPostCPRSNote.Close;
//            frmOWLCreate.Close;
           end;
end;

procedure TfrmOWLCreate.cbxSelRequestingStationDropDown(Sender: TObject);
begin
cbxSelRequestingStation.Perform(CB_SETDROPPEDWIDTH, 350, 0);
end;

procedure TfrmOWLCreate.cbxSelReceivingStationDropDown(Sender: TObject);
begin
cbxSelReceivingStation.Perform(CB_SETDROPPEDWIDTH, 350, 0);
end;

procedure TfrmOWLCreate.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  CompletionMask := '000000000000000';  //Global Variable reset
  Release;
  //RRA RMPR*175 302837
  frmPurOrderConsult.SuspenseUnLockRecord
end;

procedure TfrmOWLCreate.cbxSelRequestingStationSelect(Sender: TObject);
begin
   if cbxSelRequestingStation.ItemIndex >= 0 then
   begin
    edtRequestingStationIEN.Text := cbxSelRequestingStation.GetSelectedRecord.IEN;
    dbsStationGets4.IENS := cbxSelRequestingStation.GetSelectedRecord.IEN;
    cbxSelRequestingStation.Perform(EM_SCROLLCARET,0,0);// to set display Lft Just
    dbsStationGets4.GetData;
    edtRequestingStation.Text := dbsStationGets4.GetField('99').FMDBExternal;
   end;

end;

procedure TfrmOWLCreate.cbxSelReceivingStationSelect(Sender: TObject);
begin
   if cbxSelReceivingStation.ItemIndex >= 0 then
   begin
    edtReceivingStationIEN.Text := cbxSelReceivingStation.GetSelectedRecord.IEN;
    dbsStationGets4.IENS := cbxSelReceivingStation.GetSelectedRecord.IEN;
    dbsStationGets4.GetData;
    edtReceivingStation.Text := dbsStationGets4.GetField('99').FMDBExternal;
   end;
end;

procedure TfrmOWLCreate.btnCreateLabWorkOrderClick(Sender: TObject);
var
GetIEN664_1, MultiIEN664_1 : string;
CMaskTemp : String[15];
        i : integer;

begin

  begin
   if rgrpLabType.ItemIndex = -1 then
     MessageDlg('Please select a Lab Type',
       mtInformation, [mbOk],0)
  else
  begin
   if (edtNPPDStationIEN.Text = '') or (edtNPPDStation.Text = '') then 
     MessageDlg('Please select the NPPD Station',
       mtInformation, [mbOk],0)
  else
  begin
    if (edtRequestingStationIEN.Text = '') or (edtRequestingStation.Text = '')then
    MessageDlg('Please select the Requesting Station',
       mtInformation, [mbOk],0)
  else
  begin
   if (edtReceivingStationIEN.Text = '') or (edtReceivingStation.Text = '')  then
     MessageDlg('Please select the Receiving Station',
       mtInformation, [mbOk],0)
  else
  begin
   if rgrpEligibility.ItemIndex = -1 then
     MessageDlg('Please select a Patient Catagory',
       mtInformation, [mbOk],0)
  else
  begin
   if rgrpTypeOfTransaction.ItemIndex = -1 then
     MessageDlg('Please select a Type of Transaction',
       mtInformation, [mbOk],0)
  else
  begin
   if edtBillingItemIEN.Text = '' then //should be '' for production
     MessageDlg('Please select the Billing Item',
       mtInformation, [mbOk],0)
  else
  begin
   if edtHCPCSIEN.Text = '' then //should be '' for production
     MessageDlg('Please select a HCPCS',
       mtInformation, [mbOk],0)
  else
  begin
   if edtQTY.Value < 1 then //should be 0 for production
     MessageDlg('Please enter a Quantity',
       mtInformation, [mbOk],0)
  else
  begin
   if ( (rgrpLabType.ItemIndex = 0) // or (rgrpLabType.ItemIndex = 2)) // Removed per user
         and (rgrpCPTModifier.ItemIndex = 3) ) then
              MessageDlg('Please select a CPT Modifier',
              mtInformation, [mbOk],0)
  else
  begin
   if edtUnitOfIssueIEN.Text = '' then //should be '' for production
     MessageDlg('Please select the Unit of Issue',
       mtInformation, [mbOk],0)

  else //End of data entry check

  begin //Begin filing data

//****** Build Data to Send to File 664_1 ********************
GetIEN664_1 := '+1,';

//*********** Make call to start new record w/these fields
  dbsValidator664_1.SetUp('664.1',GetIEN664_1,'.01',OWLMDate);
     dbsFiler664_1.AddFDA('664.1',GetIEN664_1,'.01',OWLMDate);  //OWL Mumps Date
  dbsValidator664_1.SetUp('664.1',GetIEN664_1,'.02',PatIEN);
     dbsFiler664_1.AddFDA('664.1',GetIEN664_1,'.02',PatIEN);  //Patient
  dbsValidator664_1.SetUp('664.1',GetIEN664_1,'.03',edtNPPDStationIEN.Text);
     dbsFiler664_1.AddFDA('664.1',GetIEN664_1,'.03',edtNPPDStationIEN.Text);   //IEN File 4
  dbsValidator664_1.SetUp('664.1',GetIEN664_1,'.04',edtRequestingStationIEN.Text);
     dbsFiler664_1.AddFDA('664.1',GetIEN664_1,'.04',edtRequestingStationIEN.Text);//IEN File 4
  dbsValidator664_1.SetUp('664.1',GetIEN664_1,'.06',edtEligibility.Text);
     dbsFiler664_1.AddFDA('664.1',GetIEN664_1,'.06',edtEligibility.Text);   //Eligibility
  dbsValidator664_1.SetUp('664.1',GetIEN664_1,'.09',OWLDateRequiredMDate);
     dbsFiler664_1.AddFDA('664.1',GetIEN664_1,'.09',OWLDateRequiredMDate);
  dbsValidator664_1.SetUp('664.1',GetIEN664_1,'.11',edtReceivingStationIEN.Text);
     dbsFiler664_1.AddFDA('664.1',GetIEN664_1,'.11',edtReceivingStationIEN.Text); //IEN File 4
  dbsValidator664_1.SetUp('664.1',GetIEN664_1,'1',edtTypeOfTransaction.Text);
     dbsFiler664_1.AddFDA('664.1',GetIEN664_1,'1',edtTypeOfTransaction.Text); //Type of Transaction
  dbsValidator664_1.SetUp('664.1',GetIEN664_1,'2',edtLabType.Text);
     dbsFiler664_1.AddFDA('664.1',GetIEN664_1,'2',edtLabType.Text); // Source of Procurment
//  dbsValidator664_1.SetUp('664.1',GetIEN664_1,'',edtIEN.Text);
//     dbsFiler664_1.AddFDA('664.1',GetIEN664_1,'',edtIEN.Text); //

  if not dbsFiler664_1.Update then dbsFiler664_1.DisplayErrors;

// ******************** Retrieve new IEN of 664.1 ************
 IEN664_1:= dbsFiler664_1.FindIEN('+1,');

//*************** Configure for new mult File 664.16 ************
 MultiIEN664_1:= '+1,'+IEN664_1;  //Sets format for FileMan

//*************** Begin filing of Item Muliple ********************
  dbsValidator664_1.SetUp('664.16',MultiIEN664_1,'.01',edtBillingItemIEN.Text);
     dbsFiler664_1.AddFDA('664.16',MultiIEN664_1,'.01',edtBillingItemIEN.Text); //IEN661
  dbsValidator664_1.SetUp('664.16',MultiIEN664_1,'2',edtQty.Text);
     dbsFiler664_1.AddFDA('664.16',MultiIEN664_1,'2',edtQTY.Text);
  dbsValidator664_1.SetUp('664.16',MultiIEN664_1,'3',edtUnitOfIssueIEN.Text);
     dbsFiler664_1.AddFDA('664.16',MultiIEN664_1,'3',edtUnitOfIssueIEN.Text); //IEN420.5 Default UoI 'JOB'
  dbsValidator664_1.SetUp('664.16',MultiIEN664_1,'8',edtTypeOfTransaction.Text);
     dbsFiler664_1.AddFDA('664.16',MultiIEN664_1,'8',edtTypeOfTransaction.Text); //Type of Transaction
  dbsValidator664_1.SetUp('664.16',MultiIEN664_1,'9',edtEligibility.Text);
     dbsFiler664_1.AddFDA('664.16',MultiIEN664_1,'9',edtEligibility.Text); //Eligibility
  dbsValidator664_1.SetUp('664.16',MultiIEN664_1,'13',edtHCPCSIEN.Text);
     dbsFiler664_1.AddFDA('664.16',MultiIEN664_1,'13',edtHCPCSIEN.Text); //IEN661.1
  dbsValidator664_1.SetUp('664.16',MultiIEN664_1,'13.1',edtCPTModifier.Text);
     dbsFiler664_1.AddFDA('664.16',MultiIEN664_1,'13.1',edtCPTModifier.Text); //IEN661.1

  if not dbsFiler664_1.Update then dbsFiler664_1.DisplayErrors;

//*************** Retrieve new IEN of Multiple File 664.16 **********
 IEN664_16 := dbsFiler664_1.FindIEN('+1,')+','+IEN664_1;

//**************** Send Extended Deescription to Multiple ************
  if memExtDescSend.Lines.Count > 0 then
    begin
     memExtDescSend.FMFile  := '664.16'; //For future reference
     memExtDescSend.FMField := '7';
     memExtDescSend.IENS := IEN664_16;
     dbsFiler664_1.AddChgdControl(memExtDescSend); //Must for Filer to know about changes
    if not dbsFiler664_1.Update then dbsFiler664_1.DisplayErrors;
   end;


//******Create Work Order Number **********************
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR CREATE WORK ORDER';
    frmMenu.brkrRPC.Param[1].Value := Piece(IEN664_1,',',1);// IEN 664.1
    frmMenu.brkrRPC.Param[1].Ptype := literal;
    frmMenu.brkrRPC.Param[2].Value := NPPDStationIEN; //IEN 669.9
    frmMenu.brkrRPC.Param[2].PType := literal;
    frmMenu.brkrRPC.Param[3].Value := IEN668; //IEN 668
    frmMenu.brkrRPC.Param[3].PType := literal;
    frmMenu.brkrRPC.Param[4].Value := OWLCreatePrinterIEN; //Print device
    frmMenu.brkrRPC.Param[4].PType := literal;




  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
  END;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
           begin
             begin
              CMaskTemp := '';
              CMaskTemp := CompletionMask;
              Delete (CMaskTemp,9,1);
              Insert('0',CMaskTemp,9); //Work Order number not assigned
              CompletionMask := CMaskTemp;
              CMaskTemp := '';
             end;

            MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
           end;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then  //Ok
           begin
             begin
              CMaskTemp := '';
              CMaskTemp := CompletionMask;
              Delete (CMaskTemp,9,1);
              Insert('1',CMaskTemp,9); //Work Order number assigned
              CompletionMask := CMaskTemp;
              CMaskTemp := '';
             end;

            ShowMessage(Piece(frmMenu.brkrRPC.Results[0],'^',2));
            WorkOrderNumber := Trim(Piece(frmMenu.brkrRPC.Results[0],':',2));
            PostAutoNoteToCPRS; //Post default note to to CPRS
           end;

//*************************************
      if OWLCreatePrinterIEN = 'WINDOWS' then
       begin
         frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL PC PRINT';
         frmMenu.brkrRPC.Param[1].Value := Piece(IEN664_1,',',1);// IEN 664
         frmMenu.brkrRPC.Param[1].PType := literal;
         frmMenu.brkrRPC.Param[2].Value := SiteIEN;//Site IEN
         frmMenu.brkrRPC.Param[2].PType := literal;
         frmMenu.brkrRPC.Param[3].Value := OWLCreatePrinterIEN; //Printer Selection
         frmMenu.brkrRPC.Param[3].PType := literal;

          Try
          //
           frmMenu.brkrRPC.Call;

          except
           on E:EBrokerError do
           begin
            Showmessage('Broker Error: '+ E.Message);
           end;
           on E:EAccessViolation do
           Showmessage(E.Message);
          else
           raise;
          end;

         memOWLWorkOrder.Lines.Clear;

         for i := 0 to frmMenu.brkrRPC.Results.Count -1 do
          begin
           memOWLWorkOrder.Lines.Add (frmMenu.brkrRPC.Results[i]);
          end;

         btnOWLWorkOrderPrint.Click;

       end;//Windows printing

     Close; //frmOWLCreate - back to the consult grid

            end; //Data entry check
           end;
          end;
         end;
        end;
       end;
      end;
     end;
    end;
   end;
  end;
 end; //Data entry check
end;

procedure TfrmOWLCreate.FormCreate(Sender: TObject);
var
d1,d2,d3,d4 : string;
begin
  OWLCreatePrinterIEN := '0';
  OWLPrinterName := 'Default VistA Printer';
  edtDate.Text := DateToStr(Now);

// Create Mumps style date for filing
   begin
      OWLMDate := '';
      if (Date2Year(Now) < 1900) then  //Checks century
    d1 := '1';
      if (Date2Year(Now) >= 1900) and
         (Date2Year(Now) < 2000) then
    d1 := '2';
      if (Date2Year(Now) >= 2000) then
    d1 := '3';

    d2 := Copy(IntToStr(Date2Year(Now)),3,2); //Gets year

      if Date2Month(Now) < 10 then //Pad month with 0 if needed
    d3:= '0'+ IntToStr(Date2Month(Now))
       else
    d3 := IntToStr(Date2Month(Now));

     if Date2Day(Now) < 10 then  //Pad day with 0 if needed
    d4:= '0'+ IntToStr(Date2Day(Now))
       else
    d4 := IntToStr(Date2Day(Now));

  OWLMDate := d1 + d2+ d3 + d4;   //Assemble MUMPS date style
 end;
end;

procedure TfrmOWLCreate.rgrpLabTypeClick(Sender: TObject);
begin
 edtLabType.Text
  := rgrpLabType.FMInternalCodes.Strings[rgrpLabType.ItemIndex];
end;

procedure TfrmOWLCreate.rgrpEligibilityClick(Sender: TObject);
begin
 edtEligibility.Text
  := rgrpEligibility.FMInternalCodes.Strings[rgrpEligibility.ItemIndex];
end;

procedure TfrmOWLCreate.FormActivate(Sender: TObject);
var
 i : integer;
begin
 begin
 edtOWLSelectedPrinter.Text := OWLPrinterName;
 end;


 with grdMiniDis do       // Grid header
  begin
      Cells[0,0] := 'Disability';
      Cells[1,0] := ' %';
      Cells[2,0] := 'SC';
 end;

begin
   TRY
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR DIS LIST';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


 grdMiniDis.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do  //Tab 4
   begin
    with grdMiniDis do
      begin
         Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//Disab
         Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//% Disab
         Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);// SC YES/NO

      end; // with do
    end;
   Except
  end;//Try
 end;


end;

procedure TfrmOWLCreate.cbxHCPCSEnter(Sender: TObject);
begin
 cbxHCPCS.Perform(CB_SETDROPPEDWIDTH, 350, 0);
 dbsHCPCSLister.Screen := 'I $P(^(0),U,5)=1';
 cbxHCPCS.SelectAll;
end;

procedure TfrmOWLCreate.cbxUnitOfIssueExit(Sender: TObject);
begin
 edtUnitOfIssueIEN.Text := '';

  if cbxUnitOfIssue.ItemIndex >= 0 then
     edtUnitOfIssueIEN.Text := cbxUnitOfIssue.GetSelectedRecord.IEN;
end;

procedure TfrmOWLCreate.cbxBillingItemExit(Sender: TObject);
begin
  edtBillingItemIEN.Text := '';

  if cbxBillingItem.ItemIndex >= 0 then
    edtBillingItemIEN.Text := cbxBillingItem.GetSelectedRecord.IEN;
    
cbxBillingItem.SelStart := 0;
end;

procedure TfrmOWLCreate.cbxHCPCSExit(Sender: TObject);
begin
  edtHCPCSIEN.Text := '';

  if cbxHCPCS.ItemIndex >= 0 then
    edtHCPCSIEN.Text := cbxHCPCS.GetSelectedRecord.IEN;
    
cbxHCPCS.SelStart := 0;
end;

procedure TfrmOWLCreate.cbxUnitOfIssueKeyPress(Sender: TObject;
  var Key: Char);
const
  AllowedChars: string = 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz';
var
  i: Integer;
  Ok: Boolean;
begin
  i  := 0;
  Ok := False;
  { If you erase next line, user won't be able to type backspace }
  if Key = #8 then Ok := True;
  repeat
    i := i + 1;
    if (Key = AllowedChars[i]) or (Key = #13) then Ok := True;
  until (Ok) or (i = Length(AllowedChars));
  if not Ok then Key := #0;
end;

procedure TfrmOWLCreate.cbxNPPDStationDropDown(Sender: TObject);
begin
//dbStationLister669_9.Identifier := 'D EN^DDIOL($S($D(^DIC(4,$P(^(0),U,2),99)):$P(^(99),U),1:""""))';
cbxNPPDStation.Perform(CB_SETDROPPEDWIDTH, 350, 0);
end;

procedure TfrmOWLCreate.btnExtDescClick(Sender: TObject);
begin
Application.CreateForm(TfrmOWLExtDesc, frmOWLExtDesc);
frmOWLExtDesc.ShowModal;   //OWL Extended Description memo
end;

procedure TfrmOWLCreate.rgrpTypeOfTransactionClick(Sender: TObject);
begin
 edtTypeOfTransaction.Text
  := rgrpTypeOfTransaction.FMInternalCodes.Strings[rgrpTypeOfTransaction.ItemIndex];
end;

procedure TfrmOWLCreate.edtQtyEnter(Sender: TObject);
begin
 edtQty.SelectAll;
end;

procedure TfrmOWLCreate.cbxNPPDStationExit(Sender: TObject);
begin
 if cbxNPPDStation.Text <> '' then
   begin
    if cbxNPPDStation.ItemIndex >= 0 then
     begin
       dbsStationGets669_9.IENS := cbxNPPDStation.GetSelectedRecord.IEN;
                NPPDStationIEN := cbxNPPDStation.GetSelectedRecord.IEN;
       dbsStationGets669_9.GetData;
        edtNPPDStationIEN.Text := dbsStationGets669_9.GetField('1').FMDBInternal;
           edtNPPDStation.Text := edtNPPDStationIEN.Text;
           //RRA RMPR*175 - TICKET 387983 use station IEN to display actual STATION #
           dbsStationGets4.IENS :=   edtNPPDStationIEN.Text ;
       dbsStationGets4.GetData;
        edtNPPDStation.Text :=   dbsStationGets4.GetField('99').FMDBExternal;

     end;
  end
  else
   begin
    edtNPPDStationIEN.Text := '';
    edtNPPDStation.Text := '';
 end;
cbxNPPDStation.SelStart := 0;
end;

procedure TfrmOWLCreate.btnQuitWorkClick(Sender: TObject);
begin
Close;
end;

procedure TfrmOWLCreate.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (Key = VK_F5) then SendMessage(cbxNPPDStation.Handle, CB_SHOWDROPDOWN, 1, 0);
end;

procedure TfrmOWLCreate.cbxNPPDStationSelect(Sender: TObject);
begin
   if cbxNPPDStation.ItemIndex >= 0 then
   begin
       dbsStationGets669_9.IENS := cbxNPPDStation.GetSelectedRecord.IEN;
                NPPDStationIEN := cbxNPPDStation.GetSelectedRecord.IEN;
       dbsStationGets669_9.GetData;
        edtNPPDStationIEN.Text := dbsStationGets669_9.GetField('1').FMDBInternal;
           edtNPPDStation.Text := edtNPPDStationIEN.Text;
           //RRA RMPR*175 - TICKET 387983 use station IEN to display actual STATION #
        dbsStationGets4.IENS :=   edtNPPDStationIEN.Text ;
       dbsStationGets4.GetData;
       edtNPPDStation.Text :=   dbsStationGets4.GetField('99').FMDBExternal;

   end;

end;

procedure TfrmOWLCreate.btnView2319Click(Sender: TObject);
begin
if IEN668 <> '' then
  begin
  Application.CreateForm(TfrmView2319, frmView2319);
  frmView2319.edtVarIEN668.Text  := IEN668; //sends IEN668 to View2319
  frmView2319.ShowModal;
  end
 else ShowMessage('Please select a PATIENT/RECORD to view');
end;


procedure TfrmOWLCreate.btnViewCPRSClick(Sender: TObject);
begin
 if IEN668 <> '' then
  begin
  Application.CreateForm(TfrmViewCPRS, frmViewCPRS);  
  frmViewCPRS.edtVarIEN668.Text := IEN668; //sends IEN668 to ViewCPRS
  frmViewCPRS.ShowModal;
  end;
end;


procedure TfrmOWLCreate.btnViewRequestClick(Sender: TObject);
begin
 if IEN668 <> '' then
   begin
   Application.CreateForm(TfrmViewReq, frmViewReq);
   frmViewReq.edtVarIEN668.Text := IEN668; //sends IEN668 to ViewRequest
   frmViewReq.ShowModal;
   end;
end;

procedure TfrmOWLCreate.btnOWLChangePrinterLocationClick(Sender: TObject);
begin
  Application.CreateForm(TfrmOWLSelPrinter, frmOWLSelPrinter);
  frmOWLSelPrinter.edtSelectedPrinterIEN.Text := OWLCreatePrinterIEN; 
  frmOWLSelPrinter.edtSelectedPrinter.Text := OWLPrinterName;
  frmOWLSelPrinter.ShowModal;
end;

procedure TfrmOWLCreate.btnOWLWorkOrderPrintClick(Sender: TObject);
begin
  memOWLWorkOrder.Print('Work Order - '+WorkOrderNumber); // for Windows print que
end;

procedure TfrmOWLCreate.cbxSelReceivingStationExit(Sender: TObject);
begin
 if cbxSelReceivingStation.Text <> '' then
   begin
    if cbxSelReceivingStation.ItemIndex >= 0 then
     begin
      edtReceivingStationIEN.Text := cbxSelReceivingStation.GetSelectedRecord.IEN;
      dbsStationGets4.IENS := cbxSelReceivingStation.GetSelectedRecord.IEN;
      dbsStationGets4.GetData;
      edtReceivingStation.Text := dbsStationGets4.GetField('99').FMDBExternal;
     end;
  end
  else
    begin
     edtReceivingStation.Text := '';
     edtReceivingStationIEN.Text := '';
    end; 
cbxSelReceivingStation.SelStart := 0;
end;

procedure TfrmOWLCreate.cbxSelRequestingStationExit(Sender: TObject);
begin
 if cbxSelRequestingStation.Text <> '' then
  begin
   if cbxSelRequestingStation.ItemIndex >= 0 then
   begin
    edtRequestingStationIEN.Text := cbxSelRequestingStation.GetSelectedRecord.IEN;
    dbsStationGets4.IENS := cbxSelRequestingStation.GetSelectedRecord.IEN;
    cbxSelRequestingStation.Perform(EM_SCROLLCARET,0,0);// to set display Lft Just
    dbsStationGets4.GetData;
    edtRequestingStation.Text := dbsStationGets4.GetField('99').FMDBExternal;
   end;
  end
  else
    begin
    edtRequestingStationIEN.Text := '';
    edtRequestingStation.Text := '';
    end;
cbxSelRequestingStation.SelStart := 0;    
end;

procedure TfrmOWLCreate.rgrpCPTModifierClick(Sender: TObject);
begin
 edtCPTModifier.Text
  := rgrpCPTModifier.FMInternalCodes.Strings[rgrpCPTModifier.ItemIndex];
end;

procedure TfrmOWLCreate.edtQtyExit(Sender: TObject);
begin
if ((edtQty.Value > 9999) or (edtQty.Value < 0)) then
 begin
  ShowMessage('Please enter a valid QUANTITY less than 9,999');
  edtQTY.SetFocus;
 end;
if edtQty.Text = ''  then
 edtQty.Value := 0;
end;

procedure TfrmOWLCreate.btnOWLDateRequiredClick(Sender: TObject);
begin
Application.CreateForm(TfrmOWLDateRequired, frmOWLDateRequired);
frmOWLDateRequired.ShowModal;
end;

procedure TfrmOWLCreate.FormShow(Sender: TObject);
begin
edtOWLDateRequired.Text := DateToStr(AddDays(Str2Date(edtDate.Text),30));//Set 30 day due date
end;

procedure TfrmOWLCreate.edtOWLDateRequiredChange(Sender: TObject);
var
DateRequired : TDateTime;
d1,d2,d3,d4 : string;         //Gets the user input from the calendar
begin
      DateRequired := Str2Date(edtOWLDateRequired.Text);
      OWLDateRequiredMDate := '';

      if (Date2Year(DateRequired) < 1900) then  //Checks century
    d1 := '1';
      if (Date2Year(DateRequired) >= 1900) and
         (Date2Year(DateRequired) < 2000) then
    d1 := '2';
      if (Date2Year(DateRequired) >= 2000) then
    d1 := '3';

    d2 := Copy(IntToStr(Date2Year(DateRequired)),3,2); //Gets year

      if Date2Month(DateRequired) < 10 then //Pad month with 0 if needed
    d3:= '0'+ IntToStr(Date2Month(DateRequired))
       else
    d3 := IntToStr(Date2Month(DateRequired));

     if Date2Day(DateRequired) < 10 then  //Pad day with 0 if needed
    d4:= '0'+ IntToStr(Date2Day(DateRequired))
       else
    d4 := IntToStr(Date2Day(DateRequired));

OWLDateRequiredMDate := d1 + d2+ d3 + d4;                    //Assemble MUMPS date style
end;

procedure TfrmOWLCreate.cbxBillingItemDropDown(Sender: TObject);
begin
cbxBillingItem.Perform(CB_SETDROPPEDWIDTH, 350, 0);
end;

procedure TfrmOWLCreate.cbxHCPCSDropDown(Sender: TObject);
begin
cbxHCPCS.Perform(CB_SETDROPPEDWIDTH, 350, 0);
end;

end.
