(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program print.

*******************************************)

unit uPROS_OWL_PrintOWL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Fmcntrls, Buttons, Fmcmpnts, Diaccess, ExtCtrls, MFunstr,
  Trpcb, Printers, ComCtrls;

type
  TfrmOWLPrint = class(TForm)
    lblPrintLocation: TFMLabel;
    edtSelectedPrinter: TFMEdit;
    grpChangePrintLocation: TGroupBox;
    lblWindowsPrinter: TFMLabel;
    btnWindowsPrinter: TBitBtn;
    lblSelectDifferentPrintLocation: TFMLabel;
    edtSelectedPrinterIEN: TFMEdit;
    lblOrPrintLocation: TFMLabel;
    lblVistaPrinter: TFMLabel;
    pnlOWLPrint: TPanel;
    btnPrintOWL: TBitBtn;
    cbxOWLSelVistaPrinter: TFMComboBoxLookUp;
    btnDefaultVistaPrinter: TBitBtn;
    dbsOWLGets3_5: TFMGets;
    dbsOWLLister3_5: TFMLister;
    dlgOWLPrinter: TPrintDialog;
    memOWLPCPrint: TRichEdit;
    btnCancel: TBitBtn;
    procedure btnWindowsPrinterClick(Sender: TObject);
    procedure cbxOWLSelVistaPrinterEnter(Sender: TObject);
    procedure cbxOWLSelVistaPrinterSelect(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnDefaultVistaPrinterClick(Sender: TObject);
    procedure btnPrintOWLClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLPrint: TfrmOWLPrint;
  OWLPrinterIEN : string;

implementation

uses PROS_Menu,uPROS_OWL;

{$R *.dfm}

procedure TfrmOWLPrint.btnWindowsPrinterClick(Sender: TObject);
var
 i : integer;
begin
cbxOWLSelVistaPrinter.ClearSelection;
dlgOWLPrinter.Execute;

begin
 i := Printer.PrinterIndex;
  begin
   if(i > -2)then
    begin
     edtSelectedPrinter.Text := Printer.Printers.Strings[i];
     OWLPrinterIEN := 'WINDOWS'; // Tells RPC to send back PO for Win print
     edtSelectedPrinterIEN.Text := OWLPrinterIEN;
    end
   else
    begin
     edtSelectedPrinter.Text := '';
    end;
 end;
end;

end;

procedure TfrmOWLPrint.cbxOWLSelVistaPrinterEnter(Sender: TObject);
begin
cbxOWLSelVistaPrinter.Perform(CB_SETDROPPEDWIDTH, 200, 0);
end;

procedure TfrmOWLPrint.cbxOWLSelVistaPrinterSelect(Sender: TObject);
begin
if cbxOWLSelVistaPrinter.GetSelectedRecord.IEN <> ''  then
 begin
  OWLPrinterIEN := cbxOWLSelVistaPrinter.GetSelectedRecord.IEN;
  edtSelectedPrinterIEN.Text := OWLPrinterIEN;
  edtSelectedPrinter.Text := cbxOWLSelVistaPrinter.Text;
 end;
end;

procedure TfrmOWLPrint.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Release;
end;

procedure TfrmOWLPrint.btnDefaultVistaPrinterClick(Sender: TObject);
begin
cbxOWLSelVistaPrinter.ClearSelection;
edtSelectedPrinterIEN.Text := '0';
OWLPrinterIEN := '0';
edtSelectedPrinter.Text := 'Default VistA Printer';
end;

procedure TfrmOWLPrint.btnPrintOWLClick(Sender: TObject);
var
 i : integer;
begin

      if OWLPrinterIEN <> 'WINDOWS' then
       begin
         frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL VISTA PRINT';
         frmMenu.brkrRPC.Param[1].Value := Piece(IEN664_1,',',1);// IEN 664
         frmMenu.brkrRPC.Param[1].PType := literal;
         frmMenu.brkrRPC.Param[2].Value := IEN669_9;//Site IEN
         frmMenu.brkrRPC.Param[2].PType := literal;
         frmMenu.brkrRPC.Param[3].Value := OWLPrinterIEN; //Printer Selection
         frmMenu.brkrRPC.Param[3].PType := literal;

          Try
          //
           frmMenu.brkrRPC.Call;

          except
           on E:EBrokerError do
           begin
            Showmessage('Broker Error: '+ E.Message);
           end;
           on E:EAccessViolation do
           Showmessage(E.Message);
          else
           raise;
          end;

{         memOWLWorkOrder.Lines.Clear;

         for i := 0 to frmMenu.brkrRPC.Results.Count -1 do
          begin
           memOWLWorkOrder.Lines.Add (frmMenu.brkrRPC.Results[i]);
          end;

         btnOWLWorkOrderPrint.Click;
}
       end;//VistA printing


      if OWLPrinterIEN = 'WINDOWS' then
       begin
         frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL PC PRINT';
         frmMenu.brkrRPC.Param[1].Value := Piece(IEN664_1,',',1);// IEN 664
         frmMenu.brkrRPC.Param[1].PType := literal;
         frmMenu.brkrRPC.Param[2].Value := IEN669_9;//Site IEN
         frmMenu.brkrRPC.Param[2].PType := literal;
         frmMenu.brkrRPC.Param[3].Value := OWLPrinterIEN; //Printer Selection
         frmMenu.brkrRPC.Param[3].PType := literal;

          Try
          //
           frmMenu.brkrRPC.Call;

          except
           on E:EBrokerError do
           begin
            Showmessage('Broker Error: '+ E.Message);
           end;
           on E:EAccessViolation do
           Showmessage(E.Message);
          else
           raise;
          end;

         memOWLPCPrint.Lines.Clear;

         for i := 0 to frmMenu.brkrRPC.Results.Count -1 do
          begin
           memOWLPCPrint.Lines.Add (frmMenu.brkrRPC.Results[i]);
          end;

//         btnOWLWorkOrderPrint.Click;
        memOWLPCPrint.Print('Work Order - '+frmOWL.grdOWLWorkOrders.Cells[0,frmOWL.grdOWLWorkOrders.Row]); // for Windows print que
       end;//Windows printing

     Close; //frmOWLCreate - back to the consult grid

end;

procedure TfrmOWLPrint.btnCancelClick(Sender: TObject);
begin
Close;
end;

end.
