(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program change date required.

*******************************************)

unit uPROS_OWL_SelDateRequired;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Fmcntrls, ESBDates, Buttons;

type
  TfrmOWLDateRequired = class(TForm)
    calOWLSelDateRequired: TMonthCalendar;
    lblNewOWLDateRequired: TFMLabel;
    btnOk: TBitBtn;
    btnCancel: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure calOWLSelDateRequiredClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLDateRequired: TfrmOWLDateRequired;

implementation

uses uPROS_OWL_Create;

{$R *.dfm}

procedure TfrmOWLDateRequired.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Release;
end;

procedure TfrmOWLDateRequired.FormActivate(Sender: TObject);
begin
calOWLSelDateRequired.Date := StrToDate(frmOWLCreate.edtOWLDateRequired.Text);
lblNewOWLDateRequired.Caption := 'This selected Due Date is '+
                  IntToStr(DaysApart(Now,calOWLSelDateRequired.Date))+' days from today';
end;

procedure TfrmOWLDateRequired.calOWLSelDateRequiredClick(Sender: TObject);
begin
if (DaysApart(Date,calOWLSelDateRequired.Date)) < 0 then
  begin
  lblNewOWLDateRequired.Caption := 'This selected Due Date is in the past!';

  ShowMessage('Please select TODAY''S date or a date in the future');
  end
 else
 lblNewOWLDateRequired.Caption := 'This selected Due Date is '+
                  IntToStr(DaysApart(Now,calOWLSelDateRequired.Date))+' days from today';
end;

procedure TfrmOWLDateRequired.btnOkClick(Sender: TObject);
begin
  begin
   if (DaysApart(Date,calOWLSelDateRequired.Date)) < 0 then
   begin

   ShowMessage('Please select TODAY''S date or a date in the future');

   end
 else
  begin
  frmOWLCreate.edtOWLDateRequired.Text := DateToStr(calOWLSelDateRequired.Date);
  Close;
  end;
 end;
end;

procedure TfrmOWLDateRequired.btnCancelClick(Sender: TObject);
begin
Close;
end;

end.
