(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program select a print location.

*******************************************)

unit uPROS_OWL_SelPrinter;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Fmcntrls, ExtCtrls, Fmcmpnts, Diaccess, Buttons, Printers;

type
  TfrmOWLSelPrinter = class(TForm)
    edtSelectedPrinter: TFMEdit;
    lblCurrentPrintLocation: TFMLabel;
    lblSelectDifferentPrinter: TFMLabel;
    grpChangePrintLocation: TGroupBox;
    lblWindowsPrinter: TFMLabel;
    btnWindowsPrinter: TBitBtn;
    lblOrVistaPrinter: TFMLabel;
    lblVistaPrinter: TFMLabel;
    btnDefaultPrinter: TBitBtn;
    dbsOWLGets3_5: TFMGets;
    dbsOWLLister3_5: TFMLister;
    dlgOWLPrinter: TPrintDialog;
    pnlSSelPrinter: TPanel;
    btnOk: TBitBtn;
    edtSelectedPrinterIEN: TFMEdit;
    btnLabWorkOrderPrint: TBitBtn;
    memLabWorkOrderPrint: TFMMemo;
    cbxOWLSelVistaPrinter: TFMComboBoxLookUp;
    procedure btnWindowsPrinterClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure cbxOWLSelVistaPrinterEnter(Sender: TObject);
    procedure cbxOWLSelVistaPrinterSelect(Sender: TObject);
    procedure btnDefaultPrinterClick(Sender: TObject);
    procedure dlgOWLPrinterClose(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOkClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLSelPrinter: TfrmOWLSelPrinter;
  OWLPrinterIEN : string;
implementation

uses uPROS_OWL_Create, PROS_Menu;

{$R *.dfm}

procedure TfrmOWLSelPrinter.btnWindowsPrinterClick(Sender: TObject);
var
 i : integer;
begin
cbxOWLSelVistaPrinter.ClearSelection;
dlgOWLPrinter.Execute;

begin
 i := Printer.PrinterIndex;
  begin
   if(i > -2)then
    begin
     edtSelectedPrinter.Text := Printer.Printers.Strings[i];
     OWLPrinterName := edtSelectedPrinter.Text;
     frmOWLCreate.edtOWLSelectedPrinter.Text := OWLPrinterName;
     OWLCreatePrinterIEN := 'WINDOWS'; // Tells RPC to send back PO for Win print
     edtSelectedPrinterIEN.Text := OWLCreatePrinterIEN;
    end
   else
    begin
     edtSelectedPrinter.Text := '';
    end;
 end;
end;

end;

procedure TfrmOWLSelPrinter.FormActivate(Sender: TObject);
begin
   edtSelectedPrinter.Text := OWLPrinterName; //Gets current selection
end;

procedure TfrmOWLSelPrinter.cbxOWLSelVistaPrinterEnter(Sender: TObject);
begin
//dbOWLLister3_5.Screen :='S J=$S($G(^(90))''="":+^(90),1:DT+5),RMPRTYP=$G(^("SUBTYPE")) I J>DT I $E($G(^%ZIS(2,+RMPRTYP,0)))="P"';
cbxOWLSelVistaPrinter.Perform(CB_SETDROPPEDWIDTH, 200, 0);
end;


procedure TfrmOWLSelPrinter.cbxOWLSelVistaPrinterSelect(Sender: TObject);
begin
if cbxOWLSelVistaPrinter.GetSelectedRecord.IEN <> ''  then
 begin
  OWLCreatePrinterIEN := cbxOWLSelVistaPrinter.GetSelectedRecord.IEN;
  edtSelectedPrinterIEN.Text := OWLCreatePrinterIEN;
  edtSelectedPrinter.Text := cbxOWLSelVistaPrinter.Text;
  OWLPrinterName := edtSelectedPrinter.Text;
  frmOWLCreate.edtOWLSelectedPrinter.Text := OWLPrinterName;
 end;
end;

procedure TfrmOWLSelPrinter.btnDefaultPrinterClick(Sender: TObject);
begin
cbxOWLSelVistaPrinter.ClearSelection;
edtSelectedPrinterIEN.Text := '0';
OWLCreatePrinterIEN := '0';
OWLPrinterName := 'Default VistA Printer';
edtSelectedPrinter.Text := OWLPrinterName;
frmOWLCreate.edtOWLSelectedPrinter.Text := OWLPrinterName;
end;

procedure TfrmOWLSelPrinter.dlgOWLPrinterClose(Sender: TObject);
var
 i : integer;
begin
 i := Printer.PrinterIndex;
  begin
   if(i > -2)then
    begin
     edtSelectedPrinter.Text := Printer.Printers.Strings[i];
    end
   else
    begin
     edtSelectedPrinter.Text := '';
    end;
 end;
end;

procedure TfrmOWLSelPrinter.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Release;
end;

procedure TfrmOWLSelPrinter.btnOkClick(Sender: TObject);
begin
Close;
end;

procedure TfrmOWLSelPrinter.BitBtn1Click(Sender: TObject);
begin
Close;
end;

end.
