unit uPROS_InventoryIssue;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, StrUtils, Fmcntrls, ExtCtrls, Trpcb, MFunStr, MyGrids,
  SortGrid, NumEdit, CurrEdit, Grids, ProsUtils, VA508AccessibilityManager;

type
  TfrmInventoryIssue = class(TForm)
    btnCancel: TBitBtn;
    edtPatIEN: TEdit;
    rgrpTypeOfTransaction: TFMRadioGroup;
    edtTypeOfTransaction: TFMEdit;
    btnIssueItem: TBitBtn;
    rgrpEligibility: TFMRadioGroup;
    edtEligibility: TFMEdit;
    edtItemNumber: TEdit;
    edtIEN668: TEdit;
    grdMiniDis: TSortGrid;
    lblPatientName: TLabel;
    lblPatientSSN: TLabel;
    edtVendor: TEdit;
    edtStoreRoom: TEdit;
    edtBarCodeHCPCS: TEdit;
    edtSource: TEdit;
    edtRemarks: TEdit;
    edtSerialNumber: TEdit;
    edtLotNumber: TEdit;
    edtStationNumber: TEdit;
    edtExcludeWaiver: TEdit;
    Panel1: TPanel;
    btnReadBarCode1: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    edtDateOfReceipt: TEdit;
    Label12: TLabel;
    edtItemDescription: TEdit;
    Label8: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    edtIssuedHCPCSIEN: TEdit;
    edtBarCodeItemCost: TCurrencyEdit;
    edtTotalCost: TCurrencyEdit;
    edtQty: TIntEdit;
    edtExpirationDate: TEdit;
    Label16: TLabel;
    edtHCPCSVersionDate: TEdit;
    Label17: TLabel;
    BitBtn1: TBitBtn;
    edtIssuedHCPCS: TEdit;
    BitBtn2: TBitBtn;
    Label18: TLabel;
    Label19: TLabel;
    chkExclude: TCheckBox;
    chkWaiver: TCheckBox;
    btnReadBarCode2: TBitBtn;
    btnReadBarCode3: TBitBtn;
    btnReadBarCode4: TBitBtn;
    btnReadBarCode5: TBitBtn;
    btnReadCarCode6: TBitBtn;
    edtExternalLotID: TEdit;
    edtContractNumber: TEdit;
    Label7: TLabel;
    Label9: TLabel;
    grdPatientCategory: TStringGrid;
    btnPostNote: TBitBtn;
    edtVendorIEN: TEdit;
    edtHCPCSVersionDateDisplay: TEdit;
    edtExpirationDateDisplay: TEdit;
    edtDateOfReceiptDisplay: TEdit;
    grbPatientCategory: TGroupBox;
    btnEligibility: TBitBtn;
    edtEligibilityDisplay: TEdit;
    edtSenderWindow: TEdit;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    VA508ComponentAccessibility1: TVA508ComponentAccessibility;
    VA508ComponentAccessibility2: TVA508ComponentAccessibility;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure rgrpTypeOfTransactionClick(Sender: TObject);
    procedure btnIssueItemClick(Sender: TObject);
    procedure rgrpEligibilityClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnReadBarCode1Click(Sender: TObject);
    procedure edtQtyChange(Sender: TObject);
    procedure edtQtyEnter(Sender: TObject);
    procedure edtQtyClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure chkExcludeClick(Sender: TObject);
    procedure chkWaiverClick(Sender: TObject);
    procedure edtQtyExit(Sender: TObject);
    procedure btnReadBarCode2Click(Sender: TObject);
    procedure btnReadBarCode3Click(Sender: TObject);
    procedure btnReadBarCode4Click(Sender: TObject);
    procedure btnReadBarCode5Click(Sender: TObject);
    procedure btnReadCarCode6Click(Sender: TObject);
    procedure btnEligibilityClick(Sender: TObject);
    procedure grdPatientCategoryKeyPress(Sender: TObject; var Key: Char);
    procedure grdPatientCategoryDblClick(Sender: TObject);
    procedure btnPostNoteClick(Sender: TObject);
    procedure edtLotNumberKeyPress(Sender: TObject; var Key: Char);
    procedure edtSerialNumberKeyPress(Sender: TObject; var Key: Char);
    procedure edtSerialNumberExit(Sender: TObject);
    procedure grdPatientCategoryMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure edtBarcodeDataKeyPress(Sender: TObject; var Key: Char);
    procedure edtEligibilityChange(Sender: TObject);
    procedure edtHCPCSVersionDateChange(Sender: TObject);
    procedure VA508ComponentAccessibility1ValueQuery(Sender: TObject;
      var Text: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInventoryIssue: TfrmInventoryIssue;
  IEN666 : string;

implementation
uses
   PROS_Menu
  ,PROS_POC_PurOrderConsult
  ,PROS_DOR_View2319
  ,PROS_DOR_ViewCPRS
  ,PROS_DOR_ViewReq
  ,PROS_DOR_AppTransDetail
  ,PROS_Menu_About
  ,uPROS_SelectHCPCS
  ,uPROS_InventoryIssueCloseSuspense
  ,uPROS_InventoryIssueScanBarcode;

{$R *.dfm}

function buildOutput(o: TSortGrid): String;

var text: String;
const delim: string = '^';
var i: integer;

Begin
  o.SelectedRows.Sort;
  Text := delim + inttostr(o.RowCount-1) + delim;   // row count
  Text := Text + inttostr(o.colCount) + delim;    // column count

  for i := 0 to o.colCount-1 do // column headers
    Text := Text + o.Cells[i,0] + delim; // row 0 is column header
    Text := Text + IntToStr(o.Row) + delim; // current row number
    Text := Text + inttostr(0) + delim; // current column num will always be 0 when in row selection mode

  for i := 0 to o.colCount-1 do // data
    Text := Text + o.Cells[i,o.Row] + delim; // row 0 is column header
    Text := Text + intToStr(o.SelectedRows.Count) + delim; // row selection count
    Text := Text + intToStr(0) + delim; // col selection count

 for i := 0 to o.SelectedRows.Count - 1 do
  Begin
     if i = o.SelectedRows.Count -1 then
       Text := Text + o.SelectedRows[i] // selected rows
     Else
       Text := Text + o.SelectedRows[i] + ','; // selected rows
   End;

  Text := Text + delim;  // delim after selected rows
  Text := Text + IntToStr(0) + Delim; // selected columns

  buildOutput := Text;

End;

procedure TfrmInventoryIssue.VA508ComponentAccessibility1ValueQuery(Sender: TObject;
var Text: string);
begin
  Text := buildOutput(TSortGrid(TVA508ComponentAccessibility(sender).Component));
End;

procedure TfrmInventoryIssue.BitBtn1Click(Sender: TObject);
begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR INV BARCODE DATA CHECK';
    frmMenu.brkrRPC.Param[1].Value := edtBarCodeHCPCS.Text;
    frmMenu.brkrRPC.Param[1].Ptype := literal;
    frmMenu.brkrRPC.Param[2].Value := edtHCPCSVersionDate.Text;
    frmMenu.brkrRPC.Param[2].Ptype := literal;
    frmMenu.brkrRPC.Param[3].Value := edtStationNumber.Text;
    frmMenu.brkrRPC.Param[3].Ptype := literal;

  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
  End;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
           begin
          // Application.CreateForm(TfrmSelHCPCS, frmSelHCPCS);
          // frmSelHCPCS.lblHCPCSErrorMsg.Caption := Piece(frmMenu.brkrRPC.Results[0],'^',2);
//           frmSelHCPCS.ShowModal;
            MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
           end;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then  //Ok
           begin
            edtIssuedHCPCSIEN.Text := Piece(frmMenu.brkrRPC.Results[0],'^',2);
//             MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
             end;

//   PostAutoNoteToCPRS; //Post default note to to CPRS


end;

procedure TfrmInventoryIssue.BitBtn2Click(Sender: TObject);
begin
//  Application.CreateForm(TfrmSelHCPCS, frmSelHCPCS);
//  frmSelHCPCS.lblHCPCSTopMessage.Caption := 'Select New HCPCS Code';
//  frmSelHCPCS.lblHCPCSErrorMsg.Caption := '';
//  frmSelHCPCS.ShowModal;
end;

procedure TfrmInventoryIssue.btnEligibilityClick(Sender: TObject);
var
  i : integer;
begin
//     grdPatientCategory.Visible := True;
//     grdPatientCategory.SetFocus;

    frmMenu.brkrRPC.RemoteProcedure := 'RMPR PATIENT CATEGORY LIST'; // 'RMPR INV ISSUE POST';


  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
  End;

    if frmMenu.brkrRPC.Results.Count > 0 then
        grdPatientCategory.RowCount := frmMenu.brkrRPC.Results.Count +1;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1  do  //Tab 4


    with grdPatientCategory do
    begin

      Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1); //Catagory
      Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2); //Code

    end;
    grdPatientCategory.Visible := True;
    grdPatientCategory.SetFocus;
//    edtEligibility.text := grdPatientCategory.cells[2,grdPatientCategory.Row];  //Sets first DFN
//   end
//  else
//   ShowMessage('Please enter at least 2 characters.');






end;

procedure TfrmInventoryIssue.btnReadBarCode4Click(Sender: TObject);
begin
edtItemNumber.Text:= '757873388';
edtItemDescription.Text := 'Stump Sock Single Below Knee';
edtVendor.Text := 'DePuy';
edtVendorIEN.Text := '2014';
edtStoreRoom.Text := 'B16R212';
edtBarCodeHCPCS.Text := 'L8470';
//edtIssuedHCPCS.Text := 'K0001';
edtIssuedHCPCSIEN.Text := '1209';
edtStationNumber.Text := '552';
edtSource.Text := 'C';
edtDateOfReceipt.Text := '201002110847';
edtExpirationDate.Text := '20141031';
edtHCPCSVersionDate.Text := '200911281025';
edtExternalLotID.Text := 'FY10-DR4';
edtBarCodeItemCost.Value := StrToFloat('9.50');
edtTotalCost.Value := StrToFloat('9.50');
edtSource.Text := 'C';
edtQty.Value := 1;
//edtTotalCost.Value := StrToFloat('11.98');
//btnIssueItem.Enabled := True;
end;

procedure TfrmInventoryIssue.btnReadBarCode5Click(Sender: TObject);
begin
edtItemNumber.Text:= '1899452';
edtItemDescription.Text := 'Eye Patch Occlusive';
edtVendor.Text := 'Abbott Labs';
edtVendorIEN.Text := '14238';
edtStoreRoom.Text := 'B16R212';
edtBarCodeHCPCS.Text := 'A6412';
//edtIssuedHCPCS.Text := 'K0001';
edtIssuedHCPCSIEN.Text := '3832';
edtStationNumber.Text := '552';
edtSource.Text := 'C';
edtDateOfReceipt.Text := '201002010858';
edtExpirationDate.Text := '20141031';
edtHCPCSVersionDate.Text := '200911281025';
edtExternalLotID.Text := 'FY09-559';
edtBarCodeItemCost.Value := StrToFloat('2.25');
edtTotalCost.Value := StrToFloat('2.25');
edtSource.Text := 'C';
edtQty.Value := 1;
//edtTotalCost.Value := StrToFloat('11.98');
//btnIssueItem.Enabled := True;
end;

procedure TfrmInventoryIssue.btnReadCarCode6Click(Sender: TObject);
begin
edtItemNumber.Text:= '58733622';
edtItemDescription.Text := 'Tray, W/C';
edtVendor.Text := 'Everest & Jennings';
edtVendorIEN.Text := '392';
edtStoreRoom.Text := 'B16R212';
edtBarCodeHCPCS.Text := 'E0950';
//edtIssuedHCPCS.Text := 'K0001';
edtIssuedHCPCSIEN.Text := '224';
edtStationNumber.Text := '552';
edtSource.Text := 'C';
edtDateOfReceipt.Text := '201002110847';
edtExpirationDate.Text := '';
edtHCPCSVersionDate.Text := '200503252315';
edtExternalLotID.Text := 'FY05-9E0';
edtBarCodeItemCost.Value := StrToFloat('39.00');
edtTotalCost.Value := StrToFloat('39.00');
edtSource.Text := 'C';
edtQty.Value := 1;
//edtTotalCost.Value := StrToFloat('11.98');
//btnIssueItem.Enabled := True;
end;

procedure TfrmInventoryIssue.btnReadBarCode2Click(Sender: TObject);
begin
edtItemNumber.Text:= '5578388';
edtItemDescription.Text := 'Cane Adjust/Fixed with tip';
edtVendor.Text := 'Baxter Hospital Supply';
edtVendorIEN.Text := '2820';
edtStoreRoom.Text := 'B16R212';
edtBarCodeHCPCS.Text := 'E0100';
//edtIssuedHCPCS.Text := 'K0001';
edtIssuedHCPCSIEN.Text := '49';
edtStationNumber.Text := '552';
edtSource.Text := 'C';
edtDateOfReceipt.Text := '201001120805';
edtExpirationDate.Text := '20121226';
edtHCPCSVersionDate.Text := '200911281025';
edtExternalLotID.Text := 'FY10-67P';
edtBarCodeItemCost.Value := StrToFloat('14.25');
edtTotalCost.Value := StrToFloat('14.25');
edtSource.Text := 'C';
edtQty.Value := 1;
//edtTotalCost.Value := StrToFloat('11.98');
// btnIssueItem.Enabled := True;
end;

procedure TfrmInventoryIssue.btnReadBarCode3Click(Sender: TObject);
begin
edtItemNumber.Text:= '4564923789';

edtItemDescription.Text := 'Clock/Watches - Braille/Talking';
edtVendor.Text := 'Invacare';
edtVendorIEN.Text := '4814';
edtStoreRoom.Text := 'B16R212';
edtBarCodeHCPCS.Text := 'BA200';
//edtIssuedHCPCS.Text := 'K0001';
edtIssuedHCPCSIEN.Text := '3756';
edtStationNumber.Text := '552';
edtSource.Text := 'C';
edtDateOfReceipt.Text := '200902141045';
edtExpirationDate.Text := '';
edtHCPCSVersionDate.Text := '200911281025';
edtExternalLotID.Text := '';
edtBarCodeItemCost.Value := StrToFloat('24.55');
edtTotalCost.Value := StrToFloat('24.55');
edtSource.Text := 'C';
edtQty.Value := 1;
//edtTotalCost.Value := StrToFloat('11.98');
btnIssueItem.Enabled := True;
end;

procedure TfrmInventoryIssue.btnCancelClick(Sender: TObject);
begin
Close;
end;

procedure TfrmInventoryIssue.btnIssueItemClick(Sender: TObject);
var
i : integer;
begin
 if edtEligibility.Text <> '' then
  begin


    frmMenu.brkrRPC.RemoteProcedure := 'RMPR INV ISSUE POST'; // 'RMPR INV ISSUE POST';
    frmMenu.brkrRPC.Param[1].Value := edtIEN668.Text;
    frmMenu.brkrRPC.Param[1].Ptype := literal;
    frmMenu.brkrRPC.Param[2].Value := edtPatIEN.Text;
    frmMenu.brkrRPC.Param[2].Ptype := literal;
    frmMenu.brkrRPC.Param[3].Value := edtTypeOfTransaction.Text;
    frmMenu.brkrRPC.Param[3].PType := literal;
    frmMenu.brkrRPC.Param[4].Value := edtEligibility.Text;
    frmMenu.brkrRPC.Param[4].PType := literal;
    frmMenu.brkrRPC.Param[5].Value := edtItemNumber.Text;
    frmMenu.brkrRPC.Param[5].PType := literal;
    frmMenu.brkrRPC.Param[6].Value := edtItemDescription.Text;
    frmMenu.brkrRPC.Param[6].PType := literal;
    frmMenu.brkrRPC.Param[7].Value := edtRemarks.Text;
    frmMenu.brkrRPC.Param[7].PType := literal;
    frmMenu.brkrRPC.Param[8].Value := FloatToStr(edtBarCodeItemCost.Value);
    frmMenu.brkrRPC.Param[8].PType := literal;
    frmMenu.brkrRPC.Param[9].Value := FloatToStr(edtTotalCost.Value);
    frmMenu.brkrRPC.Param[9].PType := literal;
    frmMenu.brkrRPC.Param[10].Value := IntToStr(edtQty.Value);
    frmMenu.brkrRPC.Param[10].PType := literal;
    frmMenu.brkrRPC.Param[11].Value := edtContractNumber.Text;
    frmMenu.brkrRPC.Param[11].PType := literal;
    frmMenu.brkrRPC.Param[12].Value := edtSerialNumber.Text;
    frmMenu.brkrRPC.Param[12].PType := literal;
    frmMenu.brkrRPC.Param[13].Value := edtLotNumber.Text;
    frmMenu.brkrRPC.Param[13].PType := literal;
    frmMenu.brkrRPC.Param[14].Value := edtVendor.Text;
    frmMenu.brkrRPC.Param[14].PType := literal;
    frmMenu.brkrRPC.Param[15].Value := edtStoreRoom.Text;
    frmMenu.brkrRPC.Param[15].PType := literal;
    frmMenu.brkrRPC.Param[16].Value := edtStationNumber.Text;
    frmMenu.brkrRPC.Param[16].PType := literal;
    frmMenu.brkrRPC.Param[17].Value := edtBarCodeHCPCS.Text;
    frmMenu.brkrRPC.Param[17].PType := literal;
    frmMenu.brkrRPC.Param[18].Value := edtIssuedHCPCSIEN.Text;
    frmMenu.brkrRPC.Param[18].PType := literal;
    frmMenu.brkrRPC.Param[19].Value := edtSource.Text;
    frmMenu.brkrRPC.Param[19].PType := literal;
    frmMenu.brkrRPC.Param[20].Value := edtExcludeWaiver.Text;
    frmMenu.brkrRPC.Param[20].PType := literal;
    frmMenu.brkrRPC.Param[21].Value := edtExpirationDate.Text;
    frmMenu.brkrRPC.Param[21].PType := literal;
    frmMenu.brkrRPC.Param[22].Value := edtDateOfReceipt.Text;
    frmMenu.brkrRPC.Param[22].PType := literal;
    frmMenu.brkrRPC.Param[23].Value := edtHCPCSVersionDate.Text;
    frmMenu.brkrRPC.Param[23].PType := literal;
    frmMenu.brkrRPC.Param[24].Value := edtExternalLotID.Text;
    frmMenu.brkrRPC.Param[24].PType := literal;


  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
  End;
        i := frmMenu.brkrRPC.Results.Count;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
           begin
             MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
           end;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then  //Ok
           begin
             IEN666 := Piece(frmMenu.brkrRPC.Results[0],'^',2); //Receive IEN of new 666
             btnPostNote.Click;
           end;

//   PostAutoNoteToCPRS; //Post default note to to CPRS

   btnIssueItem.Enabled := False;



  close;

 end
 else
   begin
   Showmessage('Please select a PATIENT CATEGORY');
   btnEligibility.SetFocus;
   end;
end;


procedure TfrmInventoryIssue.btnPostNoteClick(Sender: TObject);
var
i
,j : integer;
begin
//memo1.Lines.AddStrings (grdSuspenseProcessingSingle.SelectedRows);

  Application.CreateForm(TfrmInventoryIssueCloseSuspense, frmInventoryIssueCloseSuspense);
  frmInventoryIssueCloseSuspense.edtInvIssueIEN666.Text := IEN666; //Passes IEN666
  frmInventoryIssueCloseSuspense.edtSenderWindow.Text := edtSenderWindow.Text; //transfer from Issue to Post Note
//  frmPostSuspenseNote.edtSuspenseProcessingSingleRow.Text := IntToStr(grdSuspenseProcessingSingle.Row); //Org Row
  frmInventoryIssueCloseSuspense.ShowModal;
end;


procedure TfrmInventoryIssue.btnReadBarCode1Click(Sender: TObject);
begin
edtItemNumber.Text:= '67833';
edtItemDescription.Text := 'Wheelchair - Standard';
edtVendor.Text := 'Acme Labs';
edtVendorIEN.Text := '15706';
edtStoreRoom.Text := 'B16R212';
edtBarCodeHCPCS.Text := 'K0001';
//edtIssuedHCPCS.Text := 'K0001';
edtIssuedHCPCSIEN.Text := '339';
edtStationNumber.Text := '552';
edtSource.Text := 'C';
edtDateOfReceipt.Text := '200910311313';
edtExpirationDate.Text := '20101225';
edtHCPCSVersionDate.Text := '200911281025';
edtExternalLotID.Text := 'FY10-355';
edtBarCodeItemCost.Value := StrToFloat('5.99');
edtTotalCost.Value := StrToFloat('5.99');
edtSource.Text := 'C';
edtQty.Value := 1;
//edtTotalCost.Value := StrToFloat('11.98');
// btnIssueItem.Enabled := True;

end;

procedure TfrmInventoryIssue.chkExcludeClick(Sender: TObject);
begin
 if chkExclude.Checked = True then
 begin
  chkWaiver.Checked := False;
  edtExcludeWaiver.Text := 'E';
 end
  else
  edtExcludeWaiver.Text := '';

end;

procedure TfrmInventoryIssue.chkWaiverClick(Sender: TObject);
begin
 if chkWaiver.Checked = True then
 begin
  chkExclude.Checked := False;
  edtExcludeWaiver.Text := 'W';
 end
  else
  edtExcludeWaiver.Text := '';
end;


procedure TfrmInventoryIssue.edtBarcodeDataKeyPress(Sender: TObject; var Key: Char);
begin
(*             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSChangeDate.Text := '';
 edtDisplayHCPCSChangeDate.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
        edtBarCodeItemCost.Text := '';
              edtTotalCost.Text := '';
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';

if Key = #13  then
 begin
  if edtBarcodeData.Text <> '' then
      begin
             edtItemNumber.Text := piece(edtBarcodeData.Text,'|',1);
        edtItemDescription.Text := piece(edtBarcodeData.Text,'|',2);
              edtStoreroom.Text := piece(edtBarcodeData.Text,'|',3);
          edtDateOfReceipt.Text := piece(edtBarcodeData.Text,'|',4);
           edtBarCodeHCPCS.Text := piece(edtBarcodeData.Text,'|',5);
        edtHCPCSChangeDate.Text := piece(edtBarcodeData.Text,'|',6);
 edtDisplayHCPCSChangeDate.Text := DateTimeStr2StrDateTime(edtHCPCSChangeDate.Text);
                 edtVendor.Text := piece(edtBarcodeData.Text,'|',7);
          edtStationNumber.Text := piece(edtBarcodeData.Text,'|',8);
         edtContractNumber.Text := piece(edtBarcodeData.Text,'|',9);
                 edtSource.Text := piece(edtBarcodeData.Text,'|',10);
      try
       edtBarCodeItemCost.Value := StrToFloat(piece(edtBarcodeData.Text,'|',11));
      except
        on Exception : EConvertError do
        begin
         ShowMessage ('Not a valid barcode.');
        end;
       end;

          try
             edtTotalCost.Value := StrToFloat(piece(edtBarcodeData.Text,'|',11));
          except
           on Exception : EConvertError do
          ShowMessage ('Not a valid barcode.');
          end;

          edtExternalLotID.Text := piece(edtBarcodeData.Text,'|',12);
         edtExpirationDate.Text := piece(edtBarcodeData.Text,'|',13);

      btnEligibility.Enabled := true;
      edtBarcodeData.Clear;
      edtBarcodeData.Enabled := false;
      end
    else
      begin
      ShowMessage('Not a valid barcode.');
      edtBarcodeData.Clear;
      edtBarcodeData.Enabled := false;
//      btnScanBarcode.Caption := 'Scan NEW Barcode';
//      btnScanBarcode.SetFocus;
//      edtBarcodeData.SetFocus;
      end;
 end;
//      edtBarcodeData.Clear;
//      edtBarcodeData.Enabled := false;
//      btnScanBarcode.Caption := 'Scan NEW Barcode';
//      btnScanBarcode.SetFocus;
*)
end;

procedure TfrmInventoryIssue.edtEligibilityChange(Sender: TObject);
begin
 if edtEligibility.Text <> '' then btnIssueItem.Enabled := True;
 btnEligibility.Caption := 'Change Patient Category';
end;

procedure TfrmInventoryIssue.edtHCPCSVersionDateChange(Sender: TObject);
begin
// edtDisplayHCPCSChangeDate.Text := DateTimeStr2StrDateTime (edtHCPCSChangeDate.Text);
end;

procedure TfrmInventoryIssue.edtLotNumberKeyPress(Sender: TObject;
  var Key: Char);
begin
if Key = '^' then Key := #0;

//For lot number, the length must between 1 and 20 characters and cannot contain an ^.
end;

procedure TfrmInventoryIssue.edtQtyChange(Sender: TObject);
begin
edtTotalCost.Value :=  (edtQty.Value * edtBarCodeItemCost.Value);
end;

procedure TfrmInventoryIssue.edtQtyClick(Sender: TObject);
begin
edtQty.SelectAll;
end;

procedure TfrmInventoryIssue.edtQtyEnter(Sender: TObject);
begin
edtQty.SelectAll;
end;

procedure TfrmInventoryIssue.edtQtyExit(Sender: TObject);
begin
if edtQty.Value < 1 then
  begin
   Showmessage('Please enter a quantity of 1 or more.');
   edtQty.Value := 1;
   edtQty.SetFocus;
  end;

if edtQty.Value > 1000 then
  begin
   Showmessage('Please enter a quantity of 1000 or less.');
   edtQty.Value := 1;
   edtQty.SetFocus;
  end;
end;

procedure TfrmInventoryIssue.edtSerialNumberExit(Sender: TObject);
begin
 if LeftStr(edtSerialNumber.Text,1) = '-' then
  begin
    ShowMessage('The FIRST character must not be the '' - '' ');
    edtSerialNumber.SetFocus;
  end;
 
end;

procedure TfrmInventoryIssue.edtSerialNumberKeyPress(Sender: TObject;
  var Key: Char);
var
 s : string;
begin
  begin
   if (Key = '-') and (edtSerialNumber.SelStart = 0) then  Key := #0;
  end;
if (Key = '"') or (Key = '^') then Key := #0;

//For serial # the length must be between 1 and 20 characters in length and cannot  begin with   or  contain  or an ^.
end;

procedure TfrmInventoryIssue.FormActivate(Sender: TObject);
var
 i : integer;
begin
  frmInventoryIssueScanBarcode.Hide; // hides it so as not to confuse
  frmInventoryIssueScanBarcode.Close;  //but, does not close until Isssue closes

 with grdPatientCategory do
  begin
    Cells[0,0] := 'Category';
    Cells[1,0] := 'Code';
  end;

 with grdMiniDis do       // Grid header
  begin
      Cells[0,0] := 'Disability';
      Cells[1,0] := ' %';
      Cells[2,0] := 'SC';
 end;

begin
   TRY
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR DIS LIST';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


 grdMiniDis.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do  //Tab 4
   begin
    with grdMiniDis do
      begin
         Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//Disab
         Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//% Disab
         Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);// SC YES/NO

      end; // with do
    end;
   Except
  end;//Try
 end;
end;

procedure TfrmInventoryIssue.FormClose(Sender: TObject; var Action: TCloseAction);
begin
release;
end;

procedure TfrmInventoryIssue.grdPatientCategoryDblClick(Sender: TObject);
begin
   edtEligibility.text := grdPatientCategory.cells[1,grdPatientCategory.Row];
   edtEligibilityDisplay.Text := grdPatientCategory.Cells[0,grdPatientCategory.row];
   grdPatientCategory.Visible := False;
end;

procedure TfrmInventoryIssue.grdPatientCategoryKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = char(VK_RETURN) then
  begin
   edtEligibility.text := grdPatientCategory.cells[1,grdPatientCategory.Row];
   edtEligibilityDisplay.Text  := grdPatientCategory.Cells[0,grdPatientCategory.row];
   grdPatientCategory.Visible := False;
  end;

 if Key = char(VK_Escape) then
  begin
   grdPatientCategory.Visible := False;
   btnEligibility.SetFocus;
  end;
end;

procedure TfrmInventoryIssue.grdPatientCategoryMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   edtEligibility.text := grdPatientCategory.cells[1,grdPatientCategory.Row];
   edtEligibilityDisplay.Text := grdPatientCategory.Cells[0,grdPatientCategory.row];
   grdPatientCategory.Visible := False;
end;

procedure TfrmInventoryIssue.rgrpEligibilityClick(Sender: TObject);
begin
edtEligibility.Text
  := rgrpEligibility.FMInternalCodes.Strings[rgrpEligibility.ItemIndex];
end;

procedure TfrmInventoryIssue.rgrpTypeOfTransactionClick(Sender: TObject);
begin
 edtTypeOfTransaction.Text
  := rgrpTypeOfTransaction.FMInternalCodes.Strings[rgrpTypeOfTransaction.ItemIndex];
end;

end.
