unit uPROS_InventoryIssueCloseSuspense;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RpcConf1, Trpcb, MFunStr, StdCtrls, Buttons,
  VA508AccessibilityManager;

type
  TfrmInventoryIssueCloseSuspense = class(TForm)
    chkPostComplete: TCheckBox;
    chkPostInitial: TCheckBox;
    chkPostOther: TCheckBox;
    memPostNoteToCPRS: TMemo;
    memSendMulti: TMemo;
    lblPostCompleteNotice: TLabel;
    btnPostNote: TBitBtn;
    edtInvIssueIEN666: TEdit;
    edtSenderWindow: TEdit;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure chkPostCompleteClick(Sender: TObject);
    procedure chkPostInitialClick(Sender: TObject);
    procedure chkPostOtherClick(Sender: TObject);
    procedure btnPostNoteClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInventoryIssueCloseSuspense: TfrmInventoryIssueCloseSuspense;
  Status, StatusFlag :string;


implementation

uses PROS_POC_PurOrderConsult, uPROS_InventoryIssue, Pros_Menu,
  uPROS_POC_SuspenseProcessingSingle;

{$R *.dfm}

procedure TfrmInventoryIssueCloseSuspense.btnPostNoteClick(Sender: TObject);
var
  s : string;
  Mult1: TMult;
  i : integer;
begin
  begin
   StatusFlag := '';
   memSendMulti.Lines.Clear;
   if chkPostComplete.Checked = True then StatusFlag := '1';
   if chkPostComplete.Checked = True then Status := 'CLOSED';
   if chkPostInitial.Checked = True then StatusFlag := '0';
   if chkPostInitial.Checked = True then Status := 'PENDING';
   if chkPostOther.Checked = True then StatusFlag := '2';
   if chkPostOther.Checked = True then Status := ''; //Post other text should be null - no change
  end;

  if StatusFlag = '' then
      begin
       MessageDlg('Please select the TYPE of posting for this NOTE',mtInformation, [mbOk],0);

      end
  else

 if memPostNoteToCPRS.Lines.Count < 1 then
       MessageDlg('Please enter the NOTE to be posted', mtInformation,[mbOk], 0)
  else

     begin
         for i:=0 to memPostNoteToCPRS.Lines.Count -1 do
         begin
          memSendMulti.Lines.Add(memPostNoteToCPRS.Lines[i]);
         end;
         memSendMulti.Lines.Insert(0,'Inventory Item Issued'); //Insert Note

  // Send

        frmMenu.brkrRPC.RemoteProcedure := 'RMPR INV SUSPENSE ACTIONS';
        frmMenu.brkrRPC.Param[1].Value := IEN668;    //Selected Consult IENs
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := StatusFlag;
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := edtInvIssueIEN666.Text;// IEN 666
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Mult.Assign (memSendMulti.Lines);    //
        frmMenu.brkrRPC.Param[4].PType := list;
        frmMenu.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       ShowMessage(E.Message);
     else
       raise;
     end;




        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
                    MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);

        if  Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then
         begin
          ShowMessage(Piece(frmMenu.brkrRPC.Results[0],'^',2));
          close;
         end;

    end;

end;

procedure TfrmInventoryIssueCloseSuspense.chkPostCompleteClick(Sender: TObject);
begin
  if chkPostComplete.Checked = True then
     begin
       chkPostInitial.Checked := False;
       chkPostOther.Checked := False;
       lblPostCompleteNotice.Visible := True;
       memPostNoteToCPRS.SetFocus;
     end
     else
       lblPostCompleteNotice.Visible := False;

end;

procedure TfrmInventoryIssueCloseSuspense.chkPostInitialClick(Sender: TObject);
begin
  if chkPostInitial.Checked = True then
     begin
       chkPostComplete.Checked := False;
       chkPostOther.Checked := False;
       memPostNoteToCPRS.SetFocus;
     end;

end;

procedure TfrmInventoryIssueCloseSuspense.chkPostOtherClick(Sender: TObject);
begin
  if chkPostOther.Checked = True then
     begin
       chkPostComplete.Checked := False;
       chkPostInitial.Checked := False;
       memPostNoteToCPRS.SetFocus;
     end;
end;

procedure TfrmInventoryIssueCloseSuspense.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
RowToFind : integer;
begin
 if edtSenderWindow.Text = 'SuspenseProcessing' then
  begin
   RowToFind := frmSuspenseProcessing.grdConsult.FindRow(13,IEN668);

   if StatusFlag <> '2' then //if 2 then it was Post Other Note & no change to Status
     frmSuspenseProcessing.grdConsult.Cells[11,RowToFind] := Status;
   frmSuspenseProcessing.grdConsult.Cells[0,RowToFind] := 'Yes';
  end;

 if edtSenderWindow.Text = 'SuspenseProcessingSingle' then
  begin
   RowToFind := frmSuspenseProcessingSingle.grdSuspenseProcessingSingle.FindRow(13,sglIEN668);

   if StatusFlag <> '2' then //if 2 then it was Post Other Note & no change to Status
     frmSuspenseProcessingSingle.grdSuspenseProcessingSingle.Cells[11,RowToFind] := Status;
   frmSuspenseProcessingSingle.grdSuspenseProcessingSingle.Cells[0,RowToFind] := 'Yes';
  end;

release;
end;

end.
