unit PROS_POC_ESignature;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Trpcb, MFunStr, ComCtrls, Fmcmpnts, Diaccess,
  Printers, ExtCtrls, Fmcntrls;

type
  TfrmESignature = class(TForm)
    edtESignature: TEdit;
    btnSendPO: TBitBtn;
    lblElectronicSignature: TLabel;
    btnPurOrderPrint: TSpeedButton;
    memPurOrderPrint: TRichEdit;
    lblSelectPrintLocation: TLabel;
    lblCurrentPrintLocation: TLabel;
    edtSelectedPrinter: TFMEdit;
    pnlESignature: TPanel;
    dbLister3_5: TFMLister;
    dlgPurOrderPrinter: TPrintDialog;
    grpPrintLocation: TGroupBox;
    lblWindowsPrinter: TLabel;
    btnWindowsPrinter: TBitBtn;
    lblVistaPrinter: TLabel;
    cbxSelVistaPrinter: TFMComboBoxLookUp;
    lblWindowsOrVista: TLabel;
    btnDefaultPrinter: TBitBtn;
    edtSelVistaPrinterIEN: TFMEdit;
    dbGets3_5: TFMGets;
    procedure btnSendPOClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnPurOrderPrintClick(Sender: TObject);
    procedure btnDefaultPrinterClick(Sender: TObject);
    procedure btnWindowsPrinterClick(Sender: TObject);
    procedure dlgPurOrderPrinterClose(Sender: TObject);
    procedure cbxSelVistaPrinterSelect(Sender: TObject);
    procedure cbxSelVistaPrinterEnter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmESignature: TfrmESignature;

implementation

uses PROS_POC_PurOrderConsult, PROS_POC_PurOrder, Pros_Menu;

{$R *.dfm}

procedure TfrmESignature.btnSendPOClick(Sender: TObject);
var
i : integer;
//s : string;
CMaskTemp : String[15];
begin
    If Copy(CompletionMask,4,1) = '1' then
      Close  //Stops duplicate filing error due to Windows (fax?) driver errors
    else
     begin
     frmPurOrder.btnEditDelete.Enabled := False;  //Prevent changing
     frmPurOrder.btnAddItems.Enabled := False;    //Prevent Changing

    if IEN664 = '' then
      begin
       frmPurOrder.btnCreateFile664.Click;   // Send to Vista
      end;

 begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR SEND PURCHASE ORDER';
    frmMenu.brkrRPC.Param[1].Value := edtESignature.Text;//Signature
    frmMenu.brkrRPC.Param[1].PType := literal;
    frmMenu.brkrRPC.Param[2].Value := Piece(IEN664,',',1);// IEN 664
    frmMenu.brkrRPC.Param[2].PType := literal;
    frmMenu.brkrRPC.Param[3].Value := SiteIEN;//Site IEN
    frmMenu.brkrRPC.Param[3].PType := literal;
    frmMenu.brkrRPC.Param[4].Value := PrinterIEN; //Printer Selection
    frmMenu.brkrRPC.Param[4].PType := literal;
//    frmMenu.brkrRPC.RPCTimeLimit := 60;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
     end;


  if (Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0') then //ESig Result OK
    begin

        frmPurOrder.btnCloseSuspense.Enabled := True; //Allow close suspense

        frmPurOrder.btnSelDueDate.Enabled := False;     //Prevent anything else
        frmPurOrder.imgSelDueDate.Visible := False;

        frmPurOrder.btnSelSite.Enabled := False;
        frmPurOrder.imgSelSite.Visible := False;

        frmPurOrder.btnSelPurchaseCard.Enabled := False;
        frmPurOrder.imgSelPurchaseCard.Visible := False;

        frmPurOrder.btnSelVendor.Enabled := False;
        frmPurOrder.imgSelVendor.Visible := False;

        frmPurOrder.btnSelDelivery.Enabled := False;
        frmPurOrder.imgSelDelivery.Visible := False;

        frmPurOrder.btnAddItems.Enabled := False;
        frmPurOrder.imgAddItems.Visible := False;

        frmPurOrder.btnEditDelete.Enabled := False;

        frmPurOrder.btnShipping.Enabled := False;
        frmPurOrder.imgShipping.Enabled := False;

        frmPurOrder.btnSubmitOrder.Enabled := False;
        frmPurOrder.imgSubmitOrder.Visible := False;

        frmPurOrder.btnQuitWork.Enabled := False;

       begin
        CMaskTemp := '';
        CMaskTemp := CompletionMask;
        Delete (CMaskTemp,4,1);
        Insert('1',CMaskTemp,4); //PO and Esig Completed
        CompletionMask := CMaskTemp;
        CMaskTemp := '';
       end;

        frmPurOrderConsult.grdConsult.Cells[0,RowID] := 'Yes'; //Update DONE in grid
        frmPurOrderConsult.grdConsult.Cells[8,RowID] := ''; //Update STATUS in grid


        ShowMessage('Congratulations! Your order has been completed.'+#13+
                '           Current Status : '+Piece(frmMenu.brkrRPC.Results[0],'^',2));//+#13+
           //     'Your ??? Number is: '+Piece(frmMenu.brkrRPC.Results[0],'^',3));

      if PrinterIEN = 'WINDOWS' then
       begin
         frmMenu.brkrRPC.RemoteProcedure := 'RMPR PC PO PRINT';
         frmMenu.brkrRPC.Param[1].Value := Piece(IEN664,',',1);// IEN 664
         frmMenu.brkrRPC.Param[1].PType := literal;
         frmMenu.brkrRPC.Param[2].Value := SiteIEN;//Site IEN
         frmMenu.brkrRPC.Param[2].PType := literal;
         frmMenu.brkrRPC.Param[3].Value := PrinterIEN; //Printer Selection
         frmMenu.brkrRPC.Param[3].PType := literal;

          Try
          //
           frmMenu.brkrRPC.Call;

          except
           on E:EBrokerError do
           begin
            Showmessage('Broker Error: '+ E.Message);
           end;
           on E:EAccessViolation do
           Showmessage('E.Message');
          else
           raise;
          end;

         memPurOrderPrint.Lines.Clear;

         for i := 0 to frmMenu.brkrRPC.Results.Count -1 do
          begin
           memPurOrderPrint.Lines.Add (frmMenu.brkrRPC.Results[i]);
          end;

         btnPurOrderPrint.Click;

       end;//Windows printing

      Close;
     end      //PO sent OK

   else //ESig not ok

   if (Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1') then //ESig Result NOT ok
     begin
        begin
         CMaskTemp := '';
         CMaskTemp := CompletionMask;
         Delete (CMaskTemp,4,1);
         Insert('0',CMaskTemp,4); //PO and Esig NOT completed
         CompletionMask := CMaskTemp;
         CMaskTemp := '';
        end;

        frmPurOrder.btnCloseSuspense.Enabled := False;
        edtESignature.Text := '';
        ShowMessage ('AN ERROR HAS OCCURED.'+#13+Piece(frmMenu.brkrRPC.Results[0],'^',2));
        edtESignature.SetFocus;  //Return for next try
     end;

   end;  //ESig RESULTS check
 end; // Check for prior filing
end;


procedure TfrmESignature.FormActivate(Sender: TObject);
begin
   Application.HelpFile := 'PROS_POC_HELPFILE.CHM'; //Needed here

   frmPurOrder.btnSelDueDate.Enabled := False;  //Prevent changing
   frmPurOrder.btnAddItems.Enabled := False;
   frmPurOrder.btnEditDelete.Enabled := False;
   frmPurOrder.btnSelDelivery.Enabled := False;
   frmPurOrder.btnShipping.Enabled := False;

   edtSelectedPrinter.Text := 'Default VistA Printer';
   frmESignature.SetFocusedControl(edtESignature);
end;

procedure TfrmESignature.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    If Copy(CompletionMask,4,1) = '0' then //Not Ok to close
     begin
      frmPurOrder.btnSelDueDate.Enabled := True;  //Reset
      frmPurOrder.btnAddItems.Enabled := True;
      frmPurOrder.btnEditDelete.Enabled := True;
      frmPurOrder.btnSelDelivery.Enabled := True;
      frmPurOrder.btnShipping.Enabled := True;
     end;

Release;
end;

procedure TfrmESignature.btnPurOrderPrintClick(Sender: TObject);
//var
// s : string;
begin
 begin
  // The parameter string sets name to show in the print queue under "Document name".
  memPurOrderPrint.Print('P.O. - '+frmPurOrder.edtPONumber.Text);
 end;
end;

procedure TfrmESignature.btnDefaultPrinterClick(Sender: TObject);
begin
cbxSelVistaPrinter.ClearSelection;
edtSelVistaPrinterIEN.Text := '0';
PrinterIEN := '0';
edtSelectedPrinter.Text := 'Default VistA Printer';
end;

procedure TfrmESignature.btnWindowsPrinterClick(Sender: TObject);
var
 i : integer;
begin
cbxSelVistaPrinter.ClearSelection;
dlgPurOrderPrinter.Execute;

begin
// i := -2;
 i := Printer.PrinterIndex;
  begin
   if(i > -2)then
    begin
     edtSelectedPrinter.Text := Printer.Printers.Strings[i];
     PrinterIEN := 'WINDOWS'; // Tells RPC to send back PO for Win print
    end
   else
    begin
     edtSelectedPrinter.Text := '';
    end;
 end;
end;

end;

procedure TfrmESignature.dlgPurOrderPrinterClose(Sender: TObject);
var
 i : integer;
begin
// i := -2;
 i := Printer.PrinterIndex;
  begin
   if(i > -2)then
    begin
     edtSelectedPrinter.Text := Printer.Printers.Strings[i];
    end
   else
    begin
     edtSelectedPrinter.Text := '';
    end;
 end;
end;

procedure TfrmESignature.cbxSelVistaPrinterSelect(Sender: TObject);
begin
if cbxSelVistaPrinter.GetSelectedRecord.IEN <> ''  then
 begin
  PrinterIEN := cbxSelVistaPrinter.GetSelectedRecord.IEN;
  edtSelectedPrinter.Text := cbxSelVistaPrinter.Text;
 end;
end;

procedure TfrmESignature.cbxSelVistaPrinterEnter(Sender: TObject);
begin
dbLister3_5.Screen :='S J=$S($G(^(90))''="":+^(90),1:DT+5),RMPRTYP=$G(^("SUBTYPE")) I J>DT I $E($G(^%ZIS(2,+RMPRTYP,0)))="P"';
cbxSelVistaPrinter.Perform(CB_SETDROPPEDWIDTH, 200, 0);
end;

procedure TfrmESignature.FormCreate(Sender: TObject);
begin
   if frmMenu.Is508Active then    //if registry entry is 1 then change colors
   begin
    frmESignature.Brush.Color := clBtnFace;
    frmESignature.Font.Color := clBlack;
    lblCurrentPrintLocation.Font.Color := clBlack;
    lblSelectPrintLocation.Font.Color := clBlack;
    lblWindowsPrinter.Font.Color := clBlack;
    lblWindowsOrVista.Font.Color := clBlack;
    lblVistaPrinter.Font.Color := clBlack;
    lblElectronicSignature.Font.Color := clBlack;
   end;
 end;

end.
