unit uPROS_CreateAutoAdaptive;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Fmcntrls, ComCtrls, ESBDates,
  Trpcb, MFunStr, Diaccess, Fmcmpnts, Grids, ExtCtrls, VA508AccessibilityManager;

type
  TfrmCreateAutoAdaptive = class(TForm)
    calSelSuspenseDate: TDateTimePicker;
    edtSuspenseDate: TEdit;
    edtSiteIEN: TEdit;
    edtRequesterIEN: TEdit;
    memCreateAutoAdaptive: TMemo;
    btnCreateAutoAdaptive: TBitBtn;
    btnCancel: TBitBtn;
    edtRequesterSearchString: TEdit;
    grdSelectUser: TStringGrid;
    edtSiteSearchString: TEdit;
    grdSelectSite: TStringGrid;
    btnClearList: TBitBtn;
    edtAutoAdaptivePtIEN: TEdit;
    edtSenderWindow: TEdit;
    Panel1: TPanel;
    pnlPatientNameSSN: TPanel;
    Label3: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    rgpUrgency: TFMRadioGroup;
    edtUrgency: TEdit;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    VA508ComponentAccessibility1: TVA508ComponentAccessibility;
    VA508ComponentAccessibility2: TVA508ComponentAccessibility;
    procedure btnCreateAutoAdaptiveClick(Sender: TObject);
    procedure calSelSuspenseDateCloseUp(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure edtRequesterSearchStringKeyPress(Sender: TObject; var Key: Char);
    procedure edtSiteSearchStringKeyPress(Sender: TObject; var Key: Char);
    procedure grdSelectUserClick(Sender: TObject);
    procedure grdSelectUserDblClick(Sender: TObject);
    procedure grdSelectUserKeyPress(Sender: TObject; var Key: Char);
    procedure btnClearListClick(Sender: TObject);
    procedure grdSelectSiteClick(Sender: TObject);
    procedure grdSelectSiteDblClick(Sender: TObject);
    procedure grdSelectSiteKeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure rgpUrgencyClick(Sender: TObject);
  private
    { Private declarations }
    procedure UserSearch;
    procedure SiteSearch;
    procedure CreateAutoAdaptive;
  public
    { Public declarations }
  end;

var
  frmCreateAutoAdaptive: TfrmCreateAutoAdaptive;


implementation
uses
PROS_Menu
,uPROS_POC_SuspenseProcessingSingle
,PROS_POC_PurOrderConsult;

{$R *.dfm}

procedure TfrmCreateAutoAdaptive.UserSearch;
var
 i : integer;
begin
 if length(edtRequesterSearchString.Text) > 1 then
  begin
 // btnClearList.Click;

  frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  frmMenu.brkrRPC.RemoteProcedure := 'RMPR USER LOOKUP';
  frmMenu.brkrRPC.Param[0].Value := edtRequesterSearchString.Text;
  frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

    if frmMenu.brkrRPC.Results.Count > 0 then
        grdSelectUser.RowCount := frmMenu.brkrRPC.Results.Count +1;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1  do  //Tab 4


    with grdSelectUser do
    begin
      Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);
      Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);
    end;
    grdSelectUser.Visible := True;
    grdSelectUser.SetFocus;
    edtRequesterIEN.text := grdSelectUser.cells[1,grdSelectUser.Row];  //Sets first DFN
   end
  else
   ShowMessage('Please enter at least 2 characters.');
end;

procedure TfrmCreateAutoAdaptive.SiteSearch;
var
 i : integer;
begin
 if length(edtSiteSearchString.Text) > -1 then
  begin
//  btnClearList.Click;

  frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  frmMenu.brkrRPC.RemoteProcedure := 'RMPR SITE PARAMETER LOOKUP';
  frmMenu.brkrRPC.Param[0].Value := edtSiteSearchString.Text;
  frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

    if frmMenu.brkrRPC.Results.Count > 0 then
        grdSelectSite.RowCount := frmMenu.brkrRPC.Results.Count +1;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1  do  //Tab 4


    with grdSelectSite do
    begin
      Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2); //Site Name
      Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3); //Site Number
      Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1); //IEN 669.9
      Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4); //IEN 4
    end;
    grdSelectSite.Visible := True;
    grdSelectSite.SetFocus;
    edtSiteIEN.text := grdSelectSite.cells[3,grdSelectSite.Row];  //Sets first DFN
   end
  else
   ShowMessage('Please enter at least 2 characters.');
end;


procedure TfrmCreateAutoAdaptive.calSelSuspenseDateCloseUp(Sender: TObject);
begin
 if (DaysApart(Now,calSelSuspenseDate.Date)) > 0 then
  begin
   edtSuspenseDate.Text := '';
   ShowMessage('Please select TODAY''S date or a date in the past');
   calSelSuspenseDate.Date := Now;
   calSelSuspenseDate.SetFocus;
   end
 else
 begin
  edtSuspenseDate.Text := DateToStr(calSelSuspenseDate.Date);
 end;
end;

procedure tfrmCreateAutoAdaptive.CreateAutoAdaptive;
begin
        frmMenu.brkrRPC.RemoteProcedure := 'RMPR CREATE MANUAL';
        frmMenu.brkrRPC.Param[1].Value := edtSuspenseDate.Text;    //Selected Consult IENs
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := edtSiteIEN.text;  //P.A.'s DUZ
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := edtRequesterIEN.text;
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Value := edtAutoAdaptivePtIEN.Text;
        frmMenu.brkrRPC.Param[4].PType := literal;
        frmMenu.brkrRPC.Param[5].Value := '8'; //Type of request 8 = Auto Adaptive Non CPRS
        frmMenu.brkrRPC.Param[5].PType := literal;
        frmMenu.brkrRPC.Param[6].Value := edtUrgency.text;
        frmMenu.brkrRPC.Param[6].PType := literal;
        frmMenu.brkrRPC.Param[7].Mult.Assign (memCreateAutoAdaptive.Lines);    //
        frmMenu.brkrRPC.Param[7].PType := list;
        frmMenu.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       ShowMessage(E.Message);
     else
       raise;
     end;


        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
           MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);

        if  Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then
         begin
          ShowMessage(Piece(frmMenu.brkrRPC.Results[0],'^',2));
          Close;
 end;
end;


procedure TfrmCreateAutoAdaptive.edtRequesterSearchStringKeyPress(
  Sender: TObject; var Key: Char);
begin
 if Key = char(VK_RETURN)
    then UserSearch;
end;

procedure TfrmCreateAutoAdaptive.edtSiteSearchStringKeyPress(Sender: TObject;
  var Key: Char);
begin
 if Key = char(VK_RETURN)
    then SiteSearch;
end;

procedure TfrmCreateAutoAdaptive.FormActivate(Sender: TObject);
begin
    if edtSenderWindow.Text = 'SuspenseProcessingSingle' then
      pnlPatientNameSSN.Caption := SglPatName +'  '+SglPatSSN
     else
    pnlPatientNameSSN.Caption := PatName +'  '+PatSSN; //From Consult grid

end;

procedure TfrmCreateAutoAdaptive.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// frmSuspenseProcessingSingle.btnDisplay.Click; //refreshes the grid
 release;
end;

procedure TfrmCreateAutoAdaptive.FormCreate(Sender: TObject);
var
  l: DWORD;
begin
   btnCreateAutoAdaptive.Caption := 'Create'+#13#10+'&Auto Adaptive';
  begin
   l := GetWindowLong(Self.Handle, GWL_STYLE); //Hide Min Max btns
   l := l and not (WS_MINIMIZEBOX);
   l := l and not (WS_MAXIMIZEBOX);
   l := SetWindowLong(Self.Handle, GWL_STYLE, l);
  end;

 calSelSuspenseDate.Date := Now;
 edtSuspenseDate.Text := DateToStr(calSelSuspenseDate.Date);
end;

procedure TfrmCreateAutoAdaptive.grdSelectSiteClick(Sender: TObject);
begin
  edtSiteIEN.text := grdSelectSite.cells[3,grdSelectSite.Row];
  edtSiteSearchString.Text := grdSelectSite.Cells[0,grdSelectSite.row];
end;

procedure TfrmCreateAutoAdaptive.grdSelectSiteDblClick(Sender: TObject);
begin
  edtSiteIEN.text := grdSelectSite.cells[3,grdSelectSite.Row];
  edtSiteSearchString.Text := grdSelectSite.Cells[0,grdSelectSite.row];
  grdSelectSite.Visible := False;
  memCreateAutoAdaptive.SetFocus;
end;

procedure TfrmCreateAutoAdaptive.grdSelectSiteKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = char(VK_RETURN) then
  begin
   edtSiteIEN.text := grdSelectSite.cells[3,grdSelectSite.Row];
   edtSiteSearchString.Text := grdSelectSite.Cells[0,grdSelectSite.row];
   grdSelectSite.Visible := False;
   memCreateAutoAdaptive.SetFocus;
  end;

  if Key = char(VK_Escape) then
  begin
   btnClearList.Click;
   grdSelectSite.Visible := False;
   edtSiteSearchString.SetFocus;
   edtSiteSearchString.SelStart := Length(edtSiteSearchString.Text); // set caret after the last character
  end;

  if Key = char(VK_Back) then
  begin
   grdSelectSite.Visible := False;
   edtSiteSearchString.SetFocus;
   edtSiteSearchString.SelStart := length(edtSiteSearchString.Text); // set caret after the last character
   edtSiteSearchString.Perform(WM_CHAR, VK_BACK, 1);
  end;
end;

procedure TfrmCreateAutoAdaptive.grdSelectUserClick(Sender: TObject);
begin
   edtRequesterIEN.text := grdSelectUser.cells[1,grdSelectUser.Row];
  edtRequesterSearchString.Text := grdSelectUser.Cells[0,grdSelectUser.row];
end;

procedure TfrmCreateAutoAdaptive.grdSelectUserDblClick(Sender: TObject);
begin
  edtRequesterIEN.text := grdSelectUser.cells[1,grdSelectUser.Row];
  edtRequesterSearchString.Text := grdSelectUser.Cells[0,grdSelectUser.row];
  grdSelectUser.Visible := False;
  edtSiteSearchString.SetFocus; //Next . . .
end;

procedure TfrmCreateAutoAdaptive.grdSelectUserKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = char(VK_RETURN) then
  begin
   edtRequesterIEN.text := grdSelectUser.cells[1,grdSelectUser.Row];
   edtRequesterSearchString.Text := grdSelectUser.Cells[0,grdSelectUser.row];
   grdSelectUser.Visible := False;
   edtSiteSearchString.SetFocus; //Next . . .
//   memCreateManual.SetFocus;
  end;

  if Key = char(VK_Escape) then
  begin
   btnClearList.Click;
   grdSelectUser.Visible := False;
   edtRequesterSearchString.SetFocus;
   edtRequesterSearchString.SelStart := Length(edtRequesterSearchString.Text); // set caret after the last character
  end;

  if Key = char(VK_Back) then
  begin
   grdSelectUser.Visible := False;
   edtRequesterSearchString.SetFocus;
   edtRequesterSearchString.SelStart := length(edtRequesterSearchString.Text); // set caret after the last character
   edtRequesterSearchString.Perform(WM_CHAR, VK_BACK, 1);
  end;
end;

procedure TfrmCreateAutoAdaptive.rgpUrgencyClick(Sender: TObject);
begin
edtUrgency.text := rgpUrgency.FMInternalCodes.Strings[rgpUrgency.ItemIndex];
end;

procedure TfrmCreateAutoAdaptive.btnClearListClick(Sender: TObject);
var
  i : integer;
begin
  begin
   for i :=1 to grdSelectUser.RowCount -1 do   //If selected will clear the grid
       grdSelectUser.Rows[i].Clear;
       grdSelectUser.Row := 1;
       grdSelectUser.Cells[0,1] :='';
  end;
  begin
   for i :=1 to grdSelectSite.RowCount -1 do   //If selected will clear the grid
       grdSelectSite.Rows[i].Clear;
       grdSelectSite.Row := 1;
       grdSelectSite.Cells[0,1] :='';
  end;
// edtRequesterIEN.text := '';
// edtSiteIEN.Text := '';
end;
procedure TfrmCreateAutoAdaptive.btnCancelClick(Sender: TObject);
begin
Close;
end;

procedure TfrmCreateAutoAdaptive.btnCreateAutoAdaptiveClick(Sender: TObject);
begin
CreateAutoAdaptive;

if edtSenderWindow.Text = 'SuspenseProcessing' then
 frmSuspenseProcessing.btnDisplay.Click; //refreshes calling grid

if edtSenderWindow.Text = 'SuspenseProcessingSingle' then
 frmSuspenseProcessingSingle.btnDisplay.Click; //refreshes calling grid

Close;
end;

end.
