unit uPROS_SelPatient;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Fmcntrls, StdCtrls, Diaccess, Fmcmpnts, Buttons, Fmlookup;

type
  TfrmSelPatient = class(TForm)
    FMListBox1: TFMListBox;
    FMComboBoxLookUp1: TFMComboBoxLookUp;
    FMLister1: TFMLister;
    FMLookUp1: TFMLookUp;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    FMEdit1: TFMEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FMListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FMComboBoxLookUp1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    FSearchStr: string; 
  public
    { Public declarations }
  end;

var
  frmSelPatient: TfrmSelPatient;

implementation
uses
PROS_Menu;

{$R *.dfm}

procedure TfrmSelPatient.BitBtn1Click(Sender: TObject);
var

  AddRecord :Boolean;

begin

FMLookUp1.AllowNew:=False; // disallow adding records

if FMLookUp1.Execute(AddRecord) then

    ShowMessage('You selected record: '+FMLookUp1.RecordNumber)

else

    ShowMessage('You did not select a record.');

end;

procedure TfrmSelPatient.BitBtn2Click(Sender: TObject);
begin
FMListBox1.GetList;
  {check associated TFMLister component for errors after server call}
  if FMListBox1.FMLister.ErrorList.Count >0 then
    FMListBox1.FMLister.DisplayErrors;
end;

procedure TfrmSelPatient.BitBtn3Click(Sender: TObject);
begin
FMListBox1.ClearSelection;
//FMListBox1.Clear;
end;

procedure TfrmSelPatient.FMComboBoxLookUp1KeyPress(Sender: TObject;
  var Key: Char);
var
   Found: boolean;
   j,SelSt: Integer;
   TmpStr: string;
begin
   { first, process the keystroke to obtain the current string }
   { This code requires all items in list to be uppercase}
   if Key in ['a'..'z'] then Dec(Key,32) ; {Force Uppercase only!}
   with (Sender as TComboBox) do
   begin
     SelSt := SelStart;
     if (Key = Chr(vk_Back)) and (SelLength <> 0) then
      TmpStr := Copy(Text,1,SelStart)+Copy(Text,SelLength+SelStart+1,255)

     else if Key = Chr(vk_Back) then {SelLength = 0}
      TmpStr := Copy(Text,1,SelStart-1)+Copy(Text,SelStart+1,255)
     else {Key in ['A'..'Z', etc]}
      TmpStr := Copy(Text,1,SelStart)+Key+Copy(Text,SelLength+SelStart+1,255) ;
     if TmpStr = '' then Exit;
     { update SelSt to the current insertion point }

     if (Key = Chr(vk_Back)) and (SelSt > 0) then Dec(SelSt)

     else if Key <> Chr(vk_Back) then Inc(SelSt) ;
     Key := #0; { indicate that key was handled }
     if SelSt = 0 then
     begin
       Text:= '';
       Exit;
     end;

    {Now that TmpStr is the currently typed
     string, see if we can locate a match }

     Found := False;
     for j := 1 to Items.Count do
       if Copy(Items[j-1],1,Length(TmpStr)) = TmpStr then
       begin
         Text := Items[j-1]; { update to the match that was found }
         ItemIndex := j-1;
         Found := True;
         Break;
       end;
     if Found then { select the untyped end of the string }
     begin
       SelStart := SelSt;
       SelLength := Length(Text)-SelSt;
     end
     else Beep;
   end;

end;

procedure TfrmSelPatient.FMListBox1KeyPress(Sender: TObject; var Key: Char);
var
  i: Integer;
begin
  Case Key of
    #27: Begin
           // Escape key, clear search string
           FSearchStr := EmptyStr;
         End; { Case Esc }
    #8 : Begin
           // backspace, erase last key from search string
           If Length(FSearchStr) > 0 Then
             Delete( FSearchStr, Length( FSearchStr), 1 );
         End; { Case backspace }
    Else
      FSearchStr:= FSearchStr + Key;
  End; { Case }
  If Length(FSearchStr) > 0 then
    if Sender is TListbox then Begin
      i:= SendMessage( TListbox(Sender).handle, LB_FINDSTRING,
                       TListbox(Sender).ItemIndex, longint(@FSearchStr[1]));
      If i <> LB_ERR Then
        TListbox(Sender).ItemIndex := i;
    end
    else
      if Sender is TCombobox then begin
        i:= SendMessage( TCombobox(Sender).handle, CB_FINDSTRING,
                         TCombobox(Sender).ItemIndex, longint(@FSearchStr[1]));
        If i <> LB_ERR Then
          TCombobox(Sender).ItemIndex := i;
      end;
  Key := #0;
end;


procedure TfrmSelPatient.FormCreate(Sender: TObject);
begin
FSearchStr := '';
end;

end.
